#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "tools.h"
#ifndef MSDOS
#  define EUCJMODE
#  define SS2 0x8e
#  define iskanji(c) ((c) & 0x80) /* ꉞ */
#endif
#ifdef EUCJMODE
#  define KSPC1 0xa1
#  define KSPC2 0xa1
#else
#  define KSPC1 0x81
#  define KSPC2 0x40
#endif

char	*cmdname = "fold";

static	us_int	width = 80;
#define NOFOLD	(~0) /* foldȂꍇwidthɓĂ */
static	us_int	pos = 0;
 /* widthNOFOLD̏ꍇAKposwidthƂȂ̂ŒposƔrĂOK
    ̏ꍇposintĂxȂ */

static	struct	{
	char	curstat, prevcr;
	bool	prevalph;
} lconn; /* initially all 0 */
#define NO_LCONN	0 /* -lIvVȂ0ɂĂ */
#define LCONN_NORM	1 /* -lIvVAʏ */
#define LCONN_CRLF	2 /* -lIvVACRLF̒ */
#define	LCONN_AFTCRSP	3 /* -lIvVACRLFɑ
			     t@C擪ł̏Ԃ */

 /*---- public domaingetopt()g ----------------------------*/
static	int	opterr = 1, optind = 1, optopt;
static	char	*optarg;

static	void	err_getopt(cmd, as)
char	*cmd, *as;
{
	static	char	msgtail[ ] = {0, 0};

	if(opterr){
		_puterrmes(cmd), _puterrmes(as),
		*msgtail = (char)optopt, _puterrmes_cr(msgtail);
	}
}

 /* toolslib.lɂ̂̂ɊgA"-"IvV */
static	int	egetopt(ac, av, opts)
int	ac;
char	**av, *opts;
{
	static	char	*curopt = NULL;
	register char	*cp;

	if(curopt == NULL || !*curopt){
		if(optind >= ac || *(curopt = av[optind]) != '-' || !*++curopt)
			return EOF;
		if(*curopt == '-' && !curopt[1])
			return (++optind, EOF);
	}
	if(':' == (optopt = *curopt++) || ';' == optopt ||
	   NULL == (cp = strchr(opts, optopt))){
		if(is_digit(optopt)){
		 /* "-" ̏ꍇ ɕʃIvVꍇ */
			optarg = curopt - 1;
			 /* ̔񐔎܂߂optargɓ̂Œ */
			while(is_digit(*curopt)) ++curopt;
			if(!*curopt) ++optind;
			return optopt = '0'; /* Ԃl'0' */
		}

		err_getopt(*av, ": unknown option, -");
		if(!*curopt) ++optind;
		return '?';
	}
	if(*++cp == ':' || *cp == ';' && *curopt){
		++optind;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				err_getopt(*av, ": argument missing for -");
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) ++optind;
	}
	return optopt;
}
 /*---- public domaingetopt()g ܂ -------------------*/

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-[w]width] [-l] [file...]"), exit(1);
}

static	void	outprvcr()
{
	if(lconn . curstat == LCONN_CRLF){
		putchar(lconn . prevcr);
		pos = 0, ++lconn . curstat, lconn . prevalph = 0;
	}
}
static	void	stat_normal(c)
int	c; /* cur input char */
{
	if(lconn . curstat){
		c = (is_alpha(c) ? 1 : 0);
		if(lconn . curstat == LCONN_CRLF && lconn . prevalph && c){
			if(++pos < width || width == NOFOLD) putchar(' ');
			 /* poswidth-1ȏゾꍇApos͐i߂邪ۂ
			    󔒂oȂB̏ꍇ͂̌Ac̏o͑O
			    so͂͂ */
		}

		lconn . curstat = LCONN_NORM, lconn . prevalph = (bool)c;
	}
}

static	void	fold(f)
FILE	*f;
{
	int	c, d;

	if(lconn . curstat)
		lconn . curstat = LCONN_AFTCRSP, lconn . prevalph = 0;

	for(;;){
		if(EOF == (c = getc(f))){
			outprvcr();
			break;
		} else if(is_space(c)){ /* 󔒕:\n\t\v\r\fSPC */
			outprvcr();

			cswitch(c){
			case '\n':
			case '\r':
			 /* eLXg[hOƂĂ̂"\r\n"͔l */
				if(lconn . curstat == LCONN_NORM){
					lconn . prevcr = c, ++lconn . curstat;
					continue;
				}
				 /* FALLTHROUGH */
			case '\f':
				pos = 0; break;
			case '\t':
				pos = (pos + 8) & ~7;
				if(pos > width) (putchar('\n'), pos = 8);
				break;
			case '\v':
				break;
			default: /* ' ' */
				goto normal;
			}
		} else { /*  */
			if(!iskanji(c)){ /* 񊿎 */
				stat_normal(c);
				if(c == '\b'){
					if(pos > 0) --pos;
				} else {
				normal:
					if(++pos > width)
						(putchar('\n'), pos = 1);
				}
			} else { /*  */
				d = getc(f);
				if(c == KSPC1 && d == KSPC2){
				 /* ̏ꍇ󔒕 */
					outprvcr();
				} else {
					stat_normal(c);
					if(d == EOF) goto normal;
				}

#ifdef EUCJMODE
				++pos;
				if(c != SS2) ++pos;
				if(pos > width){
					putchar('\n');
					pos = (c == SS2 ? 1 : 2);
				}
#else
				pos += 2;
				if(pos > width) (putchar('\n'), pos = 2);
#endif

				putchar(c), c = d;
			}
		}
		putchar(c);
	}
}

main(ac, av)
int	ac;
char	**av;
{
	FILE	*inf;
	char	*p;
	int	c;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while(EOF != (c = egetopt(ac, av, "w:l"))){
		cswitch(c){
		case '0': /* numeral opt */
		case 'w':
			if(0 == (width = atoi(optarg)))
				width = NOFOLD; /* max unsigned int */
			break;
		case 'l':
			lconn . curstat = LCONN_NORM;
			break;
		default:
			usage();
		}
	}
	av += optind, ac -= optind;

	if(!ac){
		fold(stdin);
	} else {
		for(; ac; --ac, ++av){
			if(*(p = *av) == '-' && !p[1]){
				fold(stdin);
				clearerr(stdin);
			} else {
				if(NULL == (inf = fopen(p, "r"))){
					_puterrmes(cmdname), _puterrmes(": ");
					_puterrmes(s_conv_to_unix_format(p));
					_puterrmes_cr(": Can't open");
					exit(1);
				}
				fold(inf);
				fclose(inf);
			}
		}
	}
	return 0;
}
