#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <memory.h>

#ifndef MSDOS
#  define USE_AOPT
#endif
 /* DOS̏ꍇASfł̊Ĵ߁A傫Ȃ߂Ȃ悤{@\Ȃ */

#ifdef TOOLS
     /* UNIX-like tools1ƂăRpCEzzꍇ͂define
	APƂŃRpCꍇdefineȂ */
#  include "tools.h"
#else /* TOOLS */
#  include <malloc.h>
typedef unsigned char	us_char;
typedef unsigned short	us_short;
typedef unsigned int	us_int;
typedef unsigned long	us_long;
typedef us_char	bool;
#  define cswitch switch
#  define setfbuf(f, b, n) setvbuf((f), (b), _IOFBF, (n))
#  define stricmp strcasecmp
#  define strnicmp strncasecmp
#  define is_space(c) (isascii(c) && isspace(c))
#  define is_upper(c) (isascii(c) && isupper(c))
#  define is_cntrl(c) (isascii(c) && iscntrl(c))
#  define is_digit(c) (isascii(c) && isdigit(c))
#  define is_print(c) (isascii(c) && isprint(c))
#  define is_graph(c) (isascii(c) && isgraph(c))
#  define to_lower(c) (is_upper(c) ? tolower(c) : (c))
#  define fsetbin(f) 0
#  define s_conv_to_unix_format(s) (s)
#  define setcmdname(av0)		\
	do{				\
		if(NULL != (cmdname = strrchr(av0, '/'))) cmdname++; \
		 else cmdname = av0;	\
	} while(0)
#  define _puterrmes(s) fputs((s), stderr)
#  define _puterrmes_cr(s) (_puterrmes(s), putc('\n', stderr))
#  define _putnomemmes() _puterrmes("Memory exhausted\n")
#  define NULSTR ""
#endif /* TOOLS */

char	*cmdname = "od";

#define DMPOUTF stdout
#define DMPINF stdin

#define SS2 0x8e
#define SS3 0x8f
#define iskana(c) \
	(0xa1 <= (c) && (c) <= 0xdf)
 /* iseucj()͈̔͂Ɋ܂܂B̂ƂgĂ */
#define ismsknj1(c) \
	(0x81 <= (c) && ((c) <= 0x9f || 0xe0 <= (c) && (c) <= 0xfc))
#define ismsknj2(c) \
	(0x40 <= (c) && (c) <= 0xfc && 0x7f != (c))
#define iseucj(c) \
	(0xa1 <= (c) && (c) <= 0xfe)
#define isSS2(c) \
	(SS2 == (c))
#define isSS3(c) \
	(SS3 == (c)) /* SS3Ή͌v撆 */

typedef	us_short us_word;	/* 2bytes */
typedef	signed short	s_word;	/* 2bytes */
typedef	us_long	us_dword;	/* 4bytes */
typedef	float	fdword;		/* 4bytes */
typedef	double	ldword;		/* 8bytes */

#define BITpBYT 8

#define OBUFSIZ 1024
#define BIGBUFSIZ 8192
#define SMALLMEM 8

#define KMODE_EUCJ	0
#define KMODE_MSK	1
#define KMODE_ASCII	2

#define STRINGSNULT	0	/* strings̏o͂nullI[̂ */
#define STRINGSALL	1	/* strings̏o͂nullI[ȊO܂ */
#define STRINGSDOLLAR	2	/* strings̏o͂'$'I[܂ */

#define DEFSTRMINLEN	4

 /* AhX̕\@ */
#define OCTADDR		'o'
#define DECADDR		'u'
#define HEXADDR		'x'

#define MAXMULCHR 3 /* oCg܂ōl邩BEUCJSS3Ή͌v撆 */

static	int	ivbufsiz, ovbufsiz;
static	char	*ivbuf, *ovbuf;

static	us_int	bytelen = 16,	/* 1s_voCg */
		bytelen1,	/* Aŏ̍s */
		minsepwid = 1;	/* _v1܂𕪗󔒕 */
static	bool	alldata,	/* ȗ_vȂ */
		byte_reord,	/* endianЂԂ */
		bit_rev,	/* bitmap dump̃rbgЂԂ */
		bit_brev,	/* bitmap dump̃oCgЂԂ */
		kanji_rev,	/* ̃oCgЂԂ */
		noaddr,		/* AhX\Ȃ */
		hexmode,	/* IvVbchex dumpɂ */
		undump,		/* undump */
		nowarn,		/* No warning when undump */
		nojischk,	/* Doesn't check JIS valid characters */
		dotrunc = 0,	/* does ftruncate when undump */
		strings;	/* strings */
 /* LȊOzero initialized */

static	us_char	*byteshift[3]; /* 2bytes, 4bytes, 8bytes̊eꍇ
		ꂼ̃oCg̃VtgJEg */

typedef struct {
	void	*sbuf;
	us_int	buflen,	 /* mے */
		len,	 /* gp */
		minlen;  /* ̒ɒBΏo */
	us_char	kmode,	 /* EUCJMSR[hl邩 */
		outmode; /* strings̏o̓[h */
	us_long	startaddr;
} sbufstr;
static	sbufstr	stringsbuf = {
	NULL, 0, 0, 0, KMODE_ASCII, STRINGSNULT, 0L,
};

typedef	struct {
	void	*mainbuf;	/* _vpobt@ */
	us_int	buflen;		/* ̒ */
	us_char	krestbuf[MAXMULCHR - 1];
				/* mǂ݃obt@ */
	us_int	krestlen,	/* ǂ݃obt@gp */
		eucjvalidlen,	/* ̑ł钷(EUCJ) */
		mskvalidlen,	/* (MSR[h) */
		kstrvalidlen;	/* (stringsp) */ /* eucjvalidlenȂ
				   Ƃ͕ʂɎBdiffline()ɉe邩 */
	bool	krestdifflg,	/* tH[}bg̃_v̍
				   krestɐHႢ邩 */
		krestignmode;	/* krestƂ݂̂ŁAu**vȂꍇ
				   oCg̍ŏȊO𖳎tOB
				   sł̂ݐ^ɂȂBgpOɃZbg
				   ̂ōŏ0ɂȂĂ */
} dbufstr;

typedef struct {
	dbufstr dumpbuf[2];
	int	buf_sw;	/* ŋ߂ɓǂݍ܂ꂽ̂͂ǂ̃obt@
		       (ŏ1AǂݍޒOɔ]̂ōŏ0֓ǂ) */
	FILE	*objf;	/* _vΏۃt@C */
} bufstr;
static	bufstr	thebuf;

#define MIDBUFSIZ 32
 /* ƕ̕ϊpԃobt@̃TCYBoutinfos[i].width̍ő+1ȏA
    raddrfmt̕+1ȏKv */
static	char	intermidbuf[MIDBUFSIZ];

#define ADDRWID 7
#define EXP10ADDRWID 10000000L /* 10ADDRWID */
static	struct {
	char	addrfmt[6];	/* AhX̏ */
	char	*faddrfmt;	/* AhXfscanfɎg */
	char	raddrfmt[9];	/* sscanfɎg */
	us_long	offset, amount;	/* ǂݔ΂ʁE_v */
} plus_opt = {
	{'%', '0', '0' + ADDRWID, 'l', OCTADDR, '\0'},
	"%11[^\t\n\013\f\r :]%1[^\n]",
	  /* 8ȏɂΏBAhXオ':'Ȃ炻̍sǂݔ΂ */
	{'%', '0' + ADDRWID, 'l', OCTADDR, '%', 'c', '%', 'c', '\0'},
	0L, (us_long)~0L
};
#define	addrfmtc  addrfmt[4]	/* 'o' 'x' 'u'̂ꂩ */
#define	raddrfmtc raddrfmt[3]	/* Ɠ̂Ƃ */

typedef struct {
	us_int	optindx; /* w肳ꂽIvVoutwidthindex */
	us_int	sepwidth, sepwidth1; /* 1܂蓯m̊Ԃ̊ԊuB
				sepwidth1͍ŏ̕ŁAsepwidthȉ̂͂ */
} modestr;
static	struct {
	modestr	*optlist; /* w肳ꂽIvV̗(outwidthindex) */
	us_int	optcount; /* ̌ */
} modeopt = {
	NULL, 0
};

typedef	struct {
	char	optc;	/* IvV̕ */
	us_char	bytes,	/* oCgƂ̃_v? */
		width,	/* _v1܂̕ */
		mulchr; /* oCg܂ōl?(1) */
	bool	isreal; /* ǂBNaNInfKv */
#ifndef LSI_C
	unsigned hexmode_adv : 4, /* zIvVL̏ꍇindex */
		 bytecnv_adv : 4; /* eIvVL̏ꍇindex */
#else /* ӊO! LSI_C̓rbgtB[h𗝉Ȃ */
	char	hexmode_adv,
		bytecnv_adv;
#endif
	void	(*ofunc)(); /* o͗p֐ */
	us_int	(*ifunc)(); /* undumpǂݍݗp֐ */
	char	**fmtls;	/* o͊֐p̃tH[}bg̔z */
	char	**rfmt;		/* tϊptH[}bg */
} outinfostr;

#ifndef MSDOS
 /*---- toolslib.l̂ƓBPƂŃRpCł悤ɂ邽 --------- */
int	opterr = 1;
int	optind = 1;
int	optopt;
char	*optarg;

static	void	err_getopt(cmd, as)
char	*cmd, *as;
{
	static	char	msgtail[ ] = {0, 0};

	if(opterr){
		_puterrmes(cmd), _puterrmes(as),
		*msgtail = optopt, _puterrmes_cr(msgtail);
	}
}

int	egetopt(ac, av, opts)
int	ac;
char	**av, *opts;
{
	static	char	*curopt = NULL;
	register char	*cp;

	if(curopt == NULL || !*curopt){
		if(optind >= ac || *(curopt = av[optind]) != '-' || !*++curopt)
			return EOF;
		if(*curopt == '-' && !curopt[1])
			return (++optind, EOF);
	}
	if(':' == (optopt = *curopt++) || ';' == optopt ||
	   NULL == (cp = strchr(opts, optopt))){
		err_getopt(*av, ": unknown option, -");
		if(!*curopt) ++optind;
		return '?';
	}
	if(*++cp == ':' || *cp == ';' && *curopt){
		++optind;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				err_getopt(*av, ": argument missing for -");
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) ++optind;
	}
	return optopt;
}
 /*---- ܂ toolslib.l̂Ɠ -------------------------------------- */
#endif

#ifdef OLD_C
int	strncasecmp(p, q, n)
char	*p, *q;
int	n;
{
	int	c, d;

	for(;; ++p, ++q){
		if(!n) return 0;
		c = to_lower(*p) - (d = to_lower(*q));
		if(c || !d) return c;
		if(n > 0) --n;
	}
}
#  define strcasecmp(p, q) strncasecmp(p, q, -1)
#endif

typedef struct {
	us_int	lb, ub;
} ranges;

static	ranges jis_valid_range_E[ ] = {
	{0, 0}, /* ԕ */

	{0x8ea1, 0x8edf}, /* X0201Ji */

	{0xa1a1, 0xa2ae}, /* @- */
	{0xa2ba, 0xa2c1}, /* - */
	{0xa2ca, 0xa2d0}, /* - */
	{0xa2dc, 0xa2ea}, /* - */
	{0xa2f2, 0xa2f9}, /* - */

	{0xa2fe, 0xa2fe}, /* - */
	{0xa3b0, 0xa3b9}, /* O-X */
	{0xa3c1, 0xa3da}, /* `-y */
	{0xa3e1, 0xa3fa}, /* - */
	{0xa4a1, 0xa4f3}, /* - */

	{0xa5a1, 0xa5f6}, /* @- */
	{0xa6a1, 0xa6b8}, /* - */
	{0xa6c1, 0xa6d8}, /* - */
	{0xa7a1, 0xa7c1}, /* @-` */
	{0xa7d1, 0xa7f1}, /* p- */

	{0xa8a1, 0xa8c0}, /* - */
	{0xb0a1, 0xcfd3}, /* -r */
	{0xd0a1, 0xf4a6}, /* - */
}; /* JIS X0208-1990 */

static	ranges jis_valid_range_M[ ] = {
	{0, 0}, /* ԕ */

	{0x8140, 0x81ac}, /* MSCODE @- */
	{0x81b8, 0x81bf}, /* MSCODE - */
	{0x81c8, 0x81ce}, /* MSCODE - */
	{0x81da, 0x81e8}, /* MSCODE - */
	{0x81f0, 0x81f7}, /* MSCODE - */

	{0x81fc, 0x81fc}, /* MSCODE - */
	{0x824f, 0x8258}, /* MSCODE O-X */
	{0x8260, 0x8279}, /* MSCODE `-y */
	{0x8281, 0x829a}, /* MSCODE - */
	{0x829f, 0x82f1}, /* MSCODE - */

	{0x8340, 0x8396}, /* MSCODE @- */
	{0x839f, 0x83b6}, /* MSCODE - */
	{0x83bf, 0x83d6}, /* MSCODE - */
	{0x8440, 0x8460}, /* MSCODE @-` */
	{0x8470, 0x8491}, /* MSCODE p- */

	{0x849f, 0x84be}, /* MSCODE - */
	{0x889f, 0x9872}, /* MSCODE -r */
	{0x989f, 0xeaa4}, /* MSCODE - */
};

#define numberof(a) (sizeof(a) / sizeof(*(a)))

static	int	isjisvalid(c, mode)
int	c, mode;
{
	int	imin = 0;
	int	imax = (mode == KMODE_EUCJ ?
		    numberof(jis_valid_range_E) : numberof(jis_valid_range_M));
	int	imid = imax >> 1;
	ranges	*userange = (mode == KMODE_EUCJ ?
					jis_valid_range_E : jis_valid_range_M);

	do {
		(us_int)c < userange[imid]. lb ? (imax = imid) : (imin = imid);
	} while(imin != (imid = (imin + imax) >> 1));
	return (us_int)c <= userange[imid] . ub;
}

#ifdef USE_AOPT
static	char	chrnamlist[] = "del\
nulsohstxetxeotenqackbelbs\0ht\0nl\0vt\0ff\0cr\0so\0si\0\
dledc1dc2dc3dc4naksynetbcanem\0subescfs\0gs\0rs\0us\0sp";
#  define charname(c) /* int c; */ \
	(chrnamlist + 3 * ((c) == 0x7f ? 0 : (c) + 1))
#endif

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = 2;
	expand_hook_default();
}
#endif

static	void	cmd_errmsg(s)
char	*s;
{
	fprintf(stderr, "%s: %s", cmdname, s);
}

static	void	cantbuf()
{
	cmd_errmsg("Can't set I/O buffer\n"), exit(2);
}

static	void	write_err()
{
	cmd_errmsg("Write error\n"), exit(2);
}

static	void	read_err()
{
	cmd_errmsg("File read error\n"), exit(2);
}

static	void	cant_treat()
{
	cmd_errmsg("Can't treat this type of dump on this machine. Sorry.\n");
	exit(2);
}

static	void	usage()
{
#ifdef USE_AOPT
	fprintf(stderr, "Usage: %s\
 [-abBcCMdDfFhHmMoOsxXnNrvzZTqu] [-e{b|l|byteorder|r#|k}] [-w#] [-W#]\n\
\t  [-t[#adCM]] [FILE] [+[0x]offset[.][b][{+|-}[0x]amount[.][b]]]\n\
", cmdname);
#else
	fprintf(stderr, "Usage: %s\
 [-bBcCMdDfFhHmMoOsxXnNrvzZTqu] [-e{b|l|byteorder|r#|k}] [-w#] [-W#]\n\
\t  [-t[#adCM]] [FILE] [+[0x]offset[.][b][{+|-}[0x]amount[.][b]]]\n\
", cmdname);
#endif
	exit(2);
}

static	us_word	*bytecnv(s)
us_char	*s;
{
	us_char	*p = byteshift[0];
	static	us_word	buf;

	((char *)&buf)[*p] = *s, ((char *)&buf)[*++p] = *++s;
	return &buf;
}
static	us_dword *lbytecnv(s)
us_char	*s;
{
	us_char	*p = byteshift[1];
	static	us_dword buf;

	((char *)&buf)[*p] = *s;
	((char *)&buf)[*++p] = *++s;
	((char *)&buf)[*++p] = *++s;
	((char *)&buf)[*++p] = *++s;
	return &buf;
}
static	ldword *dbytecnv(s)
us_char	*s;
{
	us_char	*p = byteshift[2];
	static	ldword	buf;
	int	i;

	if(p == NULL) cant_treat();
	for(i = 8; i; --i) ((char *)&buf)[*p++] = *s++;
	return &buf;
}

static	us_int	memncmp_pos(p, q, n)
char	*p, *q;
us_int	n; /* Ă钷Ԃ */
{
	us_int	i;

	for(i = n; i; --i, ++p, ++q) if(*p != *q) break;
	return n - i;
}

static	void	bw_memcpy(p, q, n)
char	*p, *q;
int	n;
{
	for(; n; --n) *p++ = *q++;
}

static	int	f_read_amount(p, n, f) /* őplus_opt.amountoCgǂ */
void	*p;
us_int	n;
FILE	*f;
{
	us_int	r;

#ifndef LSI_C
	if(feof(f)) return 0;
#endif
	if(plus_opt . amount == (us_long)~0L) return fread(p, 1, n, f);
	if((us_long)n > plus_opt . amount) n = (us_int)plus_opt . amount;
	plus_opt . amount -= (us_long)(r = fread(p, 1, n, f));
	return r;
}

static	int	fread_nl(p, n, f)
char	*p;
us_int	n;
FILE	*f; /* noCgڂ0͒uȂ */
{
	int	c, k;

	for(k = n; n; --n, ++p){
		switch(c = getc(f)){
		case '\n':
			ungetc(c, f); goto fin;
		case EOF:
			goto fin;
		default:
			*p = (char)c; break;
		}
	}
fin:
	return k - n;
}

static	int	peekc(f)
FILE	*f;
{
	int	c;

#ifndef LSI_C
	if(feof(f)) return EOF; /* Ô */
#endif
	if(EOF != (c = getc(f))) ungetc(c, f);
	return c;
}

static	int	nonsp_getc(f) /* 󔒂ƃ^ułȂ̕AsEEOF܂ */
FILE	*f;
{
	int	c;

#ifndef LSI_C
	if(feof(f)) return EOF; /* Ô */
#endif
	for(;;) if(c = getc(f), c == '\n' || !is_space(c)) return c;
}

static	int	nonsp_peekc(f)
FILE	*f;
{
	int	c;

#ifndef LSI_C
	if(feof(f)) return EOF; /* Ô */
#endif
	if(EOF != (c = nonsp_getc(f))) ungetc(c, f);
	return c;
}

static	us_int	count_spaces(f, ub)
FILE	*f;
us_int	ub; /* 󔒂̌ԂBőubB^u͔l */
{
	int	c;
	us_int	cnt = 0;

#ifndef LSI_C
	if(feof(f)) return 0; /* Ô */
#endif
	for(; ub; --ub){
		switch(c = getc(f)){
		case EOF: goto fin;
		case ' ': cnt++; break;
		default:  ungetc(c, f); goto fin;
		}
	}
fin:
	return cnt;
}

static	void	*mymalloc(n)
us_int	n; /* [NA */
{
	void	*p;

	if(NULL == (p = calloc(n, sizeof(char)))) (_putnomemmes(), exit(2));
	 /* od exits with code 2 when error */
#ifdef DEBUG2
	fprintf(stderr, "alc %x(%d)\n", (int)p, n);
#endif
	return p;
}

static	void	*myrealloc(p, n)
void	*p;
us_int	n;
{
	if(p == NULL) return mymalloc(n); /* ̏ꍇ[NA */
#ifdef DEBUG2
	fprintf(stderr, "realc %x =>", (int)p);
#endif
	if(NULL == (p = realloc(p, n))) (_putnomemmes(), exit(2));
#ifdef DEBUG2
	fprintf(stderr, "%x(%d)\n", (int)p, n);
#endif
	return p;
}

static	int	bsmap(c)
int	c; /* G[0 */
{
	switch(c){
	case '\n':
		return 'n';
	case '\t':
		return 't';
	case '\b':
		return 'b';
	case '\r':
		return 'r';
	case '\f':
		return 'f';
#ifndef NOEXPBS
	case 0x7:
		return 'a';
	case 0xb:
		return 'v';
	case '\033':
		return 'e';
#endif
	case '\0':
		return '0';
	default:
		return '\0';
	}
}

static	int	bsrevmap(c)
int	c; /* G[EOF */
{
	switch(c){
	case 'n':
		return '\n';
	case 't':
		return '\t';
	case 'b':
		return '\b';
	case 'r':
		return '\r';
	case 'f':
		return '\f';
	case 'a':
		return 0x7;
	case 'v':
		return 0xb;
	case 'e':
		return '\033';
	case '0':
		return '\0';
	default:
		return EOF;
	}
}

 /* obt@mainbufɓǂ܂Ă閖n+1ڂǂ
    nMAXMULCHR-1ȉłȂƂȂ */
static	int	getnext(odbuf, n)
bufstr	*odbuf;
us_int	n;
{
	dbufstr	*dbufp = &(odbuf -> dumpbuf[odbuf -> buf_sw]);

	if(dbufp -> krestlen <= n){
		dbufp -> krestlen += f_read_amount(
			dbufp -> krestbuf + dbufp -> krestlen,
			n + 1 - dbufp -> krestlen, odbuf -> objf);
		if(dbufp -> krestlen <= n) return EOF;
	}
	return dbufp -> krestbuf[n];
}

static	sscanNaN(buf, s, n)
char	*buf, *s;
us_int	n;
 /* scanfNaN߂ȂVXep */
{
#define NAN01D	4.7783097267364801e-299
#define NAN01F	(float)9.4039543e-38
#define INF01D	2.3891548633682403e-299
#define INF01F	(float)4.7019774e-38
	static	double	NaN01d[ ] = {
		NAN01D, NAN01D, INF01D, INF01D,
	};
	static	float	NaN01f[ ] = {
		NAN01F, NAN01F, INF01F, INF01F,
	};
	static	char	first = 1;
	char	tmp[10] /* "-Infinity"eɏ\Ȃ */, *p;
	int	sgn = 0; /* 0: plus, 1: minus */

	if(first){
		int	i, j;
		char	*q;

		first--;
		for(i = 0; i < sizeof(NaN01d) / sizeof(*NaN01d); i++){
			for(q = (char *)&NaN01d[i], j = sizeof(*NaN01d);
			    j && *q != '\01'; ++q, --j);
			if(!j) cant_treat();
			*q = (char)((i & 1) ? 0xff : 0x7f);
		}
		for(i = 0; i < sizeof(NaN01f) / sizeof(*NaN01f); i++){
			for(q = (char *)&NaN01f[i], j = sizeof(*NaN01f);
			    j && *q != '\01'; ++q, --j);
			if(!j) cant_treat();
			*q = (char)((i & 1) ? 0xff : 0x7f);
		}
	}

	if(sscanf(buf, "%9s", p = tmp) != 1) return 0;
	switch(*p){
	case '-':
		sgn++; /* through */
	case '+':
		++p;
		break;
	}
	if(!strcmp(p, "NaN")){
		memcpy(s, n > 4 ? (void *)&NaN01d[sgn] :
				  (void *)&NaN01f[sgn], n);
		return 1;
	} else
	if(!strcmp(p, "Inf") ||
	   (*p == 'i' || *p == 'I') && !strcmp(p + 1, "nfinity")){
		memcpy(s, n > 4 ? (void *)&NaN01d[sgn + 2] :
				  (void *)&NaN01f[sgn + 2], n);
		return 1;
	} else return 0;
}

 /* o͗p֐QBKȑ̃obt@̓eóBɂ
    oCgA󔒕2ށAtH[}bgXgւ̃|C^^ */
static	void	l_out_word(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register us_word *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 2, ++buf, w = wn)
		fprintf(DMPOUTF, *fmtls, w, NULSTR, *buf);
}
static	void	l_out_rwrd(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register us_word *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 2, ++buf, w = wn){
		fprintf(DMPOUTF, *fmtls, w, NULSTR, *bytecnv((us_char *)buf));
	}
	 /* -32768ƂɑΏ̂ʓ|Ȃ̂ŊSɂSysV od܂˂Ȃ */
}
#ifndef MSDOS
static	void	l_out_swrd(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register s_word *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 2, ++buf, w = wn)
		fprintf(DMPOUTF, *fmtls, w, NULSTR, *buf);
}
static	void	l_out_rswd(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register s_word *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 2, ++buf, w = wn){
		fprintf(DMPOUTF, *fmtls, w, NULSTR,
			*(s_word *)bytecnv((us_char *)buf));
	}
}
#else /* int2oCgƂ킩Ăꍇ͌pĂ܂ */
#  define l_out_swrd l_out_word
#  define l_out_rswd l_out_rwrd
#endif
static	void	l_out_dwrd(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register us_dword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 4, ++buf, w = wn)
		fprintf(DMPOUTF, *fmtls, w, NULSTR, *buf);
}
static	void	l_out_rdwd(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register us_dword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 4, ++buf, w = wn)
		fprintf(DMPOUTF, *fmtls, w, NULSTR, *lbytecnv((us_char *)buf));
}
static	void	l_out_float(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register fdword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 4, ++buf, w = wn){
		sprintf(intermidbuf, fmtls[0], *buf);
		fprintf(DMPOUTF, fmtls[1], w, NULSTR, intermidbuf);
	}
}
static	void	l_out_rflt(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register fdword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 4, ++buf, w = wn){
		sprintf(intermidbuf, fmtls[0],
			*(fdword *)lbytecnv((us_char *)buf));
		fprintf(DMPOUTF, fmtls[1], w, NULSTR, intermidbuf);
	}
}
static	void	l_out_dflt(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register ldword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 8, ++buf, w = wn){
		sprintf(intermidbuf, fmtls[0], *buf);
		fprintf(DMPOUTF, fmtls[1], w, NULSTR, intermidbuf);
	}
}
static	void	l_out_rdflt(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register ldword *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i > 0; i -= 8, ++buf, w = wn){
		sprintf(intermidbuf, fmtls[0], *dbytecnv((us_char *)buf));
		fprintf(DMPOUTF, fmtls[1], w, NULSTR, intermidbuf);
	}
}
#ifdef USE_AOPT
static	void	l_out_name(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	int	c;
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i--; w = wn){
		c = *buf++ & ~0x80; /* ]isascii(c)̃`FbNsv */
		if(isgraph(c)){
			fprintf(DMPOUTF, fmtls[1], w + 1, NULSTR, c);
		} else {
			fprintf(DMPOUTF, fmtls[0], w, NULSTR, charname(c));
		}
	}
}
#endif
static	void	l_out_byte(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i--; w = wn) fprintf(DMPOUTF, *fmtls, w, NULSTR, *buf++);
}
static	void	l_out_char(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	int	c, d;
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	for(; i--; w = wn){
		c = *buf++;
		if(is_print(c)){
			fprintf(DMPOUTF, fmtls[1], w + 1, NULSTR, c);
		} else
		if(!(d = bsmap(c))){
			fprintf(DMPOUTF, fmtls[0], w, NULSTR, c);
		} else {
			fprintf(DMPOUTF, fmtls[2], w, NULSTR, d);
		}
	}
}
static	void	l_out_EUCJ(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	int	c, d;
	us_int	kcont;
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	kcont = odbuf -> dumpbuf[odbuf -> buf_sw ^ 1] . eucjvalidlen;
	for(; i--; w = wn){
		c = *buf++;
		if(kcont){
			fprintf(DMPOUTF, fmtls[3], w, NULSTR, '*', '*');
			--kcont;
		} else
		if(is_print(c)){
			fprintf(DMPOUTF, fmtls[1], w + 1, NULSTR, c);
		} else
		if(!kanji_rev && (iseucj(c) || isSS2(c))){
			d = i ? (int)*buf : getnext(odbuf, 0);
			if(!(isSS2(c) ? iskana(d) : iseucj(d)) ||
			   !nojischk && !isjisvalid((c << 8) | d, KMODE_EUCJ))
				goto normal;
		kout:
			fprintf(DMPOUTF, fmtls[3], w + isSS2(c), NULSTR, c, d);
			++kcont;
		} else
		if(kanji_rev && iseucj(c)){/* iskana(c)iseucj(c)Ɋ܂܂ */
			d = c, c = i ? (int)*buf : getnext(odbuf, 0);
			if(!(iseucj(c) || isSS2(c) && iskana(d)) ||
			   !nojischk && !isjisvalid((c << 8) | d, KMODE_EUCJ)){
				c = d; goto normal;
			}
			goto kout;
		} else
		if(!(d = bsmap(c))){
		normal:
			fprintf(DMPOUTF, fmtls[0], w, NULSTR, c);
		} else {
			fprintf(DMPOUTF, fmtls[2], w, NULSTR, d);
		}
	}
	odbuf -> dumpbuf[odbuf -> buf_sw] . eucjvalidlen = kcont;
}
static	void	l_out_MSK(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	int	c, d;
	us_int	kcont;
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	kcont = odbuf -> dumpbuf[odbuf -> buf_sw ^ 1] . mskvalidlen;
	for(; i--; w = wn){
		c = *buf++;
		if(kcont){
			fprintf(DMPOUTF, fmtls[3], w, NULSTR, '*', '*');
			--kcont;
		} else
		if(kanji_rev && ismsknj2(c)){
		 /* is_print()iskana()̔fOɂ */
			d = c, c = i ? (int)*buf : getnext(odbuf, 0);
			if(!ismsknj1(c) ||
			   !nojischk && !isjisvalid((c << 8) | d, KMODE_MSK)){
				c = d; goto chk_cont; /* goto normal; ł͂
					  is_print()Ȃǂ`FbNKv */
			}
			goto kout;
		} else
	chk_cont:
		if(is_print(c) || iskana(c)){
			fprintf(DMPOUTF, fmtls[1], w + 1, NULSTR, c);
		} else
		if(!kanji_rev && ismsknj1(c)){
			d = i ? (int)*buf : getnext(odbuf, 0);
			if(!ismsknj2(d) ||
			   !nojischk && !isjisvalid((c << 8) | d, KMODE_MSK))
				goto normal;
		kout:
			fprintf(DMPOUTF, fmtls[3], w, NULSTR, c, d);
			++kcont;
		} else
		if(!(d = bsmap(c))){
		normal:
			fprintf(DMPOUTF, fmtls[0], w, NULSTR, c);
		} else {
			fprintf(DMPOUTF, fmtls[2], w, NULSTR, d);
		}
	}
	odbuf -> dumpbuf[odbuf -> buf_sw] . mskvalidlen = kcont;
}
static	void	l_out_bmap(odbuf, i, w, wn, fmtls)
bufstr	*odbuf;
int	i;
us_int	w, wn;
char	**fmtls;
{
	char	c;
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;

	if(bit_brev) buf += i;
	for(; i--; w = wn){
		fprintf(DMPOUTF, *fmtls, w, NULSTR);
		c = (bit_brev ? *--buf : *buf++), w = BITpBYT;
		if(bit_rev){
			for(; w; --w){
				putc(c & 1 ? '#' : '-', DMPOUTF), c >>= 1;
			}
		} else {
			for(; w; --w){
				putc(c & 0x80 ? '#' : '-', DMPOUTF), c <<= 1;
			}
		}
	}
}

static	us_int	l_in_word(modep, dbufp, outinfop)
modestr	*modep;
dbufstr	*dbufp;
outinfostr *outinfop;
 /* _v1sǂ݁Aǂ񂾗ʂԂBf[^ǉĂAbytelenȂ
    bytelen1ontinfop->bytesŊ؂ʏꍇAԒlbytelenȂbytelen1
    ɂȂ邱ƂBG[Ȃ(us_int)-1B^u͔l */
{
	register char	*buf = dbufp -> mainbuf;
	register us_int	buflen = dbufp -> buflen; /* ̓oCgP */
	char	**rfmt = outinfop -> rfmt;
	us_int	size = outinfop -> bytes;
	us_int	curbyte = 0, readbyte;
	int	i;

	if(!modep -> sepwidth){
		us_int	dmp1len = outinfop -> width;
		char	dummy[SMALLMEM], ctmp[SMALLMEM]; /* e[0]̂ݎgp */

#ifndef LSI_C
		if(feof(DMPINF)) return 0;
#endif
		 /* sepwidth1sepwidthȉ̂͂Ačŏ̋󔒂0
		    Ȃ̂œǂݔ΂sv */
		for(;;){
			readbyte = fread_nl(intermidbuf, dmp1len, DMPINF);
			if(!readbyte) break;
			if(readbyte < dmp1len) return (us_int)-1; /* error */
			intermidbuf[readbyte] = '\0';

			if(curbyte >= buflen){
				buf = myrealloc(buf, buflen += size * 16);
			} /* buflensize̔{ɂƂĂ͂
			     ̔fŏ\Błl */

			 /* ((type *)buf)[n]Ȃ̂ŕs@AhXɂ͂ȂȂ
			     ctmpdummy̓dgpBSDsscanf̖̈
			     *ctmp'\0'ɂ̂LSI_Csscanf̖̈*/
			*ctmp = '\0', i = sscanf(intermidbuf,
				    rfmt[1], buf + curbyte, ctmp, dummy);
			if(i <= 0 || i > 1 && *ctmp){
			 /* LSI_Csscanfł*ctmp'\0'ɂȂ邱Ƃ */
				if(!outinfop -> isreal ||
				   1 != sscanNaN(intermidbuf,
						buf + curbyte, size))
					return (us_int)-1;
			}
			curbyte += size;
		}
	} else {
#ifdef RDEBUG
		fprintf(stderr, "Ok1\n");
#endif
		for(;;){
			switch(nonsp_peekc(DMPINF)){
			case '\n':
			case EOF:
				goto loop_fin;
			}
			if(curbyte >= buflen){
				buf = myrealloc(buf, buflen += size * 16);
			}
			if(0 >= fscanf(DMPINF, *rfmt, buf + curbyte)){
				char	tmp[10];
				 /* "-Infinity"ǂނɏ\Ȃ */

				if(!outinfop -> isreal ||
				   1 != fscanf(DMPINF, "%9s", tmp) ||
				   1 != sscanNaN(tmp, buf + curbyte, size)){
					return (us_int)-1;
				 /* r[DMPINFǂł܂Ƃ
				    Bǂ̏ꍇ̓G[I? */
				}
			}
			curbyte += size;
		}
	}

loop_fin:
#ifndef LSI_C
	if(!feof(DMPINF))
#endif
		getc(DMPINF); /* '\n'𓾂邩܂EOF̂͂ */

	dbufp -> mainbuf = buf, dbufp -> buflen = buflen;
	return curbyte;
}
static	us_int	l_in_char(modep, dbufp, outinfop)
modestr	*modep;
dbufstr	*dbufp;
outinfostr *outinfop; /* ^ul */
 /* {[`̂b, c, C, M, aɋʂAĂԎmulchrǂ
    Ă */
{
	register char	*buf = dbufp -> mainbuf;
	register us_int	buflen = dbufp -> buflen; /* ̓oCgP */
	us_int	curbyte = 0, readbyte;
	us_int	krestind = 0;

	char	**rfmt = outinfop -> rfmt;
	us_int	dmp1len = outinfop -> width;
	 /* 8i3 16i2(aIvV̏ꍇ16ił3) */

	char	dummy[SMALLMEM], ctmp[SMALLMEM]; /* e[0]̂ݎgp */
	us_char	*ibuftop;
	us_int	nextpasssp, sepwidth = modep -> sepwidth, ibuflen;
	bool	krestignmode = dbufp -> krestignmode;

#ifdef USE_AOPT
	static	us_char	namehash[] = {
		0xff, 0xff, 0x11, 0xff, 0xff, 0x05, 0xff, 0xff,
		0xff, 0x1a, 0x0c, 0x02, 0xff, 0x0e, 0x12, 0x0d,
		0x07, 0x18, 0x7f, 0x20, 0x08, 0xff, 0xff, 0xff,
		0x1c, 0x1d, 0x13, 0xff, 0xff, 0xff, 0xff, 0xff,
		0x09, 0xff, 0xff, 0xff, 0x1e, 0xff, 0x14, 0x1f,
		0x10, 0x0f, 0xff, 0xff, 0xff, 0x01, 0x0b, 0x04,
		0xff, 0x16, 0xff, 0x19, 0xff, 0x17, 0x0a, 0x06,
		0x15, 0xff, 0xff, 0x1b, 0x00, 0x03, 0xff, 0xff,
	};
#endif

#ifndef LSI_C
	if(feof(DMPINF)) return 0;
#endif

	nextpasssp = modep -> sepwidth1;
	for(;;){
		us_char	*p;
		int	c, d;

		if(!sepwidth){
		 /* ̏ꍇ͋󔒂1Ȃꍇ͍lȂĂ悢 */
		 /* sepwidth1sepwidthȉ̂͂Ačŏ̋󔒂0 */
			readbyte = fread_nl(intermidbuf, dmp1len, DMPINF);
			if(readbyte && readbyte < dmp1len)
				return (us_int)-1; /* error */
		} else {
			count_spaces(DMPINF, nextpasssp);
			readbyte = fread_nl(intermidbuf, dmp1len + 1, DMPINF);
			if(readbyte > dmp1len){
				c = ((us_char *)intermidbuf)[dmp1len];
				if(!is_space(c)){
				 /* UNIXodŋ؂󔒂Ȃ̂ւ̑ΏB
				    2ȏ㏭Ȃꍇ͂ȂƎvB܂A1
				    ꍇ͂ł͂Ȃ */
					ungetc(c, DMPINF), --readbyte;
				}
			}
			nextpasssp = sepwidth, --nextpasssp;
			 /* dmp1len+1قǗ]ɋ󔒂ǂ񂾂
			    pnextpasssp-1Ă */
		}

		if(!readbyte) break;
		for((ibuftop = (us_char *)intermidbuf)[readbyte] = '\0';
					is_space(*ibuftop); ibuftop++);
		for(p = ibuftop; *p && !is_space(*p); p++);
		*p = '\0';

		 /* krestbufɎcĂ̂̈ */
		if(!strcmp((char *)ibuftop, "**")){
			if(krestind == dbufp -> krestlen)
				return (us_int)-1;
			c = dbufp -> krestbuf[krestind++];
			goto got_onechar;
		} else if(krestind < dbufp -> krestlen){
			if(!krestignmode){
			 /* ʏ́u**vȂĂoCg
			    o͂ĂT[rX */
				int	krest;

				krest = dbufp -> krestlen - krestind;
				if(curbyte + krest > buflen){
					buf = myrealloc(buf,
						buflen += krest + 16);
				}
				memcpy(buf + curbyte,
					dbufp -> krestbuf + krestind, krest);
				curbyte += krest;
			}
			krestignmode = 0, krestind = dbufp -> krestlen = 0;
		}

		switch(ibuflen = strlen((char *)ibuftop)){
		case 1:
			if((c = ibuftop[0]) == SS2){ /* {EUC1byte */
				d = getc(DMPINF);
				if(d == EOF || d == '\n') return (us_int)-1;
				goto twobyte;
			} else
			if(is_cntrl(c)){
				return (us_int)-1;
			}
			break;
		case 0:
			c = ' ';
			break;
		default:
#ifdef USE_AOPT
			if(outinfop -> optc == 'a'){
				if(0xff != (c = (int)namehash[0x3f & (
				     (ibuftop[0] | 0x20) +
				     ibuftop[1] * 6 + ibuftop[2] * 12)]) &&
				   !strnicmp((char *)ibuftop, charname(c), 3)){
					goto got_onechar;
				}
				if(!stricmp((char *)ibuftop, "lf")){ /*  */
					c = '\n';
					goto got_onechar;
				}
				if(!stricmp((char *)ibuftop, "dcl")){
				 /* FreeBSDod -ãoOɑΏ̂߂̓ */
					c = '\021';
					goto got_onechar;
				}

				 /* łȂΑs FreeBSDod -a0x80`
				    hexŃ_v */
				goto octhex;
			}
#endif
			if(ibuflen == dmp1len){
				short	ch;
				int	i;
#ifdef USE_AOPT
			octhex:
#endif
				*ctmp = '\0';
				i = sscanf((char *)ibuftop,
						rfmt[1], &ch, ctmp, dummy);
				if(i <= 0 || i > 1 && *ctmp){
				 /* LSI_Csscanfł*ctmp'\0'ɂȂ邱Ƃ */
					if(dmp1len == 3) return (us_int)-1;
					 /* łȂΑs */
				} else {
					c = ch; goto got_onechar;
				}
			}

			c = ibuftop[0], d = ibuftop[1];
			if(c == '\\'){
				c = bsrevmap(d);
				if(c == EOF) return (us_int)-1;
			} else
			if(!isascii(c)){ /* SS3Ή */
			twobyte:
				if(kanji_rev) c ^= d, d ^= c, c ^= d;
				dbufp -> krestbuf[0] = (us_char)d;
				dbufp -> krestlen = 1, krestind = 0;
			} else {
				return (us_int)-1;
			}
			break;
		}

	got_onechar:
		if(curbyte >= buflen){
			buf = myrealloc(buf, buflen += 16);
		}
		buf[curbyte++] = (char)c;
	}

#ifndef LSI_C
	if(!feof(DMPINF))
#endif
		getc(DMPINF); /* '\n'𓾂邩܂EOF̂͂ */

	dbufp -> mainbuf = buf, dbufp -> buflen = buflen;
	bw_memcpy(buf, buf + krestind, dbufp -> krestlen -= krestind);
	return curbyte;
}
static	us_int	l_in_bmap(unused1, dbufp, unused2)
modestr	*unused1;
dbufstr	*dbufp;
outinfostr *unused2;
{
	register char	*buf = dbufp -> mainbuf;
	register us_int	buflen = dbufp -> buflen; /* ̓oCgP */
	us_int	curbyte = 0, c, i, j;
	char	ptn[BITpBYT + 1];

	for(;;){
		switch(nonsp_peekc(DMPINF)){
		case '\n':
		case EOF:
			goto loop_fin;
		}
		if(curbyte >= buflen){
			buf = myrealloc(buf, buflen += 32);
		}
		if(0 >= fscanf(DMPINF, "%8[-#]", ptn) /* 8rbg */ ||
		   strlen(ptn) != BITpBYT){
			return (us_int)-1;
		}
		c = 0;
		if(bit_rev){
			for(i = BITpBYT; i--; ){
				c <<= 1;
				if(ptn[i] == '#') c |= 1;
			}
		} else {
			for(i = 0; i < BITpBYT; i++){
				c <<= 1;
				if(ptn[i] == '#') c |= 1;
			}
		}
		buf[curbyte++] = (char)c;
	}
loop_fin:
	if(bit_brev){
		i = j = curbyte, j -= (i >>= 1);
		while(i) c = buf[--i], buf[i] = buf[j], buf[j++] = (char)c;
	}

#ifndef LSI_C
	if(!feof(DMPINF))
#endif
		getc(DMPINF); /* '\n'𓾂邩܂EOF̂͂ */

	dbufp -> mainbuf = buf, dbufp -> buflen = buflen;
	return curbyte;
}
static	us_int	l_in_rwrd(modep, dbufp, outinfop)
modestr	*modep;
dbufstr	*dbufp;
outinfostr *outinfop;
{
	us_int	size = outinfop -> bytes;
	us_int	readbyte, curbyte, i;
	us_char	*order, *p, *q, *r;
	us_char	tmp[8]; /* max of sizeof(short|long|double) */

	switch(size){
	case 2:
		order = byteshift[0]; break;
	case 4:
		order = byteshift[1]; break;
	default: /* case 8: */
		if(NULL == (order = byteshift[2])) cant_treat();
		break;
	}

	readbyte = l_in_word(modep, dbufp, outinfop);
	if(readbyte != (us_int)-1){
		for(curbyte = 0; curbyte < readbyte; curbyte += size){
			p = order, r = tmp;
			q = dbufp -> mainbuf, q += curbyte;
			for(i = size; i; i--) *r++ = q[*p++];
			memcpy(q, tmp, size);
		}
	}
	return readbyte;
}

#define	l_in_dwrd  l_in_word
#define l_in_rdwd  l_in_rwrd
#define l_in_float l_in_word
#define l_in_rflt  l_in_rwrd
#define l_in_dflt  l_in_word
#define l_in_rdflt l_in_rwrd

static	char	FMTobyte[]    = "%*s%03o",  FMTxbyte[] = "%*s%02x",
		FMTspch[]     = "%*s %c",   FMTch[]    = "%*s%c",
		FMTspbsch[]   = "%*s \\%c", FMTbsch[]  = "%*s\\%c",
		FMTspchch[]   = "%*s %c%c", FMTchch[]  = "%*s%c%c",
		FMTxword[]    = "%*s%04hx",
		FMTxdword[]   = "%*s%08lx",
		FMTuword[]    = "%*s%05hu",
		FMTudword[]   = "%*s%010lu",
		FMToword[]    = "%*s%06ho",
		FMTodword[]   = "%*s%011lo",
		FMTdword[]    = "%*s% 06hd",
		FMTddword[]   = "%*s% 011ld",
		FMTfdword[]   = "% .8e",   /*  7 in UNIX od */
		FMTfdworde[]  = "%*s%15s", /* 14 in UNIX od */
		FMTfddword[]  = "% .16e",  /* 14 in UNIX od */
		FMTfddworde[] = "%*s%24s", /* 22 in UNIX od */
#ifdef USE_AOPT
		FMTname[]     = "%*s%3.3s",
#endif
		FMTnone[]     = "%*s";
static	char	*FMTlist_och[] = {FMTobyte, FMTspch, FMTspbsch, FMTspchch},
		*FMTlist_xch[] = {FMTxbyte, FMTch,   FMTbsch,	FMTchch},
		*FMTlist_flt[] = {FMTfdword, FMTfdworde},
		*FMTlist_dflt[] = {FMTfddword, FMTfddworde},
#ifdef USE_AOPT
		*FMTlist_name[] = {FMTname, FMTspch},
#endif
		*FMTls_others[] = {
			FMTnone,
			FMTdword,  FMTxword,  FMTuword,  FMToword,
			FMTddword, FMTxdword, FMTudword, FMTodword,
		};

static	char	rFMTdword[]   = "%hd", rFMTdwdch[]   = "%hd%c%c",
		rFMTuword[]   = "%hu", rFMTuwdch[]   = "%hu%c%c",
		rFMToword[]   = "%ho", rFMTowdch[]   = "%ho%c%c",
		rFMTxword[]   = "%hx", rFMTxwdch[]   = "%hx%c%c",
		rFMTddword[]  = "%ld", rFMTddwdch[]  = "%ld%c%c",
		rFMTudword[]  = "%lu", rFMTudwdch[]  = "%lu%c%c",
		rFMTodword[]  = "%lo", rFMTodwdch[]  = "%lo%c%c",
		rFMTxdword[]  = "%lx", rFMTxdwdch[]  = "%lx%c%c",
		rFMTfdword[]  = "%e",  rFMTfdwdch[]  = "%e%c%c",
		rFMTfddword[] = "%le", rFMTfddwch[]  = "%le%c%c";
static	char	*rFMTlist_dwd[] = {rFMTdword, rFMTdwdch},
		*rFMTlist_uwd[] = {rFMTuword, rFMTuwdch},
		*rFMTlist_owd[] = {rFMToword, rFMTowdch},
		*rFMTlist_xwd[] = {rFMTxword, rFMTxwdch},
		*rFMTlist_ddwd[] = {rFMTddword, rFMTddwdch},
		*rFMTlist_udwd[] = {rFMTudword, rFMTudwdch},
		*rFMTlist_odwd[] = {rFMTodword, rFMTodwdch},
		*rFMTlist_xdwd[] = {rFMTxdword, rFMTxdwdch},
		*rFMTlist_fdwd[] = {rFMTfdword, rFMTfdwdch},
		*rFMTlist_fddw[] = {rFMTfddword, rFMTfddwch};

static	outinfostr outinfos[] = {
#ifdef USE_AOPT
    {'a', 1,  3, 0,0,0,0, l_out_name, l_in_char, FMTlist_name, rFMTlist_xwd},
#endif

    {'b', 1,  3, 0,0,1,0, l_out_byte, l_in_char, FMTlist_och, rFMTlist_owd},
	  /* zIvVAeIvV̏ꍇ͂index */
    {'b', 1,  2, 0,0,0,0, l_out_byte, l_in_char, FMTlist_xch, rFMTlist_xwd},

    {'c', 1,  3, 0,0,1,0, l_out_char, l_in_char, FMTlist_och, rFMTlist_owd},
    {'c', 1,  2, 0,0,0,0, l_out_char, l_in_char, FMTlist_xch, rFMTlist_xwd},

    {'C', 1,  3, 2,0,1,0, l_out_EUCJ,  l_in_char, FMTlist_och, rFMTlist_owd},
    {'C', 1,  2, 2,0,0,0, l_out_EUCJ,  l_in_char, FMTlist_xch, rFMTlist_xwd},

    {'M', 1,  3, 1,0,1,0, l_out_MSK,  l_in_char, FMTlist_och, rFMTlist_owd},
    {'M', 1,  2, 1,0,0,0, l_out_MSK,  l_in_char, FMTlist_xch, rFMTlist_xwd},

    {'m', 1,  8, 0,0,0,0, l_out_bmap, l_in_bmap, FMTls_others, NULL},

    {'d', 2,  5, 0,0,0,1, l_out_word, l_in_word, FMTls_others+3, rFMTlist_uwd},
    {'d', 2,  5, 0,0,0,0, l_out_rwrd, l_in_rwrd, FMTls_others+3, rFMTlist_uwd},

    {'D', 4, 10, 0,0,0,1, l_out_dwrd, l_in_dwrd, FMTls_others+7, rFMTlist_udwd},
    {'D', 4, 10, 0,0,0,0, l_out_rdwd, l_in_rdwd, FMTls_others+7, rFMTlist_udwd},

    {'o', 2,  6, 0,0,0,1, l_out_word, l_in_word, FMTls_others+4, rFMTlist_owd},
    {'o', 2,  6, 0,0,0,0, l_out_rwrd, l_in_rwrd, FMTls_others+4, rFMTlist_owd},

    {'O', 4, 11, 0,0,0,1, l_out_dwrd, l_in_dwrd, FMTls_others+8, rFMTlist_odwd},
    {'O', 4, 11, 0,0,0,0, l_out_rdwd, l_in_rdwd, FMTls_others+8, rFMTlist_odwd},

    {'s', 2,  6, 0,0,0,1, l_out_swrd, l_in_word, FMTls_others+1, rFMTlist_dwd},
    {'s', 2,  6, 0,0,0,0, l_out_rswd, l_in_rwrd, FMTls_others+1, rFMTlist_dwd},

    {'S', 4, 11, 0,0,0,1, l_out_dwrd, l_in_dwrd, FMTls_others+5, rFMTlist_ddwd},
    {'S', 4, 11, 0,0,0,0, l_out_rdwd, l_in_rdwd, FMTls_others+5, rFMTlist_ddwd},

    {'x', 2,  4, 0,0,0,1, l_out_word, l_in_word, FMTls_others+2, rFMTlist_xwd},
    {'x', 2,  4, 0,0,0,0, l_out_rwrd, l_in_rwrd, FMTls_others+2, rFMTlist_xwd},

    {'X', 4,  8, 0,0,0,1, l_out_dwrd, l_in_dwrd, FMTls_others+6, rFMTlist_xdwd},
    {'X', 4,  8, 0,0,0,0, l_out_rdwd, l_in_rdwd, FMTls_others+6, rFMTlist_xdwd},

    {'f', 4, 15, 0,1,0,1, l_out_float, l_in_float, FMTlist_flt, rFMTlist_fdwd},
    {'f', 4, 15, 0,1,0,0, l_out_rflt,  l_in_rflt,  FMTlist_flt, rFMTlist_fdwd},
	  /* 14 in UNIX od */

    {'F', 8, 24, 0,1,0,1, l_out_dflt,  l_in_dflt,  FMTlist_dflt, rFMTlist_fddw},
    {'F', 8, 24, 0,1,0,0, l_out_rdflt, l_in_rdflt, FMTlist_dflt, rFMTlist_fddw},
	  /* 22 in UNIX od */
};
static	us_int	byteslcm = 1,	/* oCgƂ̃_v?̍ŏ{ */
		bytesgcm = 0,	/* Eő */
		dump1width = 0;	/* 1܂̃_vɗv镝 */

static	us_long addrmask(addr)
us_long	addr;
{
	switch(plus_opt . addrfmtc){
	case OCTADDR:
		return addr & ((1L << (ADDRWID * 3)) - 1);
	case HEXADDR:
		return addr & ((1L << (ADDRWID * 4)) - 1);
	default: /* case DECADDR: */
		return addr % EXP10ADDRWID;
	}
}

static	void	do_plus_opt(s, mode)
char	*s, mode;
 /* sɁu+cvČĂсAplus_opt̐ݒ */
{
	char	*p, *amount_opt, amount_pm;
	static	char	fmt[] = "%lo"; /* fmt[2]͏ */
	int	i;
	us_long	num;

	++s;
	if(NULL != (amount_opt = strchr(s, '+')) ||
	   NULL != (amount_opt = strchr(s, '-'))){
		amount_pm = *amount_opt;
		*amount_opt++ = '\0'; /* IvVBvƎv */
	}

	for(i = 0; i <= 1 && s != NULL; ++i, s = amount_opt){
		fmt[2] = mode;
		if(!strncmp(s, "0x", 2) || *s == 'x'){
			fmt[2] = HEXADDR;
			if(*s++ == '0') ++s;
		} else if(*s == '0'){
			fmt[2] = OCTADDR;
		}
		if(NULL != strchr(s, '.')){ /* 10iw̕D */
			fmt[2] = DECADDR;
		}

		sscanf(s, fmt, &num);
		if(fmt[2] != HEXADDR && NULL != (p = strpbrk(s, "bB")))
			num <<= (*p == 'b' ? 9 : 10);

		if(!i){
			plus_opt . raddrfmtc = plus_opt . addrfmtc = fmt[2];
			plus_opt . offset = num;
		} else {
		 /* ɗ̂amount_optNULL̎łȀꍇ
		    amount_pm͊ݒ */
			if(amount_pm == '-'){
				if(num < plus_opt . offset){
					cmd_errmsg("Dump range illegal\n");
					exit(2);
				}
				num -= plus_opt . offset;
			}
			plus_opt . amount = num;
		}
	}
}

static	do_dumpmode_opt(c)
char	c;
 /* cɃ_v`wIvVČĂсAmodeoptɒ߂
    ̊֐łmodestroptindx̂ݐݒAsepwidthEsepwidth1͕s
    s-1 */
{
	us_int	i;

	for(i = 0; i < sizeof(outinfos) / sizeof(*outinfos); i++){
		if(c == outinfos[i] . optc){
			modeopt . optlist = myrealloc(modeopt . optlist,
				    sizeof(modestr) * ++modeopt . optcount);
			modeopt . optlist[modeopt.optcount - 1] . optindx = i;
			return 0;
		}
	}
	return -1; /* fail */
}

static	gcm(x, y)
us_int	x, y; /* y͐̂ */
{
	us_int	rem;

	return (0 == (rem = x % y)) ? y : gcm(y, rem);
}
#define lcm(x, y) ((x) / gcm((x), (y)) * (y))

static	void	dumpmode_init()
 /* 󔒂̕Ƃ̏𓾂 */
{
	us_int	n, i;
	us_int	sepwidth_min, lg_ratio;

	if(hexmode){
		for(i = modeopt . optcount; i--; ){
			modeopt . optlist[i] . optindx += outinfos[
				modeopt . optlist[i] . optindx] . hexmode_adv;
		}
	} /* zIvV̐b */
	if(byte_reord){
		for(i = modeopt . optcount; i--; ){
			modeopt . optlist[i] . optindx += outinfos[
				modeopt . optlist[i] . optindx] . bytecnv_adv;
		}
	} /* eIvV̐b */

	for(i = modeopt . optcount; i--; ){
		n = outinfos[modeopt . optlist[i] . optindx] . bytes;
		byteslcm = lcm(byteslcm, n);
		bytesgcm = gcm(bytesgcm, n);
	}
	for(i = modeopt . optcount; i--; ){
		n = modeopt . optlist[i] . optindx;
		n = (outinfos[n] . width + minsepwid) *
					(byteslcm / outinfos[n] . bytes);
		if(n > dump1width) dump1width = n;
	}
	lg_ratio = (bytesgcm ? byteslcm / bytesgcm : 1);
	 /* modeopt.optcount0̎bytesgcm0ƂȂ */
	dump1width = (dump1width + lg_ratio - 1) / lg_ratio * lg_ratio;
	for(sepwidth_min = i = 0; i < modeopt . optcount; i++){
		n = modeopt . optlist[i] . optindx;
		n = modeopt . optlist[i] . sepwidth =
			dump1width / (byteslcm / outinfos[n] . bytes) -
							outinfos[n] . width;
		if(!i || n < sepwidth_min) sepwidth_min = n;
	}
	for(i = modeopt . optcount; i--; ){
		modeopt . optlist[i] . sepwidth1 =
			modeopt . optlist[i] . sepwidth - sepwidth_min;
	} /* sepwidth1sepwidthȉɂȂ͂ł */
}

 /* _vׂt@CK؂ȃobt@ւ̓ǂݍ */
 /* ǂ݂̌ʂ͏ɂ̃obt@ɓĂƂĂ
    ͂Ȃ */
static	us_int	odread(odbuf, n)
bufstr	*odbuf;
us_int	n;	/* ǂݍ݃oCg */
{
	char	*p;
	us_int	krestlen, readlen;
	dbufstr	*cur_dbufp, *prv_dbufp;

	prv_dbufp = &(odbuf -> dumpbuf[odbuf -> buf_sw]);
	cur_dbufp = &(odbuf -> dumpbuf[odbuf -> buf_sw ^= 1]);
	 /* buf_sw] */

	p = cur_dbufp -> mainbuf;
	cur_dbufp -> eucjvalidlen = cur_dbufp -> mskvalidlen =
		cur_dbufp -> kstrvalidlen = 0;

	if((krestlen = prv_dbufp -> krestlen) >= n){
		cur_dbufp -> krestlen = (krestlen -= n);
		memcpy(p, prv_dbufp -> krestbuf, n);
		memcpy(cur_dbufp -> krestbuf, prv_dbufp -> krestbuf + n,
		       krestlen);
		return n;
	} else {
		cur_dbufp -> krestlen = 0;
		if(krestlen){ /* ̔f͖{͂ȂĂ̂ */
			memcpy(p, prv_dbufp -> krestbuf, krestlen);
			p += krestlen;
			n -= krestlen;
		}
		n -= (readlen = f_read_amount(p, n, odbuf -> objf));
		if(n) memset(p + readlen, 0, n);
		return krestlen + readlen;
	}
}

 /* O̍sƈقȂf[^Ȃ0B̍sɂ銿ꍇkrestbuf
    ǂłBL͂̃obt@eucjvalidlenȂǂɓĂ͂ */
static	diffline(odbuf, i)
bufstr	*odbuf;
us_int	i;
{
	dbufstr	*prv_dbufp = &(odbuf -> dumpbuf[odbuf -> buf_sw ^ 1]),
		*cur_dbufp = &(odbuf -> dumpbuf[odbuf -> buf_sw]);
	us_int	kneedlen, krestlen;

	if(memcmp(prv_dbufp -> mainbuf, cur_dbufp -> mainbuf, i)) return 1;
	if(i < bytelen || !prv_dbufp -> krestlen) return 0;
	 /* ̌㔼͏X̃Xs[hAbv̂ */
	kneedlen = ((cur_dbufp -> eucjvalidlen = prv_dbufp -> eucjvalidlen) >
		    (cur_dbufp -> mskvalidlen = prv_dbufp -> mskvalidlen)) ?
		   cur_dbufp -> eucjvalidlen : cur_dbufp -> mskvalidlen;
	if(kneedlen > (krestlen = cur_dbufp -> krestlen)){
		krestlen = cur_dbufp -> krestlen += f_read_amount(
			cur_dbufp -> krestbuf + krestlen,
			kneedlen - krestlen, odbuf -> objf);
		if(kneedlen > krestlen) return 1;
	}
	return kneedlen &&
	    memcmp(prv_dbufp -> krestbuf, cur_dbufp -> krestbuf, kneedlen);
}

 /* buf̒glAeLXgƂďóBkcontɂ͑O̊̑
    邩nBԂĺAɊ̐B́A
    ̊֐{I2AŌĂ΂Aׂꍇ邽 */
us_int	stroutmain(buf, l, kcont)
us_char	*buf;
us_int	l, kcont;
{
	int	c, d;

	for(; l; --l, ++buf){
		c = *buf;
		if(kcont){
			--kcont, putc(c, DMPOUTF);
		} else
		if(is_print(c) ||
		   stringsbuf . kmode == KMODE_MSK && iskana(c)){
			if(c == '\\') putc(c, DMPOUTF);
			putc(c, DMPOUTF);
		} else
		if(0 != (d = bsmap(c))){
			putc('\\', DMPOUTF), putc(d, DMPOUTF);
		} else
		if(!(c & 0x80)){ /* '\016', '\017' */
			fprintf(DMPOUTF, "\\%03o", c);
		} else { /* must be 2-byte char */
			++kcont, putc(c, DMPOUTF);
			 /* SS3 not yet supported here */
		}
	}
	return kcont;
}

 /* sbufs->bufbufɂꂼAeLXg̘AĂƂA
    o */
static	void	stringsrealout(addr, sbufs, olen, buf, contlen)
us_long	addr;
sbufstr	*sbufs;
us_int	olen;
us_char	*buf;
us_int	contlen;
{
	if(olen + contlen < sbufs -> minlen) return;
	if(kanji_rev && sbufs -> kmode != KMODE_ASCII){
		us_char	*p, *q;
		static	us_char	*tbuf = NULL;
		static	us_int	tbuf_siz = 0;
		us_int	i, kcont = 0;

		if(tbuf_siz < contlen)
			tbuf = myrealloc(tbuf, tbuf_siz = contlen);
		buf = (us_char *)memcpy(tbuf, buf, contlen);

		p = olen ? sbufs -> sbuf : buf;
		i = olen + contlen;

		while(i > 1){ /* Ō1̎ɎȂ悤 */
			q = (--i == contlen ? buf : p + 1);
			if(kcont){
				--kcont;
			} else
			if(sbufs -> kmode == KMODE_EUCJ ? (int)(*p & 0x80) :
			 /* EUCJ̏ꍇAtextȂ̂͂킩Ă邩炱ŏ\ */
			     ismsknj1(*q) && ismsknj2(*p) &&
			     (nojischk || isjisvalid((*q<<8)|*p, KMODE_MSK))){
				*p ^= *q, *q ^= *p, *p ^= *q, ++kcont;
			}
			p = q;
		}
	}

	if(!noaddr){
		if(olen) addr = sbufs -> startaddr;
		fprintf(DMPOUTF, plus_opt . addrfmt, addr);
	}
	if(modeopt . optcount) fputs(": ", DMPOUTF);
	 else if(!noaddr) putc(' ', DMPOUTF);
	stroutmain(buf, contlen, stroutmain(sbufs -> sbuf, olen, 0));
	putc('\n', DMPOUTF);
}

 /* stringsrealout()̕ώB'$'΂̒O܂łóBۂɂ
    stringsrealout()ĂԁB'$'͊2oCgڂɂ͂ȂȂ */
static	void	stringsdollarout(addr, sbufs, olen, buf, contlen)
us_long	addr;
sbufstr	*sbufs;
us_int	olen;
us_char	*buf;
us_int	contlen;
{
	us_char	*p;

	for(p = buf + contlen; contlen; --contlen){
		if(*--p == '$'){
			contlen--; goto fin;
		}
	}
	for(p = (us_char *)(sbufs -> sbuf) + olen; olen; --olen){
		if(*--p == '$'){
			olen--; break;
		}
	}
fin:
	stringsrealout(addr, sbufs, olen, buf, contlen);
}

 /* dumpmodeƌp̃obt@ֈʓǂ񂾂(odbuf̒)
    eLXg̘AAKvȂ璙߁AA؂ꂽ
    stringsrealout()Ăяoďo */
static	void	stringsout(odbuf, i, addr)
bufstr	*odbuf;
us_int	i;	/* oCg */
us_long	addr;	/* o͂AhX */
{
	register us_char *buf = odbuf -> dumpbuf[odbuf -> buf_sw] . mainbuf;
	int	c, d;
	us_int	kcont, strcont;

	strcont = 0;
	kcont = odbuf -> dumpbuf[odbuf -> buf_sw ^ 1] . kstrvalidlen;
	while(i--){
		c = *buf++;
		if(kcont){
			++strcont, --kcont;
		} else
		if(kanji_rev && /* iskana(c)iseucj(c)Ɋ܂܂ */
		   (stringsbuf . kmode == KMODE_EUCJ ? iseucj(c) :
		    stringsbuf . kmode == KMODE_MSK && ismsknj2(c))){
			d = c, c = (i ? (int)*buf : getnext(odbuf, 0));
			if(!(stringsbuf . kmode == KMODE_MSK ? ismsknj1(c) :
				iseucj(c) || isSS2(c) && iskana(d)) ||
			   !nojischk&& !isjisvalid((c<<8)|d,stringsbuf.kmode)){
				c = d;
				if(stringsbuf.kmode== KMODE_MSK) goto chk_cont;
				 else goto normal;
			}
			++strcont, ++kcont;
		} else
	chk_cont:
		if(is_print(c) || bsmap(c) && c ||
		   c == '\016' || c == '\017' || 
		   stringsbuf . kmode == KMODE_MSK && iskana(c)){
			++strcont;
		} else
		if(!kanji_rev &&
		   (stringsbuf . kmode == KMODE_EUCJ? (iseucj(c) || isSS2(c)) :
		    stringsbuf . kmode == KMODE_MSK && ismsknj1(c))){
			d = (i ? (int)*buf : getnext(odbuf, 0));
			if(!(stringsbuf . kmode == KMODE_MSK ? ismsknj2(d) :
				isSS2(c) ? iskana(d) : iseucj(d)) ||
			   !nojischk&& !isjisvalid((c<<8)|d, stringsbuf.kmode))
				goto normal;

			++strcont, ++kcont;
		} else { /* r؂ꂽ */
		normal:
#ifdef DEBUG
			fprintf(stderr, "str cut by 0x%x, addr %lo\n", c,addr);
#endif
			switch(stringsbuf . outmode){
			case STRINGSNULT:
				if(c) break; /* else through */
			case STRINGSALL:
			normalout:
				stringsrealout(addr - strcont, &stringsbuf,
				 stringsbuf . len, buf - strcont - 1, strcont);
				break;
			default: /* STRINGSDOLLAR */
				if(!c) goto normalout;
				stringsdollarout(addr - strcont, &stringsbuf,
				 stringsbuf . len, buf - strcont - 1, strcont);
				break;
			}
			stringsbuf . len = strcont = 0;
		}
		++addr;
	}
	 /* ؂ĂȂ΂܂łstringsbuf֓ */
	if(strcont){
		us_int	orglen = stringsbuf . len,
			newlen = orglen + strcont;
		us_char	*p = stringsbuf . sbuf;

		if(!orglen) stringsbuf . startaddr = addr - strcont;
		if((stringsbuf . len = newlen) > stringsbuf . buflen){
#ifdef DEBUG
			fprintf(stderr, "str_buf %d => %d\n",
				stringsbuf . buflen, newlen + 100);
#endif
			stringsbuf . sbuf = p = myrealloc(p,
					stringsbuf . buflen = newlen + 100);
		}
		memcpy(p + orglen, buf - strcont, strcont);
	}
	odbuf -> dumpbuf[odbuf -> buf_sw] . kstrvalidlen = kcont;
}

 /* 1s̃f[^K؂ȃobt@ɓĂAo */
static	void	lineout(odbuf, i, addr)
bufstr	*odbuf;
us_int	i;	/* oCg */
us_long	addr;	/* o͂AhX */
{
	us_int	n;
	modestr	*p;

	if(strings) stringsout(odbuf, i, addr);
	for(n = 0; n < modeopt . optcount; ++n){
		if(!noaddr){
			if(n){
				putc('\t', DMPOUTF);
			} else {
				fprintf(DMPOUTF, plus_opt . addrfmt, addr);
							/* AhXo */
				putc(' ', DMPOUTF);
			}
			if(minsepwid) putc(' ', DMPOUTF);
			 /* noaddr̂Ƃ͂͂Ȃ */
		}
		p = modeopt . optlist + n;
		(outinfos[p -> optindx] . ofunc)(odbuf, i, p -> sepwidth1,
			p -> sepwidth, outinfos[p -> optindx] . fmtls);
		 /*  2:oCg 3E4:󔒕 5: */
		if(EOF == putc('\n', DMPOUTF)) write_err();
	}
}

static	us_long	pass(f, rw)
FILE	*f; /* If EOF reached, return the rest amount not passed */
int	rw;
{
	char	*passbuf;
	us_long	passrest;
	us_int	passread, passed;

	passbuf = mymalloc(OBUFSIZ);
	passrest = plus_opt . offset;
	while(passrest){
		passread = (passrest > (us_long)OBUFSIZ ?
						OBUFSIZ : (us_int)passrest);
		passed = fread(passbuf, 1, passread, f);
		passrest -= passed;
		if(passread > passed) break;
	}
	if(rw){
		memset(passbuf, '\0', OBUFSIZ);
		while(passrest){
			passread = (passrest > (us_long)OBUFSIZ ?
						OBUFSIZ : (us_int)passrest);
			if(passread > fwrite(passbuf, 1, passread, f))
				write_err();
			passrest -= passread;
		}
	}
	free(passbuf);
	return passrest;
}

static	void	alloc_bufs()
{
	us_int	i;

	if(NULL == (ivbuf = malloc(ivbufsiz = BIGBUFSIZ)))
		ivbuf = malloc(ivbufsiz = OBUFSIZ);
#ifdef DEBUG2
	fprintf(stderr, "alc %x(%d)\n", (int)ivbuf, BIGBUFSIZ);
#endif
	if(isatty(fileno(DMPOUTF)) ||
	   NULL == (ovbuf = malloc(ovbufsiz = BIGBUFSIZ)))
		ovbuf = malloc(ovbufsiz = OBUFSIZ);
#ifdef DEBUG2
	fprintf(stderr, "alc %x(%d)\n", (int)ovbuf, BIGBUFSIZ);
#endif
	if(NULL != ovbuf && 0 != setfbuf(DMPOUTF, ovbuf, ovbufsiz)) cantbuf();

	stringsbuf . sbuf = mymalloc(stringsbuf . buflen = 100);

	 /* mainbuf2Ƃ[NAKv */
	for(i = 2; i--; ){
		dbufstr	*dbufp = &(thebuf . dumpbuf[i]);

		dbufp -> mainbuf = mymalloc(dbufp -> buflen =
		  (((bytelen > bytelen1) ? bytelen : bytelen1) + byteslcm - 1)
		  / byteslcm * byteslcm);
		 /* undumpłȂꍇAmainbuf[0]bytelenbytelen1̒
		    KvAmainbuf[1]bytelenKvBundump̏ꍇ
		    Ƃbytelenbytelen1̒Kv */
		dbufp -> krestdifflg = 0;
		dbufp -> krestlen = dbufp -> kstrvalidlen =
		dbufp -> eucjvalidlen = dbufp -> mskvalidlen = 0;
		 /* staticȂ̂0ǔÔ */
	}
	thebuf . buf_sw = 1;
}

static	void	do_e_opt(s) /* -eIvVoCgI[_ */
char	*s;
{
	double	all1	= 7.748604185489348e-304;
	double	zro2svn = 1.401599773078893e-309;
	long	zro2thr = 0x00010203L;
	short	zro2one = 0x0001;

	static	us_char	ordbuf[8 + 4 + 2];
	char	tmp[8 + 1];
	us_int	i, j, k, l, c;

	switch(strlen(s)){
	case 1:
		switch(*s){
		case 'b':
			do_e_opt("12345678"); break;
		case 'l':
			do_e_opt("87654321"); break;
		case 'r':
			bit_rev = 1; return; /* backward compati */
		case 'k':
			kanji_rev = 1; return;
		default:
			usage();
		}
		break;
	case 2:
		if(*s != 'r' || *++s < '0' || *s > '3') usage();
		bit_rev = *s & 1; /* '0'KvȂ */
		bit_brev = (*s >> 1) & 1;
		return;
	case 4:
		strcpy(tmp, s), s = strcat(tmp, s);
		for(i = 4; i; --i) s[i] += 4;
		/* through */
	case 8:
		byteshift[2] = ordbuf, byteshift[1] = ordbuf + 8,
		byteshift[0] = ordbuf + 8 + 4;
		for(i = j = k = 0; i < 8; ++i){
			c = s[i] - '1';
			if(c < 8){
				if(byteshift[2] == NULL) goto next1;
				for(l = 8; l--; ){
					if(((char *)&zro2svn)[l] == (char)c){
						byteshift[2][i] = (char)l;
						goto next1;
					}
				}
				byteshift[2] = NULL; /* non-IEEE, maybe */
			next1:	;
			} else usage();
			if(c < 4 && j < 4){
				for(l = 4; l--; ){
					if(((char *)&zro2thr)[l] == (char)c){
						byteshift[1][j] = (char)l;
						goto next2;
					}
				}
				cant_treat();
			next2:	++j;
			}
			if(c < 2 && k < 2){
				for(l = 2; l--; ){
					if(((char *)&zro2one)[l] == (char)c){
						byteshift[0][k] = (char)l;
						goto next3;
					}
				}
				cant_treat();
			next3:	++k;
			}
		}
		break;
	default:
		usage();
	}
	if(byteshift[2] != NULL&& *dbytecnv((us_char *)&all1) != all1) usage();
	byte_reord = 1;
}

static	void	do_t_opt(s)
char	*s;
{
	strings = 1;

	if(!(stringsbuf . minlen = (is_digit(*s) ? atoi(s) : DEFSTRMINLEN)))
		usage();
	while(is_digit(*s)) s++;
	for(;;){
		switch(*s++){
		case '\0':
			return;
		case 'C':
			stringsbuf . kmode = KMODE_EUCJ; break;
		case 'M':
			stringsbuf . kmode = KMODE_MSK; break;
		case 'a':
			stringsbuf . outmode = STRINGSALL; break;
		case 'd':
			stringsbuf . outmode = STRINGSDOLLAR; break;
		default:
			usage();
		}
	}
}

static	void	illaddr(addr)
us_long	addr;
{
	cmd_errmsg("Illegal address after ");
	fprintf(stderr, plus_opt . addrfmt, addr), putc('\n', stderr);
	exit(2);
}

static	void	illdata(addr)
us_long	addr;
{
	cmd_errmsg("Illegal data near address ");
	fprintf(stderr,	plus_opt . addrfmt, addr), putc('\n', stderr);
	exit(2);
}

struct	warnout {
	bool	flg;  /* 0:xoׂ */
	us_long	addr;
};

static	void	warnmsg(warnstr_p, msg)
struct	warnout	*warnstr_p;
char	*msg;
{
	if(warnstr_p -> flg == 0) return; else warnstr_p -> flg = 0;

	if(nowarn) return;
	cmd_errmsg("Warning: "), fputs(msg, stderr);
	fprintf(stderr, plus_opt . addrfmt, warnstr_p -> addr);
	putc('\n', stderr);
}

 /* s̎ۂ̃f[^TCY-wŎw肵̂ƈႤ */
static	void	warnsize(warnstr_p)
struct	warnout	*warnstr_p;
{
	warnmsg(warnstr_p, "Data size mismatch near address ");
}

 /* s̃AhXO̍s̃AhXɃIvV-wŎw肵TCY
    (ŏIs̏ꍇ͎ۂ̃f[^TCY)̂ƈႤ */
static	void	warnaddr(warnstr_p)
struct	warnout	*warnstr_p;
{
	warnmsg(warnstr_p, "Address mismatch at ");
}

#define warn_prepare(warnstr_p, address) \
	((warnstr_p) -> addr = (address), (warnstr_p) -> flg = 1)
 /* warnstr_pɑ΂āAwarnmsg܂2񑱂ĂĂ΂ƁA
    ÕAhXɑ΂xKvƂ͎̏Ă܂ */

#define warn_clear(warnstr_p) ((warnstr_p) -> flg = 0)

static	void	warndata(addr) /* s̃f[^m̐HႢ */
us_long	addr;
{
	if(nowarn) return;
	cmd_errmsg("Warning: Data mismatch near address ");
	fprintf(stderr,	plus_opt . addrfmt, addr), putc('\n', stderr);
}

static	void	passminsep()
 /* getaddr(), getemptyaddr()ŃAhX𓾂(]noaddrłȂɌ)A
    minsepaddr̗]vȋ󔒂ǂݔ΂ĂBAUNIXodł͂̋󔒂
    ȂƂ */
{
	if(minsepwid && ' ' == peekc(DMPINF)) getc(DMPINF);
}

static	getaddr(addrp)
us_long	*addrp;
 /* AhXƂ̎̋1ǂ
    G[-1A펞0AEOF1A'*'Ȃ2Ԃ AhXaddrp̎w*/
{
	int	i;
	us_char	ctmp[SMALLMEM], dummy[SMALLMEM]; /* e[0]̂ݎgp */

resume_when_string:
	switch(peekc(DMPINF)){
	case EOF:
		return 1;
	case '*':
		getc(DMPINF); /* '*'ǂł */
		return 2; /* '*'̌ɗ]vȂ̂Ȃǂ͑Ō */
	case ':': /* string dump̃}[NƓ */
	case ';': /* undoc */
		goto pass_to_eol; /* s܂œǂݔ΂ */
	} /* łȂꍇAfscanfEOFԂȂBȂALSI_Cł
	     ͂IĂĂfscanfEOFԂȂ */
	i = fscanf(DMPINF, plus_opt . faddrfmt,	intermidbuf, ctmp);
#ifdef RDEBUG2
	fprintf(stderr, "Ok1 '%s' [%x] %d\n", intermidbuf, *ctmp, i);
#endif
	if(i <= 0 || (int)strlen(intermidbuf) < ADDRWID) return -1;
	if(i > 1 && !is_space(*ctmp)){
		int	cc;

		if(*ctmp != ':') return -1;
		 /* ł́u;v͌ȂB܂A̎' 'ǂ
		    ȂƂɂ */

	pass_to_eol: /* s܂œǂݔ΂ */
		while('\n' != (cc = getc(DMPINF))){
			if(cc == EOF) return 1; /* EOF */
		}
		goto resume_when_string;
	}

	*ctmp = '\0'; /* LSI_Csscanf̖ */
	i = sscanf(intermidbuf, plus_opt . raddrfmt, addrp, ctmp, dummy);
	  /* dummyctmp̓dgpBSDsscanf̖̂ */
	if(i <= 0 || i > 1 && *ctmp){
	 /* LSI_Csscanfł*ctmp'\0'ɂȂ邱Ƃ */
		return -1;
	}
	*addrp = addrmask(*addrp);

	passminsep();
	return 0;
}

static	getemptyaddr()
 /* G[-1A펞0AEOF1Ԃ */
{
	int	i;

	for(i = 8; i; i--){
		switch(getc(DMPINF)){
		case EOF: return 1;
		case ' ': continue;
		case '\t': break;
		default: return -1;
		}
		break;
	}

	passminsep();
	return 0;
}

static	us_long difaddr(addr, oaddr)
us_long	addr, oaddr;
{
	us_long	addrdif;

	addrdif = addr - oaddr;
	if(addr < oaddr){
		switch(plus_opt . addrfmtc){
		case OCTADDR:
			addrdif += (1L << (ADDRWID * 3)); break;
		case HEXADDR:
			addrdif += (1L << (ADDRWID * 4)); break;
		default: /* case DECADDR: */
			addrdif += EXP10ADDRWID; break;
		}
	}
	return addrdif;
}

static	us_long	r_od_star(dbufp, odbuf, oaddr, addr,
			readbytes, bytelenNow, warnout_addrp)
 /* '*'̏Bo͂oCgԂ */
dbufstr	*dbufp;
bufstr	*odbuf;
us_long	oaddr, addr;
us_int	readbytes, bytelenNow;
struct	warnout	*warnout_addrp;
{
	us_long	addrdif, omitlines, l;
	us_int	omitrest;

	if((addrdif = difaddr(addr, oaddr)) < bytelenNow){
		warn_prepare(warnout_addrp, addr);
		warnaddr(warnout_addrp);
		return 0L;
	}
	omitlines = (addrdif -= bytelenNow) / bytelen;
	 /* 2sڂ͒bytelenƍl */
	for(l = omitlines; l; --l){
		fwrite(dbufp -> mainbuf, 1, readbytes, odbuf -> objf);
	}
	omitrest = (us_int)(addrdif -= omitlines * bytelenNow);
	if(omitrest > readbytes) omitrest = readbytes;
	if(omitrest){
		fwrite(dbufp -> mainbuf, 1, omitrest, odbuf -> objf);
		warn_prepare(warnout_addrp, addr);
	}
	return readbytes * omitlines + omitrest;
}

static	void	r_od(f)
FILE	*f;
{
	/*  od -r outfile < dumped */
	us_long addr,	  /* dumped data̐擪̃AhXێB7 */
		realaddr, /* ۂundumpoCg𐔂ĂBS */
		oaddr;	  /* ÕAhX */
	us_int	readbytes, readbytes1, matchbytes, bytelenNow;
	struct	warnout	warnout_addr, warnout_size, warnout_addr2;
	 /* warnout_addr2͍Ō̍s̃TCYƃAhX̐HႢxp */

	if(!modeopt . optcount){
		cmd_errmsg("Can't undump.\n"), exit(2);
	}

	pass(thebuf . objf = f, 1);
	realaddr = plus_opt . offset;
	warn_clear(&warnout_addr), warn_clear(&warnout_size),
						 warn_clear(&warnout_addr2);

	if(noaddr){
		addr = realaddr;
	} else { /* 擪s̃AhXƂ̎1󔒂ǂ */
		switch(oaddr = addrmask(realaddr), getaddr(&addr)){
		case 0: /*  */
			if(addr != oaddr){
				warn_prepare(&warnout_addr, addr);
				warnaddr(&warnout_addr);
			}
			break;
		case 1: /* EOF */
			goto r_od_fin;
		default: /* G[exitB'*'̏ꍇ܂ */
			illaddr(oaddr);
		}
	}

	for(bytelenNow = bytelen1; ; bytelenNow = bytelen){
		outinfostr *outinfop;
		modestr	*modep;
		dbufstr	*cur_dbufp, *prv_dbufp;
		us_long	addrdif /* OAhXƂ̍ */, optrest;
		int	getad_ret;

		struct	{
			us_char	krestbuf[MAXMULCHR - 1];
			us_int	krestlen;
		} krestbak[2];

		outinfop = &outinfos[(modep = modeopt . optlist) -> optindx];
		prv_dbufp = &(thebuf . dumpbuf[thebuf . buf_sw]);
	     /*	cur_dbufp = &(thebuf . dumpbuf[thebuf . buf_sw ^= 1]); */
		cur_dbufp = &(thebuf . dumpbuf[thebuf . buf_sw ^ 1]);
					/* lqAƂŖ{iC */

		if(noaddr){
		 /* string dumps(u:vŎn܂)𖳎[uBu;vŎn܂
		    s߂ƂĖ(Undoc)Bȃ_vs͂ł
		    n܂Ȃc */
			int	cc;

			while((cc = peekc(DMPINF)) == ':' || cc == ';'){
				while((cc= getc(DMPINF)) != '\n' && cc != EOF);
			}
		}

		cur_dbufp -> krestignmode = 0;
		 /* l_in_wordȂǂĂŃf[^ǂ warnsizewarnaddr
		    ۂɌĂŌxô */
		switch(readbytes = (*(outinfop -> ifunc))(
						modep, cur_dbufp, outinfop)){
		case 0: /* AhX(or noaddrŃf[^Ȃ)̍ŏIsB
			   ꍇOs̃AhXTCYɊւx͏oȂ */
			if(EOF == peekc(DMPINF)){
				warnaddr(&warnout_addr2); /* A͏o */
				goto r_od_fin;
			}
			break;
		case (us_int)-1:
			illdata(noaddr ? realaddr : addr); /* exit */
		default: /* f[^݂̑sB
			    Os̃TCYAhXɊւx */
			warn_clear(&warnout_addr2); /* Ō̍sȊÕG[
					Ōɏôh */
			warnsize(&warnout_size); /* noaddrłs */
			warnaddr(&warnout_addr); /* noaddȑꍇx͏oȂ */
			break;
		} /* ǂ񂾃oCgreadbytesɓ */
		matchbytes = (cur_dbufp -> krestdifflg ? 0 : readbytes);
		 /* krestɐHႢꍇŏHႢƌȂ */
		cur_dbufp -> krestdifflg = 0;

		 /* tH[}bg_v̏ꍇAŏȊOǂ */
		memcpy(krestbak[0] . krestbuf, prv_dbufp -> krestbuf,
			krestbak[0] . krestlen = prv_dbufp -> krestlen);
		krestbak[1] . krestlen = 0;
		prv_dbufp -> krestignmode = 1;
		 /* for̊ԕςȂ̂1xZbg */
		for(optrest = modeopt . optcount; --optrest; ){
			outinfostr *eachinfop;

			eachinfop = &outinfos[(++modep) -> optindx];
			if(!noaddr){
				if(getemptyaddr() != 0){
					illdata(addr); /* G[exit(EOF) */
				}
			}

			if(eachinfop -> mulchr){
				memcpy(prv_dbufp -> krestbuf,
				       krestbak[0] . krestbuf,
				       prv_dbufp -> krestlen =
						krestbak[0] . krestlen);
			} else prv_dbufp -> krestlen = 0;
			 /* ܂܂l_in_wordȂǂĂ */
			readbytes1 = (*(eachinfop -> ifunc))(
						modep, prv_dbufp, eachinfop);
			if(readbytes1 == (us_int)-1)
				illdata(noaddr ? realaddr : addr); /* exit */

			 /* f[^̃TCYe̐HႢ̃`FbN */
			matchbytes = memncmp_pos(
			    cur_dbufp -> mainbuf, prv_dbufp -> mainbuf,
			    matchbytes < readbytes1 ? matchbytes : readbytes1);

			if(!eachinfop -> mulchr) continue;
			 /* krestbuf̐HႢ̃`FbN */
			if(krestbak[1] . krestlen < prv_dbufp -> krestlen){
				if(krestbak[1] . krestlen &&
				   memcmp(krestbak[1] . krestbuf,
					  prv_dbufp -> krestbuf,
					  krestbak[1] . krestlen)){
					cur_dbufp -> krestdifflg = 1;
				}
				memcpy(krestbak[1] . krestbuf,
				       prv_dbufp -> krestbuf,
				       krestbak[1] . krestlen =
						prv_dbufp -> krestlen);
			} else {
				if(prv_dbufp -> krestlen &&
				   memcmp(krestbak[1] . krestbuf,
					  prv_dbufp -> krestbuf,
					  prv_dbufp -> krestlen)){
					cur_dbufp -> krestdifflg = 1;
				}
			} /* LSI Cmemcmp()zero flagNAREPZ CMPSB
			     Ă邽ߑ30Ɣ0ɂȂ邱Ƃ */
		}
		memcpy(prv_dbufp -> krestbuf, krestbak[1] . krestbuf,
			prv_dbufp -> krestlen = krestbak[1] . krestlen);

		oaddr = addr;
		if(noaddr){
			addr = realaddr;
			addrdif = (us_long)bytelenNow;
		} else { /* ̍s̃AhXƂ̎1󔒂ǂ */
			switch(getad_ret = getaddr(&addr)){
			case 0: /* AhXɓǂ߂ */
				addrdif = difaddr(addr, oaddr); break;
			default: /* ȊO(G[A'*'AEOF) */
				addrdif = (us_long)bytelenNow; break;
			}
		}

		 /* f[^TCY߂ƏóAf[^šx */
		if(addrdif <= readbytes &&
		   readbytes - (us_int)addrdif < outinfop -> bytes){
			readbytes = (us_int)addrdif;
		}
		if(matchbytes < readbytes)
			warndata(noaddr ? realaddr : oaddr);
		 /* addr͊Ɏ̍ŝǂł̂oaddrg */
		fwrite(cur_dbufp -> mainbuf, 1, readbytes, thebuf . objf);
		realaddr += readbytes;

  /*
	(noaddrłȂƂ)getad_ret0Ȃ
		bytelenNowreadbytesȂc
			addřɃf[^sizex(oaddr)
			(noaddrłĂ̐Ƀf[^Όx)
			readbytes̕傫ꍇx
		addrdifbytelenNowƍȂc
			addřɃf[^addrx
			addrdif̕傫ꍇx
		addrdifreadbytesƍȂc
			addřɃf[^ȂƂaddrx
	1Ȃ
		bytelenNowreadbytesȂc
			readbytes̕傫ꍇsizex(oaddr)
		͌xoȂ
	2Ȃ1̃AhXaddrɓǂ
		bytelenNowreadbytesȂc
			sizex(oaddr)
		addrdifbytelenNow̐{ƍȂc
			addřɃf[^addrx
			(addrdif߂ꍇɌx)
		addrdifreadbytesƍȂc
			xȂ
  */
		if(bytelenNow != readbytes){
			 /* oaddrɑ΂Čxo */
			warn_prepare(&warnout_size, oaddr);
			if(bytelenNow < readbytes) warnsize(&warnout_size);
		}

		if(!noaddr){
			 /* ̍s̃AhX()ǂ߂Ă邩 */
			switch(getad_ret){
			case -1: /* G[exit */
				illaddr(oaddr);
			case 0: /* ɓǂ߂ */
				if((us_long)bytelenNow != addrdif){
					 /* addrɑ΂Čxo */
					warn_prepare(&warnout_addr, addr);
					if((us_long)bytelenNow < addrdif){
						warnaddr(&warnout_addr);
						break; /* warnout_addr2ɂ
							  xƏdȂ */
					}
				}
				if((us_long)readbytes != addrdif){
					 /* addrɑ΂Čxo
					    Ō̍ŝ */
					warn_prepare(&warnout_addr2, addr);
				}
				break;
			case 1: /* EOF(̍sɃf[^莟s
				   AhXȂ)̏ꍇ */
				goto r_od_fin;
			default: /* '*'̏ꍇ */
				warnsize(&warnout_size);
				 /* TCYႢ͒Ɍx */
				if(nonsp_getc(DMPINF) != '\n') illdata(addr);
				switch(getaddr(&addr)){
				 /* 1̃AhXǂ oaddrɂ
				    '*'1ÕAhXꂽ܂ */
				case 0: /*  */
					realaddr += r_od_star(cur_dbufp,
						&thebuf, oaddr, addr,
						readbytes, bytelenNow,
						&warnout_addr);
					 /* oaddr̃`FbN͂̒ */
					break;
				default: /* ȊO */
					illaddr(oaddr);
				}
				break;
			}
		}
	}
r_od_fin:
	if(ferror(f) || EOF == fflush(f)) write_err();
	if(dotrunc){
#ifndef MSDOS
		if(0 != ftruncate(fileno(f), (long)realaddr) &&
		   errno == EIO)
			write_err();
#else
		ftruncate(fileno(f), (long)realaddr);
		 /* Ƃ肠G[͂Ȃ */
#endif
	}
}

static	void	od(f)
FILE	*f; /* f must be in binary mode */
{
	us_int	readbytes;
	us_long addr;

	if(pass(thebuf . objf = f, 0) != 0L){
		cmd_errmsg("Input past end\n"); exit(1);
	}
	addr = addrmask(plus_opt . offset);

	if(bytelen1 != bytelen){
	 /* ̏ꍇAf[^̓̕łɔȗ */
		readbytes = odread(&thebuf, bytelen1);
		if(!readbytes) goto dump_fin;
		lineout(&thebuf, readbytes, addr);
		addr = addrmask(addr + (us_long)readbytes);
	}
	if(alldata){
		for(;;){
			readbytes = odread(&thebuf, bytelen);
			if(!readbytes) break;
			lineout(&thebuf, readbytes, addr);
			addr = addrmask(addr + (us_long)readbytes);
		}
	} else {
		bool	repeat_flg;

		readbytes = odread(&thebuf, bytelen);
	newread:
		if(!readbytes) goto dump_fin;
		lineout(&thebuf, readbytes, addr);
		addr = addrmask(addr + (us_long)readbytes);

		for(repeat_flg = 0;;){
			readbytes = odread(&thebuf, bytelen);
			if(!readbytes) break;

			if(diffline(&thebuf, readbytes)) goto newread;
			 /* ȊȌꍇAlineoutĂ΂Ȃ̂ŁA
			    stringsoutOŌĂ */
			if(strings) stringsout(&thebuf, readbytes, addr);

			addr = addrmask(addr + (us_long)readbytes);
			if(!repeat_flg){
				putc('*', DMPOUTF), putc('\n', DMPOUTF);
				repeat_flg = 1;
			}
		}
	}
dump_fin:
	if(ferror(f)) read_err();
	if(strings) stringsrealout(0L, &stringsbuf, stringsbuf . len,
							(us_char *)NULL, 0);
	 /* t@CŏÎ͑ΏۂɊ܂߂ */
	if(!noaddr && modeopt . optcount){
		fprintf(DMPOUTF, plus_opt . addrfmt, addr); /* AhXo */
		if(EOF == putc('\n', DMPOUTF)) write_err();
	}
	/* if(f != stdin) fclose(f); */
	if(EOF == fflush(DMPOUTF)) write_err();
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c;
	char	*p;
	extern	char	*optarg;
	extern	int	optind, opterr;
	FILE	*objfile;
	bool	xd = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(!strcmp(cmdname, "xd")) xd = 1;

	opterr = 0;
	signal(SIGFPE, SIG_IGN);
	while(EOF != (c = egetopt(ac, av,
				"abBcCMdDfFhHmoOsSxXnNrvzZTque:w:W:t;"))){
		cswitch(c){
		case 'w': bytelen = atoi(optarg); break;
		case 'W': bytelen1 = atoi(optarg); break;
		case 'v': alldata = 1; break;
		case 'e': do_e_opt(optarg); break;
		case 'n': noaddr = 1; break;
		case 'z': hexmode ^= 1; break;
		case 'Z': xd ^= 1; break;
		case 'N': minsepwid = 0; break;
		case 'r': undump = 1; break;
		case 'T': dotrunc = 1; break;
		case 'q': nowarn = 1; break;
		case 'u': nojischk = 1; break;
		case 't': do_t_opt(optarg == NULL ? NULSTR : optarg); break;
		case 'B': c = 'o'; goto common;
		case 'h': c = 'x'; goto common;
		case 'H': c = 'X'; goto common;
		default:
		common:
			if(0 != do_dumpmode_opt(c)) usage(); break;
		}
	}
	hexmode ^= xd;
	plus_opt . addrfmtc = plus_opt . raddrfmtc =
	    (char)(xd ? HEXADDR : OCTADDR); /* AhX̕\`̃Zbg */
	if(!bytelen1) bytelen1 = bytelen;
	if(!modeopt . optcount){
		if(!strings){
			do_dumpmode_opt(xd ? 'x' : 'o');
			 /* ftHgo͌`-o-x */
		} else {
			alldata = 1; /* '*'̂ */
		}
	}
	dumpmode_init();

	ac -= optind, av += optind;
	if(ac && *(p = av[ac - 1]) == '+'){
		do_plus_opt(p, xd ? HEXADDR : OCTADDR), --ac;
		 /* _vItZbg߁BftHg̉߂8i
		    16i̓R}hɂ */
	}

	alloc_bufs();

	switch(ac){
	case 1:
		if(*(p = *av) != '-' || p[1]){
			if(undump){
				if(NULL != (objfile = fopen(p, "r+")) ||
				   errno == ENOENT &&
				   NULL != (objfile = fopen(p, "w+"))) break;
			} else {
				if(NULL != (objfile = fopen(p, "r"))) break;
			}
			cmd_errmsg(s_conv_to_unix_format(p));
			fputs(": Can't open\n", stderr);
			exit(2);
		} /* else through */
	case 0:
		objfile = undump ? stdout : stdin;
		break;
	default:
		usage();
	}
	fsetbin(objfile);
	if(NULL != ivbuf && 0 != setfbuf(objfile, ivbuf, ivbufsiz)) cantbuf();
	(undump ? r_od : od)(objfile);
	return 0;
}
