#ifndef _REGEXP_H
#define _REGEXP_H

#ifdef TOOLS /* for tools, Nide */
#  include "tools.h"
#else
#  define ARGDECL(X) ()
#endif

/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#define NSUBEXP  10
typedef struct regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;

regexp	*regcomp ARGDECL((char *));
int	re_strcmp ARGDECL((char *, char *, char *));
int	regexec ARGDECL((regexp *, char *));
void	regsub ARGDECL((regexp *, char *, char *));
void	regerror ARGDECL((char *));

/* Add Nide */
#include <string.h>
#ifndef OLD_C
#  include <malloc.h>
#else
char	*malloc();
void	free();
#endif

#endif /* _REGEXP_H */

