#include <stdio.h>
#ifndef UX_COMPILE_TEST
#  include <direct.h>
#endif
#include <string.h>
#include <errno.h>
#include "tools.h"

char	*cmdname = "removdir";

main(ac, av)
int	ac;
char	**av;
{
	int	error = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(++av, !--ac){
		_puterrmes("Usage: "), _puterrmes(cmdname),
		_puterrmes_cr(" DIRECTORY..."), exit(1);
	}
	for(; ac; --ac, ++av){
		if(rmdir(*av)){
			_cmdputerrmes(conv_to_unix_format(*av));
			_puterrmes_cr(errno == ENOENT ?
					": Not exist" : ": Can't remove");
			error = 1;
		}
	}
	return error;
}
