#include <stdio.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include "tools.h"

#define NOEVAL 01
#define INBRAC 02
#define is_CLOSBR(s) !strcmp((s), ")")
#define is_OPENBR(s) !strcmp((s), "(")
#define is_OPRTOR(s) (*(s) == '-')

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = -1;
	expand_hook_default();
}
#endif

static	void	sn_error()
{
	_cmdputerrmes_cr("Syntax error"), exit(-1);
}

#ifdef LSI_C
static	int	isatty(fd)
register int	fd;
 /* isatty(unopened_fd)1Ԃ񂾂낤:-( */
{
	union	REGS	in, out;

	in . x . ax = 0x4400;
	in . x . bx = fd;
	in . x . dx = 0; /* ??? */
	intdos(&in, &out);
	return(!out . x . cflag && (out . x . ax & 0x80));
}
#endif

static	int	isvol(s)
char	*s;
{
	static	char	templete[] = "?:/*.*";
	char	*p = templete;
	struct	find_t	t;

	if(!contains_nowild(s)) return 0;

	if(drive_headed(s)) *p = *s; else p += 2;
	if(_dos_sfindfirst(p, _A_VOLID, &t)) return 0;
	 /* pu*.*vȂ֌WȂÕ{[x镾Q
	    NȂ?? */

	s = filename_base(s), p = t . name;
	if(NULL == strchr(p, '.') || NULL != strchr(s, '.'))
		return !kstricmp(p, s);
	else
		return !kstrnicmp(p, s, 8) && strlen(p) > 8 && p[8] == '.' &&
		       !kstricmp(p + 9, s + 8);
}

#if 0 /* previous version */
static	int	isvol(s)
char	*s;
{
	int	ret;
	char	*p = chk_malloc(strlen(s) + 2), *q, *r;
	struct	find_t	t;

	strcpy(q = p, r = s);
	if(is_alpha(*r) && r[1] == DRIVE_SEP) q += 2, r += 2;
	if(NULL == strchr(r, '.') && strlen(r) > 8)
		*(q += 8) = '.', strcpy(++q, r += 8), s = p;

	if(0 != (ret = (contains_nowild(s) && !_dos_findfirst(s, 0x3f, &t)))){
	 /* _dos_findfirst()̑2P_A_VOLIDƁAlbg[NhCu
	    ŁA^OƊ֌WȂ{[x邱Ƃ?? */
		while(!isVOLattr(t . attrib)){
			if(0 != _dos_findnext(&t)){
				ret = 0;
				break;
			}
		}
	}
	free(p);
	return ret;
}
#endif

static	int	fnewer(fcur, fbuf)
struct	Find_t	*fcur, *fbuf;
{
#ifdef SUPP_LFN
	return(*((us_long *)fcur -> mtime) > *((us_long *)fbuf -> mtime));
#else
	return(fcur -> wr_date > fbuf -> wr_date ||
	       fcur -> wr_date == fbuf -> wr_date &&
	       fcur -> wr_time > fbuf -> wr_time);
#endif
}

static	int	evalfmla(), evalterm(), evalsterm(), evalprim();

main(ac, av)
int	ac;
char	*av[];
{
	int	val;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
	notrap();

	if(*cmdname == '_' || *cmdname == '[' && !cmdname[1]){
		if(*av[--ac] != ']' || av[ac][1]) sn_error();
		av[ac] = NULL;
	}

	--ac, ++av;
	if(!ac) exit(1);
	val = evalfmla(&ac, &av, 0);
	if(val < 0 || ac) sn_error();
	return !val; /* returnR[h0^ł */
}

/* n test ), test ) = ), test -t a = a, test a b = c */

static	int	uniop(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
 /* p͔ȂeXg΂ł */
{
	int	val;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	if(!strcmp(av[0] + 1, "t")){
		if(ac == 1 || is_OPRTOR(av[1]) ||
		   (flg & INBRAC) && is_CLOSBR(av[1])){
			val = isatty(1);
			--ac, ++av;
		} else {
			val = isatty(atoi(av[1]));
			ac -= 2, av += 2;
		}
	} else {
		if(ac == 1) return -1;
		if(!strcmp(av[0] + 1, "n")) val = av[1][0];
		 else
		if(!strcmp(av[0] + 1, "z")) val = !av[1][0];
		 else {
			switch(av[0][1]){
			case 'c': case 'd': case 'e': case 'r':
			case 's': case 'w': case 'x':
			case 'T': case 'B': case 'v': /* s1t*/
				if(av[0][2]) return -1; else break;
			case 'f':
				switch(av[0][2]){
				case 'a': case 'h': case 's': /* s2t*/
					if(av[0][3]) return -1; else break;
				case '\0':
					break;
				default:
					return -1;
				}
				break;
			default:
				return -1;
			}

			if(!(flg & NOEVAL))
			{
				struct	Find_t	fbuf;
				char	fatr;

				if(av[0][1] == 'v'){
					val = isvol(av[1]);
				} else if(find_Fixedfile(av[1], &fbuf, 1)){
					val = 0;
				} else {
					fatr = (char)fbuf . attrib;
					switch(av[0][1]){
					 /* ʂ́s1tł */
					case 'c':
						val = (_A_DEV & fatr);
						break;
					case 'd':
						val = (_A_SUBDIR & fatr);
						break;
					case 'e': case 'r':
						val = 1;
						break;
					case 's':
#ifdef SUPP_LFN
						val = (0L != fbuf . lsize ||
						       0L != fbuf . hsize);
#else
						val = (0L != fbuf . size);
#endif
						break;
					case 'w':
						val = !(_A_RDONLY & fatr);
						break;
					case 'x':
						val = is_executable(&fbuf);
						break;
					case 'B':
						val = !((_A_SUBDIR | _A_DEV |
						    _A_VOLID) & fatr) &&
						  !is_textfile(av[1]);
						break;
					case 'T':
						val = !((_A_SUBDIR | _A_DEV |
						    _A_VOLID) & fatr) &&
						  is_textfile(av[1]);
						break;
					default: /* case 'f': */
						switch(av[0][2]){
						 /* ʂ́s2tł */
						case 'a':
							val = (_A_ARCH & fatr);
							break;
						case 'h':
							val=(_A_HIDDEN & fatr);
							break;
						case 's':
							val=(_A_SYSTEM & fatr);
							break;
						default: /* case '\0': */
							val =
							 !((_A_SUBDIR |
							    _A_DEV |
							    _A_VOLID) & fatr);
							break;
						}
						break;
					}
				}
			}
		}
		ac -= 2, av += 2;
	}

	*avp = av, *acp = ac;
	return !(flg & NOEVAL) && val;
}

static	int	binop(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
 /* p͔ȂeXg΂ł */
{
	int	val;
	char	opfound = 0;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	if(ac >= 3 && !((flg & INBRAC) && is_CLOSBR(av[1]))){
		if(!strcmp(av[1], "=")){
			val = !strcmp(av[0], av[2]); opfound++;
		} else
		if(!strcmp(av[1], "!=")){
			val = strcmp(av[0], av[2]); opfound++;
		} else
		if(!strcmp(av[1], "-eq")){
			val = (atoi(av[0]) == atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-ne")){
			val = (atoi(av[0]) != atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-gt")){
			val = (atoi(av[0]) > atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-ge")){
			val = (atoi(av[0]) >= atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-lt")){
			val = (atoi(av[0]) < atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-le")){
			val = (atoi(av[0]) <= atoi(av[2])); opfound++;
		} else
		if(!strcmp(av[1], "-ot") || !strcmp(av[1], "-nt") ||
		   !strcmp(av[1], "-ef")){
			struct	Find_t	fbufA, fbufB;

			if(find_Fixedfile(av[0], &fbufA, 1) != 0 ||
			   find_Fixedfile(av[2], &fbufB, 1) != 0){
				val = 0;
			} else switch(av[1][1]){
			case 'n':
				val = fnewer(&fbufA, &fbufB);
				break;
			case 'o':
				val = fnewer(&fbufB, &fbufA);
				break;
			default: /* case 'e': */
				val = (chk_recursive(av[0], av[2]) < 0);
				break;
			}
			opfound++;
		} else
		if(!is_OPRTOR(av[1])){
			sn_error();
		}
	}

	if(opfound){
		ac -= 3, av += 3;
	} else {
		val = av[0][0];
		--ac, ++av;
	}

	*avp = av, *acp = ac;
	return !(flg & NOEVAL) && val;
}

static	int	evalfmla(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
 /* flg & 01 1ɂȂƔ]ac, av̂ݐival͂ȏςȂ */
 /* formulaȂac, avi߂ɕԂ(flg & 01 1ł) */
{
	int	first, val, tmpval;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(first = 1, val = 0; ; first = 0){
		if(0 > (tmpval = evalterm(&ac, &av, flg))){
			if(first) return tmpval; else sn_error();
			 /* return l Ƃƌac, av͓
			    cBłl */
		}
		if(!(flg & NOEVAL) && !val) val = tmpval;
		if(val) flg |= NOEVAL;

		if(ac && !strcmp(*av, "-o")){
			--ac, ++av;
		} else break;
	}

	*avp = av, *acp = ac;
	return val;
}

static	int	evalterm(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
{
	int	first, val, tmpval;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(first = val = 1; ; first = 0){
		if(0 > (tmpval = evalsterm(&ac, &av, flg))){
			if(first) return tmpval; else sn_error();
		}
		if(!(flg & NOEVAL) && val) val = tmpval;
		if(!val) flg |= NOEVAL;

		if(ac && !strcmp(*av, "-a")){
			--ac, ++av;
		} else break;
	}

	*avp = av, *acp = ac;
	return val;
}

static	int	evalsterm(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
{
	int	val, notcnt;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(notcnt = 0; ac && !strcmp(*av, "!"); ){
		++notcnt, --ac, ++av;
	}
	if(ac && is_OPENBR(*av)){
		--ac, ++av;
		if(0 > (val = evalfmla(&ac, &av, flg | INBRAC)) ||
		   !ac || !is_CLOSBR(*av)){
			sn_error();
		}
		--ac, ++av;
	} else {
		if(0 > (val = evalprim(&ac, &av, flg))){
			if(notcnt) sn_error(); else return val;
		}
	}

	*avp = av, *acp = ac;
	return (notcnt % 2) ? !val : val;
}

static	int	evalprim(acp, avp, flg)
int	*acp;
char	***avp;
int	flg;
{
	int	val;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	if(!ac || (flg & INBRAC) && is_CLOSBR(*av)) return -1;
	if(is_OPRTOR(*av)){
		if(0 > (val = uniop(&ac, &av, flg))) return val;
	} else {
		if(0 > (val = binop(&ac, &av, flg))) return val;
	}

	*avp = av, *acp = ac;
	return val;
}
