#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include <memory.h>

#ifdef TOOLS
     /* UNIX-like tools1ƂăRpCEzzꍇ͂define
	APƂŃRpCꍇdefineȂ */
#  include "tools.h"
#else /* TOOLS */
#  include <malloc.h>
typedef	unsigned char	us_char;
typedef	unsigned int	us_int;
typedef	unsigned long	us_long;
typedef us_char	bool;
#  define setfbuf(f, b, n) setvbuf((f), (b), _IOFBF, (n))
#  define is_xdigit(c) (isascii(c) && isxdigit(c))
#  define is_digit(c) (isascii(c) && isdigit(c))
#  define is_lower(c) (isascii(c) && islower(c))
#  define ctoi(c) \
	((c) - (is_digit(c) ? '0' : is_lower(c) ? 'a' - 10 : 'A' - 10))
#  define fsetbin(f) 0
#  define s_conv_to_unix_format(s) (s)
#  define setcmdname(av0)		\
	do{				\
		if(NULL != (cmdname = strrchr(av0, '/'))) cmdname++; \
		 else cmdname = av0;	\
	} while(0)
#endif /* TOOLS */

char	*cmdname = "yakc";

#define	SI	0xf
#define	SO	0xe
#define	ESC	0x1b
#define SS2	0x8e
#define SS3	0x8f
#define ASS2	0x19 /* Alternative SS2, SS2Ɠ */
#define ASS3	0x1d /* Alternative SS3, SS3Ɠ */
#define DOSEOF	0x1a
#define	GETA	0x222e /*  */
#define	GETA_MS	"\201\254" /*  in MSCODE */
static	char	*SEQMOD = "\033&@";

#define UBUFSIZ 1024
static	int	unget_sp = 0;
static	us_int	unget_buf[UBUFSIZ];
 /* Oungetcpobt@BႤt@C݂ɓǂނƂ͂ȂƉ肵ĂB
    R[hʗpobt@p */
#define getch(inf) (unget_sp ? unget_buf[--unget_sp] : (us_int)getc(inf))
#define ungetch(c) (unget_buf[unget_sp++] = (c))
 /* ungetcĥi_eolcnvi_ignctlz̏Ȃ悤ɂĂ */
#define peekch(inf) \
	(unget_sp ? unget_buf[unget_sp - 1] : ungetch((us_int)getc(inf)))

typedef us_long	wchar4b;  /* 4oCg */
 /* 2oCgɕZbg(us_int)A2oCg͕R[h
    us_intœĂ (int4oCg̃}VłxȂ悤ɏ) */

#define whatset(c) (us_int)((c) >> 16) /* c:wchar4b */
   /* ̉2oCĝݗL
      (邢͂rmvbufinfo)0Ɛ䕶ςȕ
      ̏ꍇ*_wgetc()Ԃlgetcœꂽwchar4bcast */
#ifdef MSDOS
#  define wctoc(c) (us_int)(c) /* c:wchar4b, Ԃlus_int */
#else
#  define wctoc(c) ((us_int)(c) & 0xffff)
#endif

#define ctowc(c) (wchar4b)(c)	/* c:us_int (getc()̕Ԃlus_int) */
	 /* EOFɂ͓KpA0xffffԂƁBint4oCg̏ꍇB*/
#define uEOF ((us_int)EOF)
#define wEOF ctowc(EOF & 0xffff)
#define wEmpty (wchar4b)0

 /* wchar4b̏2oCg(us_int)ɂ */
#define TERMCHARMASK	0xff00
#define termch(x)	((x) >> 8)	/* x:us_int, 0͂ȂƑO񂵂Ă */
#define termchmask(c)	((c) << 8)	/* c:us_int, 0`127ƑO
		ԕ0x21p镶Zbgɑ΂Ă8rbgڂ𗧂Ăĕ\
		Zbgȏɑc̕Kv */
#define SETINFOMASK	0xf8
#define MULBYTECHAR	0x08	/* SS2E3Ƃ͕oCg͍̏
				   S2oCgƎvď */
#define ROMANSET	0x10	/* [}Zbgŗ */
#define JKANJITREAT	0x20	/* JISE⏕AJIS X02131/2ʂ
				   eZbgŗB݂̂Ƃۂ
				   2oCĝ͂ꂪꍇ
				   ASS2E3̒ł͕oCg
				   S2oCgƌȂ */
#define SPECIALSET	0x40	/* designateV[PX̏o͂ɓ
				   ʈv镶Zbg̏ꍇ
				   ݂̂ƂJIS90EPCEPCp */
#define CHARSET96	0x80
 /* ȉ̃rbg*_wgetc()̕Ԃlɂ͗iostat[n].Gbuf[m]
    iostat[n].GLR[i].setɂ͗Ȃ */
#define G0		0x00
#define G1		0x01
#define G2		0x02
#define G3		0x03 /* G0`G3͏Â */
#define SNGLSFT		0x04
#define G2_SS7bit	(0x00 | SNGLSFT)
#define G3_SS7bit	(0x01 | SNGLSFT)
#define G2_SS8bit	(0x02 | SNGLSFT)
#define G3_SS8bit	(0x03 | SNGLSFT)
 /* wctoc(c)̏ʃoCg0łȂ8rbgڂ16rbgڂقȂ
    ̂SNGLSFT̂ */
#define GBUFNUMMASK	(0x03 | SNGLSFT)
#define gbufno(x)	((x) & GBUFNUMMASK)
				/* 0`3 邢͂SNGLSFT̗ */
#define rmvbufinfo(x) ((x) & ~GBUFNUMMASK)

 /* *_wgetc()̕Ԃlɂ͗Ȃ
    ɕR[h̍ŏʃrbg */
#define GL	0
#define GR	1

#define istermch(c) ('0' <= (c) && (c) <= 0x7e) /* c:2] */
				/* {ɂł? */
#define desigch2bufno(c) (us_int)((c) - '(' + G0)
#define desig96ch2bufno(c) (us_int)((c) - '-' + G1)

#define JIS78K	 (termchmask('@') | MULBYTECHAR | JKANJITREAT)
#define JIS83K	 (termchmask('B') | MULBYTECHAR | JKANJITREAT)
#define JIS90K	 (termchmask('B') | MULBYTECHAR | JKANJITREAT | SPECIALSET)
#define PCKANJI	 (termchmask('@') | MULBYTECHAR | JKANJITREAT | SPECIALSET)
 /* JIS78K̕ό`BJIS90KƏdȂȂ悤A83K̕ό`Ƃ͂Ȃ
    G0ȊOdesignate͂߂ɂȂJIS78KƓV[PXg */
#define JISSUPK	 (termchmask('D') | MULBYTECHAR | JKANJITREAT)
 /* ⏕̕Zbg */
#define ASCIISET (termchmask('B') | ROMANSET)
#define JISROMAN (termchmask('J') | ROMANSET)
#define PCROMAN	 (termchmask('J') | ROMANSET | SPECIALSET)
 /* JISROMAN̕ό` */
#define JISKANA	 (termchmask('I'))
 /* JiZbg͂1 PC̃JiJISKANAōς܂ */
#define LATIN1SET (termchmask('A') | CHARSET96)
#define CNGBSET	  (termchmask('A') | MULBYTECHAR)
#define SWNAMSET  (termchmask('H'))
#define J213K1	 (termchmask('O') | MULBYTECHAR | JKANJITREAT)
#define J213K2	 (termchmask('P') | MULBYTECHAR | JKANJITREAT)
 /* JIS X0213̑1/2 */
#define UNK_SET	  0 /* ꂪGbuf[n]GLR[n].setɓĂΕZbg */

 /* regularizepΉ\ */
static	unsigned char	Conv21tbl[ ] = {
	      ' ',  '\0', '\0', ',',  '.',  '\0', ':',
	';',  '?',  '!',  '\0', '\0', '\0', '\0', '\0',
	'^',  '\0', '_',  '\0', '\0', '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '/',
	'\\', '~',  '\0', '|',	'\0', '\0', '`',  '\'',
	'\0', '"',  '(',  ')',	'\0', '\0', '[',  ']',
	'{',  '}',  '\0', '\0', '\0', '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '+',  '-',  '\0', '\0',
	'\0', '=',  '\0', '<',	'>',  '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
	'$',  '\0', '\0', '%',	'#',  '&',  '*',  '@',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0',
};
#define Conv21(x) Conv21tbl[(x) - 0x21]
static	unsigned char	Convjisktbl[ ] = {
	      0xa3, 0xd6, 0xd7, 0xa2, 0xa6, 0x72, 0x21,
	0x23, 0x25, 0x27, 0x29, 0x63, 0x65, 0x67, 0x43,
	0xbc, 0x22, 0x24, 0x26, 0x28, 0x2a, 0x2b, 0x2d,
	0x2f, 0x31, 0x33, 0x35, 0x37, 0x39, 0x3b, 0x3d,
	0x3f, 0x41, 0x44, 0x46, 0x48, 0x4a, 0x4b, 0x4c,
	0x4d, 0x4e, 0x4f, 0x52, 0x55, 0x58, 0x5b, 0x5e,
	0x5f, 0x60, 0x61, 0x62, 0x64, 0x66, 0x68, 0x69,
	0x6a, 0x6b, 0x6c, 0x6d, 0x6f, 0x73, 0xab, 0xac,
     /*	0x70, 0x71, 0x6e, 0x75, 0x76, 0x74, 0x2c, 0x2e,
	0x30, 0x32, 0x34, 0x36, 0x38, 0x3a, 0x3c, 0x3e,
	0x40, 0x42, 0x45, 0x47, 0x49, 0x50, 0x51, 0x53,
	0x54, 0x56, 0x57, 0x59, 0x5a, 0x5c, 0x5d, */
};
#define Convjisk(x) Convjisktbl[(x) - 0x21]

 /* TOG/JVCɂMSR[hFA40`FC4B(IBMg)JISX0208/0212ւ̕ϊ\
    MSB0c1(ʏJIS X0208)
    MSB1c2(ʏJIS X0212) */
static	us_int	tog_msgaiji_to_jis[] = {
	 /* fa40 */
	0xf3f3, 0xf3f4, 0xf3f5, 0xf3f6,	0xf3f7, 0xf3f8, 0xf3f9, 0xf3fa,
	0xf3fb, 0xf3fc, 0xf3fd, 0xf3fe,	0xf4a1, 0xf4a2, 0xf4a3, 0xf4a4,
	0xf4a5, 0xf4a6, 0xf4a7, 0xf4a8,	0x224c, 0xa2c3, 0xf4a9, 0xf4aa,
	0xf4ab, 0xf4ac, 0xf4ad, 0x2268,	0xd4e3, 0xdcdf, 0xe4e9, 0xe3f8,
	0xd9a1, 0xb1bb, 0xf4ae, 0xc2ad,	0xc3fc, 0xe4d0, 0xc2bf, 0xbcf4,
	0xb0a9, 0xb0c8, 0xf4af, 0xb0d2,	0xb0d4, 0xb0e3, 0xb0ee, 0xb1a7,
	0xb1a3, 0xb1ac, 0xb1a9, 0xb1be,	0xb1df, 0xb1d8, 0xb1c8, 0xb1d7,
	0xb1e3, 0xb1f4, 0xb1e1, 0xb2a3,	0xf4b0, 0xb2bb, 0xb2e6,
	0xb2ed,	0xb2f5, 0xb2fc, 0xf4b1, 0xb3b5,	0xb3d8, 0xb3db, 0xb3e5,
	0xb3ee,	0xb3fb, 0xf4b2, 0xf4b3, 0xb4c0,	0xb4c7, 0xb4d0, 0xb4de,
	0xf4b4,	0xb5aa, 0xf4b5, 0xb5af, 0xb5c4,	0xb5e8, 0xf4b6, 0xb7c2,
	0xb7e4,	0xb7e8, 0xb7e7, 0xf4b7, 0xf4b8,	0xf4b9, 0xb8ce, 0xb8e1,
	0xb8f5,	0xb8f7, 0xb8f8, 0xb8fc, 0xb9af,	0xb9b7, 0xbabe, 0xbadb,
	0xcdaa,	0xbae1, 0xf4ba, 0xbaeb, 0xbbb3,	0xbbb8, 0xf4bb, 0xbbca,
	0xf4bc,	0xf4bd, 0xbbd0, 0xbbde, 0xbbf4,	0xbbf5, 0xbbf9, 0xbce4,
	0xbced,	0xbcfe, 0xf4be, 0xbdc2, 0xbde7,	0xf4bf, 0xbdf0, 0xbeb0,
	0xbeac,	0xf4c0, 0xbeb3, 0xbebd, 0xbecd,	0xbec9, 0xbee4, 0xbfa8,
	0xbfc9,	0xc0c4, 0xc0e4, 0xc0f4, 0xc1a6,	0xf4c1, 0xc1f5, 0xc1fc,
	0xf4c2,	0xc1f8, 0xc2ab, 0xc2a1, 0xc2a5,	0xf4c3, 0xc2b8, 0xc2ba,
	0xf4c4,	0xc2c4, 0xc2d2, 0xc2d7, 0xc2db,	0xc2de, 0xc2ed, 0xc2f0,
	0xf4c5,	0xc3a1, 0xc3b5, 0xc3c9, 0xc3b9,	0xf4c6, 0xc3d8, 0xc3fe,
	0xf4c7,	0xc4cc, 0xf4c8, 0xc4d9, 0xc4ea,	0xc4fd, 0xf4c9, 0xc5a7,
	0xc5b5,	0xc5b6, 0xf4ca, 0xc5d5, 0xc6b8,	0xc6d7, 0xc6e0, 0xc6ea,
	0xc6e3,	0xc7a1, 0xc7ab, 0xc7c7, 0xc7c3,
	 /* fb40 */
	0xc7cb, 0xc7cf, 0xc7d9, 0xf4cb, 0xf4cc, 0xc7e6, 0xc7ee, 0xc7fc,
	0xc7eb, 0xc7f0, 0xc8b1, 0xc8e5, 0xc8f8, 0xc9a6, 0xc9ab, 0xc9ad,
	0xf4cd, 0xc9ca, 0xc9d3, 0xc9e9, 0xc9e3, 0xc9fc, 0xc9f4, 0xc9f5,
	0xf4ce, 0xcab3, 0xcabd, 0xcaef, 0xcaf1, 0xcbae, 0xf4cf, 0xcbca,
	0xcbe6, 0xcbea, 0xcbf0, 0xcbf4, 0xcbee, 0xcca5, 0xcbf9, 0xccab,
	0xccae, 0xccad, 0xccb2, 0xccc2, 0xccd0, 0xccd9, 0xf4d0, 0xcdbb,
	0xf4d1, 0xcebb, 0xf4d2, 0xceba, 0xcec3, 0xf4d3, 0xcef2, 0xb3dd,
	0xcfd5, 0xcfe2, 0xcfe9, 0xcfed, 0xf4d4, 0xf4d5, 0xf4d6,
	0xf4d7, 0xd0e5, 0xf4d8, 0xd0e9, 0xd1e8, 0xf4d9, 0xf4da, 0xd1ec,
	0xd2bb, 0xf4db, 0xd3e1, 0xd3e8, 0xd4a7, 0xf4dc, 0xf4dd, 0xd4d4,
	0xd4f2, 0xd5ae, 0xf4de, 0xd7de, 0xf4df, 0xd8a2, 0xd8b7, 0xd8c1,
	0xd8d1, 0xd8f4, 0xd9c6, 0xd9c8, 0xd9d1, 0xf4e0, 0xf4e1, 0xf4e2,
	0xf4e3, 0xf4e4, 0xdcd3, 0xddc8, 0xddd4, 0xddea, 0xddfa, 0xdea4,
	0xdeb0, 0xf4e5, 0xdeb5, 0xdecb, 0xf4e6, 0xdfb9, 0xf4e7, 0xdfc3,
	0xf4e8, 0xf4e9, 0xe0d9, 0xf4ea, 0xf4eb, 0xe1e2, 0xf4ec, 0xf4ed,
	0xf4ee, 0xe2c7, 0xe3a8, 0xe3a6, 0xe3a9, 0xe3af, 0xe3b0, 0xe3aa,
	0xe3ab, 0xe3bc, 0xe3c1, 0xe3bf, 0xe3d5, 0xe3d8, 0xe3d6, 0xe3df,
	0xe3e3, 0xe3e1, 0xe3d4, 0xe3e9, 0xe4a6, 0xe3f1, 0xe3f2, 0xe4cb,
	0xe4c1, 0xe4c3, 0xe4be, 0xf4ef, 0xe4c0, 0xe4c7, 0xe4bf, 0xe4e0,
	0xe4de, 0xe4d1, 0xf4f0, 0xe4dc, 0xe4d2, 0xe4db, 0xe4d4, 0xe4fa,
	0xe4ef, 0xe5b3, 0xe5bf, 0xe5c9, 0xe5d0, 0xe5e2, 0xe5ea, 0xe5eb,
	0xf4f1, 0xf4f2, 0xf4f3, 0xe6e8, 0xe6ef, 0xe7ac, 0xf4f4, 0xe7ae,
	0xf4f5, 0xe7b1, 0xf4f6, 0xe7b2, 0xe8b1, 0xe8b6, 0xf4f7, 0xf4f8,
	0xe8dd, 0xf4f9, 0xf4fa, 0xe9d1, 0xf4fb,
	 /* fc40 */
	0xe9ed, 0xeacd, 0xf4fc, 0xeadb, 0xeae6, 0xeaea, 0xeba5, 0xebfb,
	0xebfa, 0xf4fd, 0xecd6, 0xf4fe
};
#define FA40_FC4B_CHARS \
	(sizeof(tog_msgaiji_to_jis) / sizeof(tog_msgaiji_to_jis[0]))

 /* MSR[hg̈悩JIS X0213 2ʂւ̃}bsOƂ̋tB
    MSR[hf040`UzIȕZbg2121`3a7eɊ蓖ĂāA
    ̋X0213̋Ƃ̑Ή */
static	us_char	msgaiji_to_x0213_tbl[] = {
	      0x21, 0x28, 0x23, 0x24, 0x25, 0x2c, 0x2d,
	0x2e, 0x2f, 0x6e, 0x6f, 0x70, 0x71, 0x72, 0x73,
	0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b,
	0x7c, 0x7d, 0x7e
};
#define msgaiji_to_x0213(x) msgaiji_to_x0213_tbl[(x) - 0x21]
static	us_char	x0213_to_msgaiji_tbl[] = {
 /* ̋tΉBR[hJIS X0212X0213̂ǂɂ邩̔茓p */
	      0x21, 0,    0x23, 0x24, 0x25, 0,    0,
	0x22, 0,    0,    0,    0x26, 0x27, 0x28, 0x29,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0,    0,
	0,    0,    0,    0,    0,    0,    0x2a, 0x2b,
	0x2c, 0x2d, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33,
	0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a
};
#define x0213_to_msgaiji(x) x0213_to_msgaiji_tbl[(x) - 0x21]

typedef struct {
	us_int	lb, ub;
} ranges;
static	ranges	x0208_range[ ] = {
	{0, 0}, /* ԕ */

	{0x2121, 0x222e}, /* @- */
	{0x223a, 0x2241}, /* - */
	{0x224a, 0x2250}, /* - */
	{0x225c, 0x226a}, /* - */
	{0x2272, 0x2279}, /* - */

	{0x227e, 0x227e}, /* - */
	{0x2330, 0x2339}, /* O-X */
	{0x2341, 0x235a}, /* `-y */
	{0x2361, 0x237a}, /* - */
	{0x2421, 0x2473}, /* - */

	{0x2521, 0x2576}, /* @- */
	{0x2621, 0x2638}, /* - */
	{0x2641, 0x2658}, /* - */
	{0x2721, 0x2741}, /* @-` */
	{0x2751, 0x2771}, /* p- */

	{0x2821, 0x2840}, /* - */
	{0x3021, 0x4f53}, /* -r */
	{0x5021, 0x7426}, /* - */
};

 /* ͒p */
static	bool	i_eolcnv = 1, i_nobuf = 0, i_kanajis = 0, i_i88591prior = 0,
		i_linemode = 0;
static	bool	i_ignctlz = 0, i_igaftctlz = 0; /* i_eolcnvxorȂ
						ĕWl߂ */
static	bool	jisk_unite = 1; /* ꂪ1Ȃ犿͑Sjisk_forceƌȂ */
 /* 0ɂĂƏo͂EUCł؂芷V[PXf */
static	us_int	jisk_force; /* ǂ̃ZbgƌȂ? */
static	us_int	jisk_force_no0213 = JIS83K; /* AA0213ȊO */
static	us_int	jisk_G1; /* o͂̏ԂG1Ɏw銿Zbg */
static	us_int	jishojo_force; /* ⏕ǂ̃ZbgƌȂ? */
static	us_int	jishojo_G3; /* o͂̏ԂG3Ɏw⏕Zbg */
static	bool	roman_unite = 1; /* 1Ȃ烍[}͑Sroman_forceƌȂ */
static	us_int	roman_force = ASCIISET; /* MSR[h̃[}ǂ̃Zbg
					ȂB䕶o͎ɂg */
static	bool	swnam_as_roman = 0; /* ESC ( HESC ( JƌȂ */
static	bool	x0213_1_compat = 0; /* ꂪ1ȂX02131ʂ̂X0208
					鎚͎IX0208ƌȂ */
static	bool	x0213_1_force = 0; /* ꂪ1ȂX0208X0213ƌȂ
					x0213_1_nousew̏ꍇ */
static	bool	x0213_1_nouse = 0; /* ꂪ1ȂX02131ʂX0208ƌȂ */
static	bool	x0213_2_compat = 0; /* X02132ʂɑ΂铯l̃tO */
static	bool	x0213_2_force = 0;
static	bool	x0213_2_nouse = 0;
static	bool	x0213_compat = 0; /* x0213_[12]_compator */
static	bool	eucjin_x0213 = 0; /* ͂{EUC̏ꍇG1/G3X0213ɂ */
static	bool	eucjout_x0213 = 0; /* o͂ɂēl */
static	bool	eucjin_x0213_G1 = 0; /* (eucjin_x0213 || x0213_1_force) &&
					!x0213_1_nouse */
static	bool	eucjout_k_unite = 1; /* o͂{EUC̏ꍇJIS X0208
					02131ʂ𓯈ꎋ */
static	bool	eucjout_h_unite = 1; /* X021202132ʂɂēl */
#define IOtype_EUC 0
#define IOtype_JIS 1
#define IOtype_CT  2
#define IOtype_PC  3
static	int	intype_iso = IOtype_EUC, outtype_iso = IOtype_EUC;
static	us_int	kanjitreatflg = JKANJITREAT;
 /* ꂪMULBYTECHAȐꍇSS2E3̒ȊOł
    SoCg2oCgƌȂ */
	 /* o͂mscode_wputc̏ꍇ͓sɂ肱MULBYTECHARɕύX */
static	bool	k_regularize = 0,
		k_regul_daku = 0; /* _邩 */
static	bool	r_regularize = 0,
		r_regul_kspc2 = 0, /* {󔒂1oCg2ɂ邩 */
		r_regul_nokbstl = 0; /* {ꕶ\~1oCg߂邩*/
static	char	*initstring = NULL; /* o͂ɂe */

 /* o͒p */
#ifdef MSDOS
static	bool	o_eolcnv = 1;
#else
static	bool	o_eolcnv = 0;
#endif
static	bool	o_nobuf = 0, o_eolcr = 0;
#define	JKANA_G1GR	0		/* option 8 */ /* option P̎ */
#define	JKANA_G1GL	1		/* option 7 */
#define	JKANA_G0GL	2		/* option I */
#define	JKANA_UNDEF	-1
static	int	jkana_out = JKANA_UNDEF;
#define	JHOJO_G0GL	0
#define	JHOJO_SS3	1
static	int	jhojo_out = JHOJO_G0GL;
static	bool	desig4byte = 0;
 /* MSR[h̊g̈̕⏕Ȃǂւ̑Ή̂ */
#define	MSGAIJI_0213	0	/* JIS X0213 */
#define	MSGAIJI_TOGJ	1	/* TOG/JVC standard */
#define	MSGAIJI_ORIG	2	/* ]yakc̕BSONY NeWŜ܂ */
static	int	msgaiji_conv = MSGAIJI_0213;
#define	NONJ_Preserve	0
#define	NONJ_G0GL	1
#define	NONJ_CTtype	2
#define	NONJ_JP2type	3
#define	NONJ_EUCtype	4
#define	NONJ_UNDEF	-1
static	int	nonjset = NONJ_UNDEF;

#define ROMAN_G0GL	1
#define UNDESIG_G123	2
static	int	redsg_on_spc_out = ROMAN_G0GL, redsg_on_cr_out = ROMAN_G0GL,
		redsg_on_ctl_out = ROMAN_G0GL, redsg_on_eof_out = ROMAN_G0GL;
static	bool	redsg_on_spc_in = 0, redsg_on_cr_in = 0, redsg_on_ctl_in = 0;

static	char	*ibuf = NULL, *obuf = NULL;
#define BIGBUFSIZ 8192
static	int	ibufsiz = 0, obufsiz = 0;

#define RDSTAT	0
#define WRSTAT	1
#define STDSTAT	2
#define IOSTAT_MAX 3 /* iostat[]̓Y */
static	struct iosetinfo {
	us_int Gbuf[4]; /* G0`G3designateĂ镶Zbg */
	struct {
		us_int	bufno;	/* 0`3 */
		us_int	set;	/* Zbg */
	} GLR[2];	/* GL, GRG0`G3̂ǂꂪinvokeĂ邩 */
	 /* Gbuf[n]̍XVGLR[n].setXVKv */
} iostat[IOSTAT_MAX] /* ́Eo͂̂ꂼɂ */ = {
	{{UNK_SET, UNK_SET, JISKANA, UNK_SET}, {{G0, UNK_SET}, {G1, UNK_SET}}},
	{{UNK_SET, UNK_SET, JISKANA, UNK_SET}, {{G0, UNK_SET}, {G1, UNK_SET}}},
	{{UNK_SET, UNK_SET, JISKANA, UNK_SET}, {{G0, UNK_SET}, {G1, UNK_SET}}},
}; /* UNK_SET̏ɂjisk_force̒l */

#define Curset(io, glr) (iostat[io] . GLR[glr] . set)
#define Curbufno(io, glr) (iostat[io] . GLR[glr] . bufno)
#define Curdesig(io, bufno) (iostat[io] . Gbuf[bufno])

#define	designate_const(io, charset, buf_no)		\
	do { /* S] */			\
		Curdesig(io, buf_no) = (charset);	\
		if(Curbufno(io, GL) == (buf_no))	\
			Curset(io, GL) = (charset);	\
		if(Curbufno(io, GR) == (buf_no))	\
			Curset(io, GR) = (charset);	\
	} while(0)
#define	designate_to_thebuf(io, charset, buf_no)	\
	do { /* io, buf_no] */			\
		us_int	t_charset = (charset);		\
							\
		designate_const(io, t_charset, buf_no);	\
	} while(0) /* charset萔̏ꍇȂǂ͂g */
#define	designate_theset(io, charset, buf_no)		\
	do { /* io, charset] */		\
		us_int	t_bufno = (buf_no);		\
							\
		designate_const(io, charset, t_bufno);	\
	} while(0) /* buf_no萔̏ꍇȂ񂩂͂g */
#define designate(io, charset, buf_no)				\
	do { /* io] */					\
		us_int	t_bufno = (buf_no);			\
								\
		designate_to_thebuf(io, charset, t_bufno);	\
	} while(0)
#define invoke(io, buf_no, glr) /* S] */ \
	(Curbufno(io, glr) = (buf_no), Curset(io, glr) = Curdesig(io, buf_no))

#define in_designate_const(charset, buf_no) \
	designate_const(RDSTAT, charset, buf_no) /* S] */
#define in_designate_to_thebuf(charset, buf_no)	\
	designate_to_thebuf(RDSTAT, charset, buf_no)
	 /* buf_no]Bbuf_no萔̏ꍇ͂g */
#define in_designate_theset(charset, buf_no) \
	designate_theset(RDSTAT, charset, buf_no) /* charset] */
#define in_designate(charset, buf_no) designate(RDSTAT, charset, buf_no)
#ifdef LSI_C /* Gȃ}NWJɂRpC̖h~̂ */
static	void	in_designate_func(charset, buf_no)
us_int	charset, buf_no;
{
	in_designate_const(charset, buf_no);
}
#else
#define in_designate_func(charset, buf_no) in_designate(charset, buf_no)
#endif
#define in_invoke(buf_no, glr) invoke(RDSTAT, buf_no, glr) /* glr] */

#define out_designate_const(charset, buf_no) \
	designate_const(WRSTAT, charset, buf_no) /* charset, buf_no]*/
#define out_designate_to_thebuf(charset, buf_no) \
	designate_to_thebuf(WRSTAT, charset, buf_no) /* buf_no] */
#define out_invoke(buf_no, glr) invoke(WRSTAT, buf_no, glr) /* glr] */

#define makewch(c, set_buf_info) \
	(wchar4b)((us_int)(c) | ((wchar4b)(set_buf_info)) << 16)
 /* ͎wchar4b𐶐 c:us_int set_buf_info:us_int Ԃlwchar4b
    2ɂCursetCurbufnoorė^ */
#define makewchar(c, set, glr) \
	makewch((c), (set) | Curbufno(RDSTAT, (glr)))

#ifdef LSI_C
#define put2c(c, f) /* ] c:us_int */ \
	(putc((int)((c) >> 8), (f)), putc((int)(c), (f)))
#else
#define put2c(c, f) \
	(putc((int)((c) >> 8), (f)), putc((int)(c) & 0xff, (f))) /* Ö */
#endif

static	wchar4b	iso_wgetc(), mscode_wgetc(), muleint_wgetc(), special_wgetc();
static	void	iso_wputc(), eucj_wputc(), mscode_wputc();
static	wchar4b	(*common_wgetc)() = NULL, (*wgetc)() = NULL,
		(*plain_wgetc)() = NULL;
#ifdef MSDOS
static	void	(*wputc)() = mscode_wputc;
#else
static	void	(*wputc)() = eucj_wputc;
#endif
static	wchar4b	get_SS23_next(), get_ESC_next(), get_ESC_next_misc();
static	void	wchar_out(), decide_incode(), alloc_iobufs(), setinit(), yakc();

static	void	usage()
{
	fputs("Usage: ", stderr), fputs(cmdname, stderr);
	fputs("\
 [-i eujcmsPi3tzZlfka] [-o eujcmsP3tTf] [-j @B+p] [-r JBpH1ns]\n\
\t    [-k I782d] [-h 7] [-c lsoLSOe] [-C lso] [-f EIC2p] [-u 4]\n\
\t    [-x jty] [-3 cfnCFNdD] [-s initial] [filename...]\n",
	  stderr);
	exit(1);
}

static	void	cmd_errmsg(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	void	cantbuf()
{
	cmd_errmsg("Can't setvbuf()\n"), exit(1);
}

static	int	isx0208valid(c)
us_int	c;
{
	int	imin = 0, imax = sizeof(x0208_range) / sizeof(x0208_range[0]),
		imid = imax >> 1;

	do {
		c < x0208_range[imid] . lb ? (imax = imid) : (imin = imid);
	} while(imin != (imid = (imin + imax) >> 1));
	return c <= x0208_range[imid] . ub;
}

#define x0213_compat_chk(hi, ch, chset)				\
	do { /* hi, ch1񂾂] */				\
		if(!x0213_compat) break;			\
		switch(chset){					\
		case J213K1:					\
			if(x0213_1_compat && isx0208valid(ch))	\
				(chset) = jisk_force_no0213;	\
			break;					\
		case J213K2:					\
			if(x0213_2_compat && !x0213_to_msgaiji(hi)) \
				(chset) = JISSUPK;		\
			break;					\
		}						\
	} while(0)

static	wchar4b	iso_wgetc(inf)
FILE	*inf;
 /* {ꊿȊO̕oCg1oCgBASS2E3̎
    2oCg */
{
	register us_int	c, d;
	us_int	chset;

resume:
	c = getch(inf); /* cus_intɂcEOFȂ炻0xff */
	if(c <= 0x7e){
		if(c < 0x21) switch(c){
		case 0x20:
			chset = Curset(RDSTAT, GL);
			if(chset & CHARSET96) return makewchar(c, chset, GL);
			 /* FALLTHROUGH */
		case '\t':
			if(redsg_on_spc_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
			goto other_ch1;
		case ESC:
#ifndef MSC51
#  define treat_ESC(inf)				\
	do {						\
		wchar4b	tmp = get_ESC_next(inf);	\
							\
		switch(tmp){				\
		case wEmpty:				\
			goto resume;			\
		case wEOF:				\
			break;				\
		default:				\
			return tmp;			\
		}					\
	} while(0)
#else /* MSC51switch̏case̒萔longgȂBR */
#  define treat_ESC(inf)				\
	do {						\
		wchar4b	tmp = get_ESC_next(inf);	\
							\
		if(tmp == wEmpty) goto resume;		\
		if(tmp != wEOF) return tmp;		\
	} while(0)
#endif
			treat_ESC(inf);
			goto other_ch;
		case '\r':
			if(i_eolcnv && (c = getch(inf)) != '\n')
				(ungetch(c), c = '\n');
			 /* FALLTHROUGH */
		case '\n': case '\f':
			if(redsg_on_cr_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
			goto other_ch1;
		case SI:
			in_invoke(G0, GL); goto resume;
		case SO:
			in_invoke(G1, GL); goto resume;
		case ASS2:
			goto CaseSS2;
		case ASS3:
			goto CaseSS3;
		case DOSEOF:
			if(i_igaftctlz) return wEOF;
			if(i_ignctlz) goto resume;
			 /* FALLTHROUGH */
		default:
		other_ch:
			if(redsg_on_ctl_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
		other_ch1:
			return ctowc(c);
		} else {
			chset = Curset(RDSTAT, GL);
			if(chset & kanjitreatflg){
				d = getch(inf);
				if(0x21 <= d && d <= 0x7e){
					d |= c << 8;
					x0213_compat_chk(c, d, chset);
					return makewchar(d, chset, GL);
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
			 /* JISKANA0x5fȉɌƂʈ͂߂ */
				return makewchar(c, chset, GL);
			}
		}
	} else {
		if(0xa1 <= c && c <= 0xfe){
			chset = Curset(RDSTAT, GR);
			if(chset & kanjitreatflg){
				d = getch(inf);
				if(0xa1 <= d && d <= 0xfe){
					d |= c << 8;
					x0213_compat_chk(c & ~0x80,
						d & ~0x8080, chset);
					return makewchar(d, chset, GR);
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
				return makewchar(c, chset, GR);
			}
		} else
		if(intype_iso == IOtype_PC &&
		   JISKANA == (chset = Curset(RDSTAT, GR)) &&
		   0x80 <= c && c <= 0xff){
		 /* Ji: ͂PC^̏ꍇ0x80`0xff͑SJi */
			return makewchar(c, chset, GR);
		} else switch(c) { /* 0x7f`0xa0, 0xff, EOF */
		case SS2:
		case SS3:
		CaseSS2:
		CaseSS3:
#define treat_SS23(inf, bufno, use8)			\
	do {						\
		wchar4b	tmp;				\
							\
		tmp = get_SS23_next(inf, bufno, use8);	\
		if(tmp != wEOF) return tmp;		\
	} while(0)
			treat_SS23(inf,
				(c == SS3 || c == ASS3) ? G3 : G2, c & 0x80);
			goto other_ch;
		case uEOF:
			return wEOF;
		case 0x7f:
			chset = Curset(RDSTAT, GL);
			if(chset & CHARSET96) return makewchar(c, chset, GL);
			goto other_ch;
		case 0xa0:
		case 0xff:
			chset = Curset(RDSTAT, GR);
			if(chset & CHARSET96) return makewchar(c, chset, GR);
			 /* FALLTHROUGH */
		default:
			goto other_ch;
		}
	}
}

static	wchar4b	get_SS23_next(inf, bufno, use8)
FILE	*inf;
us_int	bufno;
us_int	use8; /* 8rbgSS2E3ŌĂяoꂽ?(1or0łȂ0or0) */
 /* ςȕ߂wEOFԂBȊȌꍇwEOFԂ邱Ƃ͂ȂB܂
    0ԂȂBSNGLSFTrbgƏI[񂪔0̂͂Ȃ̂ */
{
	register us_int	c, d;
	us_int	chset = Curdesig(RDSTAT, bufno);
	us_int	buf_info;

	if(use8){
		buf_info = (bufno == G3 ? G3_SS8bit : G2_SS8bit);
	} else {
		buf_info = (bufno == G3 ? G3_SS7bit : G2_SS7bit);
	}

	c = getch(inf);
	if(0x21 <= c && c <= 0x7e || 0xa1 <= c && c <= 0xfe){
		if(chset & MULBYTECHAR){
			d = getch(inf);
			if(0x21 <= d && d <= 0x7e || 0xa1 <= d && d <= 0xfe){
				d |= c << 8;
				x0213_compat_chk(c& ~0x80, d& ~0x8080, chset);
				return makewch(d, buf_info | chset);
			} else {
				ungetch(d);
				goto other_ch;
			}
		} else {
			return makewch(c, buf_info | chset);
		}
	} else
    /* Ji
	if(intype_iso == IOtype_PC &&
	   chset == JISKANA && 0x80 <= c && c <= 0xff){
		return makewch(c, buf_info | chset);
	} else
    */
	if(c != uEOF && (c & 0x60)){ /* 0x20, 0x7f, 0xa0, 0xff */
		us_int	set_buf_info = buf_info | chset;

		if(chset & CHARSET96){
			if(chset & MULBYTECHAR){
				d = getch(inf);
				if(d != uEOF && (d & 0x60)){
				 /* 0x20`0x7f, 0xa0`0xff */
					return makewch(((c << 8) | d),
								set_buf_info);
				 /* 96ZbgȂ̂x0213_compat̏sv */
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
				return makewch(c, set_buf_info);
			}
		} else {
			goto other_ch;
		}
	} else {
	other_ch:
		ungetch(c);
		return wEOF;
	}
}

static	wchar4b	get_ESC_next(inf)
FILE	*inf;
 /* ςȂ̂߂wEOFAƂV[PXwEmptyA
    SS2E3ŕǂ񂾂炻̕Ԃ */
{
	register us_int	c, d;
	us_int	e;
	bool	modflg = 0; /* KiCtO */

resume:
	c = getch(inf);
	switch(c){
	case '$':
		d = getch(inf);
		switch(d){
		case 'B':
			in_designate_to_thebuf(jisk_unite ? jisk_force :
						modflg ? JIS90K : JIS83K, G0);
			return wEmpty;
		case '@':
			in_designate_to_thebuf(
				jisk_unite ? jisk_force : JIS78K, G0);
			return wEmpty;
		case 'A':
			in_designate_const(CNGBSET, G0);
			return wEmpty;
		case '(': case ')': case '*': case '+':
			e = getch(inf);
			switch(e){
			case 'B':
				in_designate_func(jisk_unite ? jisk_force :
						modflg ? JIS90K : JIS83K,
							desigch2bufno(d));
				return wEmpty;
			case 'O':
				in_designate_func(x0213_1_nouse ? jisk_force :
						J213K1,	desigch2bufno(d));
				return wEmpty;
			case '@':
				in_designate_func(jisk_unite ? jisk_force :
						JIS78K,	desigch2bufno(d));
				return wEmpty;
			case 'D':
				in_designate_theset(jishojo_force,
							desigch2bufno(d));
				return wEmpty;
			case 'P':
				in_designate_func(x0213_2_nouse ? JISSUPK :
						J213K2,	desigch2bufno(d));
				return wEmpty;
			}
			if(istermch(e)){
				in_designate_func(termchmask(e) | MULBYTECHAR,
							desigch2bufno(d));
				return wEmpty;
			}
			ungetch(e);
			break;
		case ',': case '-': case '.': case '/':
			e = getch(inf);
			if(istermch(e)){
				in_designate_func(termchmask(e) | MULBYTECHAR |
					      CHARSET96, desig96ch2bufno(d));
				return wEmpty;
			}
			ungetch(e);
			break;
		}
		ungetch(d);
		goto other_ch;
	case '(': case ')': case '*': case '+':
		d = getch(inf);
		switch(d){
		case 'B':
			in_designate(roman_unite ? roman_force : ASCIISET,
							desigch2bufno(c));
			return wEmpty;
		case 'J':
			in_designate(roman_unite ? roman_force : JISROMAN,
							desigch2bufno(c));
			return wEmpty;
		case 'H':
			in_designate_func(!swnam_as_roman ? SWNAMSET :
				     roman_unite ? roman_force : JISROMAN,
					desigch2bufno(c));
			return wEmpty;
		}
		if(istermch(d)){
			in_designate_func(termchmask(d), desigch2bufno(c));
			return wEmpty;
		}
		if(d == '!'){ /* o^ςݑ2ԕ2/194}`() */
			e = getch(inf);
			if(istermch(e)){
				in_designate_func(termchmask(e | 0x80),
							desigch2bufno(c));
				return wEmpty;
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	case ',': case '-': case '.': case '/':
		d = getch(inf);
		if(istermch(d)){
			in_designate_func(termchmask(d) | CHARSET96,
							desig96ch2bufno(c));
			return wEmpty;
		}
		ungetch(d);
		goto other_ch;
	case '&': /* ESC & @ ESC $ B */
		d = getch(inf);
		if(d == '@'){
			e = getch(inf);
			if(e == ESC){
				modflg = 1;
				goto resume;
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	default: /* LSI COut of memoryh~̈get_ESC_next_misc()𕪊*/
		return get_ESC_next_misc(inf, c);
	}
other_ch:
	ungetch(c);
	return wEOF;
}

 /* ̒xŃG[NȂ > LSI_C */
static	wchar4b	get_ESC_next_misc(inf, c)
FILE	*inf;
us_int	c;
 /* cςȂ̂߂wEOFAƂV[PX0A
    SS2E3ŕǂ񂾂炻̕Ԃ */
{
	us_int	d;

	switch(c){
	case 'N':
	case 'O':
		treat_SS23(inf, c == 'N' ? G2 : G3, 0);
		goto other_ch;
	case 'n':
		in_invoke(G2, GL); return wEmpty;
	case 'o':
		in_invoke(G3, GL); return wEmpty;
	case '~':
		in_invoke(G1, GR); return wEmpty;
	case '}':
		in_invoke(G2, GR); return wEmpty;
	case '|':
		in_invoke(G3, GR); return wEmpty;
	case '!': case '"': case ' ':
		d = getch(inf);
		if(d != uEOF) return wEmpty;
		ungetch(d);
		goto other_ch;
	case 'K':
		in_designate_to_thebuf(jisk_unite ? jisk_force : PCKANJI, G0);
		return wEmpty;
	case 'H':
		in_designate_to_thebuf(roman_unite? roman_force : PCROMAN, G0);
		return wEmpty;
	case '\1': /* ??? */
		return wEmpty;
	}
other_ch:
	ungetch(c);
	return wEOF;
}

static	us_int	msgaiji2supk(gl, gjset)
us_int	gl, *gjset;
 /* glɂMSR[hf040`UzIȕZbg2121`3a7eɕϊ
    ̂nBJIŜǂ̕Ɋ蓖Ă邩𔻒肷 */
{
	switch(msgaiji_conv){
	case MSGAIJI_0213:
		gl = ((us_int)msgaiji_to_x0213(gl >> 8) << 8) | (gl & 0xff);
		*gjset = x0213_2_nouse ? JISSUPK : J213K2;
		break;
	case MSGAIJI_TOGJ:
		if(gl < 0x2b00){
			/* 2121`2A7E  1st plane 7521`7E7E */
			gl += 0x5400;
			*gjset = jisk_force;
		} else if(gl < 0x3500){
			/* 2B21`347E  2nd plane 7521`7E7E */
			gl += 0x4a00;
			*gjset = jishojo_force;
		} else {
			/* 3521`417E  1st/2nd plane, using table */
			us_int	inx;

			inx = ((gl >> 8) - 0x35) * 94 + (gl & 0xff) - 0x21;
			if(inx >= FA40_FC4B_CHARS){
				gl = GETA; /* ΉȂ */
				*gjset = jisk_force;
			} else {
				gl = tog_msgaiji_to_jis[inx];
				if(gl & 0x8000)
					*gjset = jishojo_force;
				else
					*gjset = jisk_force;
				gl &= ~0x8080;
			}
		}
		break;
	default: /* case MSGAIJI_ORIG: */
		*gjset = jishojo_force;
		break;
	}
	return gl;
}

static	us_int	supk2msgaiji(gl)
us_int	gl;
 /* JIS X0212⏕MSR[h̊g̈Ƀ}bv邩ǂ߁A
    ΂UzIȕZbg2121`3a7eɕϊ̂ԂB
    Ȃ0Ԃ */
{
	switch(msgaiji_conv){
	case MSGAIJI_0213:
		return 0; /* no mapping to x0212 */
	case MSGAIJI_TOGJ:
		if(0x7521 <= gl && gl <= 0x7e7e){
			return gl - 0x4a00;
		} else {
			us_int	i;

			/* Linear search; brute & foolish */
			gl |= 0x8080;
			for(i = 0; i < FA40_FC4B_CHARS; i++){
				if(gl == tog_msgaiji_to_jis[i]) return
					(((i / 94) << 8) | (i % 94)) + 0x2121;
			}
			return 0;
		}
		break;
	default: /* case MSGAIJI_ORIG: */
		return gl >= 0x3b00 ? 0 : gl;
	}
}

static	us_int	x0213tomsgaiji(gl)
us_int	gl;
 /* JIS X02132ʂ̕MSR[h̊g̈Ƀ}bv邩ǂ߁A
    ł΂UzIȕZbg2121`3a7eɕϊ̂ԂB
    Ȃ0Ԃ */
{
	us_int	h;

	switch(msgaiji_conv){
	case MSGAIJI_0213:
		h = x0213_to_msgaiji(gl >> 8);
		return h ? (h << 8) | (gl & 0x7f) : 0;
	default:
		return 0;
	}
}

static	wchar4b	mscode_wgetc(inf)
FILE	*inf;
{
	us_int	c, d;
#ifndef __WATCOMC__
#  define intcast(x) ((int)(x))
#else /* WATCOMC͒萔intւcastɕtB]vȂb */
#  define intcast(x) ((int)((x) & 0xffff))
#endif
#define mssubconst(x, y, z) intcast((((long)(x) << 9) | (y)) - (z))
	static	int	mssubparam1[ ] = {
		mssubconst(0x81, 0x40, 0x2121),
		mssubconst(0x81, 0x80, 0x2160),
		mssubconst(0x81, 0x9f, 0x2221),
	};
	static	int	mssubparam2[ ] = {
		mssubconst(0xe0, 0x40, 0x5f21),
		mssubconst(0xe0, 0x80, 0x5f60),
		mssubconst(0xe0, 0x9f, 0x6021),
	};
	static	int	mssubparam3[ ] = {
		mssubconst(0xf0, 0x40, 0x2121),
		mssubconst(0xf0, 0x80, 0x2160),
		mssubconst(0xf0, 0x9f, 0x2221),
	};
	int	*mssubparam;

#define paramsub_bycase(d, param)		\
	if((d) < 0x40) goto unget_otherch;	\
	else if((d) <= 0x7e) (d) -= (param)[0];	\
	else if((d) == 0x7f) goto unget_otherch;\
	else if((d) <= 0x9e) (d) -= (param)[1];	\
	else if((d) <= 0xfc) (d) -= (param)[2];	\
	else goto unget_otherch

resume:
	c = getch(inf);
	if(0x81 <= c){ /* cus_intɂcEOFȂ炻0xff */
		if(c <= 0x9f){
			mssubparam = mssubparam1;
			goto mskanji;
		} else
		if(c <= 0xdf){
			if(c == 0xa0) return ctowc(' ');
			return makewch(c & ~0x80, JISKANA | G0);
		} else
		if(c <= 0xef){
			mssubparam = mssubparam2;
		mskanji:
			d = getch(inf);
			paramsub_bycase(d, mssubparam);
			d += c << 9;
			return makewch(d, (eucjin_x0213_G1 &&
				!(x0213_1_compat && isx0208valid(d)) ?
					J213K1 : jisk_force_no0213) | G0);
		} else
		if(c <= 0xfc){
			us_int	gl, gjset;

			d = getch(inf);
			paramsub_bycase(d, mssubparam3);
			gl = msgaiji2supk(d + (c << 9), &gjset);
			return makewch(gl, gjset | G0);
			 /* ̏ꍇMSGAIJI_0213Ȃx0213_compat͕̏sv
			    ȊOŕ⏕x0213_forceX0213ɉꍇ
			    x0213_compat̏͂ȂƂɂ */
		} else
		if(c == uEOF){
			return wEOF;
		} else { /* 0xfd`0xff */
			goto other_ch;
		}
	unget_otherch:
		ungetch(d);
		goto other_ch;
	} else
	if(0x21 <= c){
		if(c <= 0x7e) return makewch(c, roman_force | G0);
		goto other_ch;
	} else switch(c){
	case '\r':
		if(i_eolcnv && (c = getch(inf))!= '\n') (ungetch(c), c = '\n');
		goto other_ch;
	case DOSEOF:
		if(i_igaftctlz) return wEOF;
		if(i_ignctlz) goto resume;
		 /* FALLTHROUGH */
	default:
	other_ch:
		return ctowc(c);
	}
}

static	wchar4b	muleint_wgetc(inf) /* X0213l x0213_force */
FILE	*inf;
{
	us_int	c, d;
	static	wchar4b	next_ret = wEOF;

	if(next_ret != wEOF){
		wchar4b	ret = next_ret;

		next_ret = wEOF;
		return ret;
	}

#define MULE_KANA_RDNG	0x89
#define MULE_JISR_RDNG	0x8a
#define MULE_OKNJ_RDNG	0x90
#define MULE_KNJ_RDNG	0x92
#define MULE_SUPK_RDNG	0x94

resume:
	c = getch(inf);

	if(0x21 <= c && c <= 0x7f){
		return makewch(c, (roman_unite ? roman_force : ASCIISET) | G0);
	} else
	if(0x81 <= c && c <= 0x8d){
		switch(c){
		case 0x8b:
			goto other_ch;
		case MULE_KANA_RDNG:
			d = getch(inf);
			if(0xa1 <= d && d <= 0xdf){
			 /* muleint̏ꍇ0xa0l */
				return makewch(d, JISKANA | G1);
			}
			ungetch(d);
			goto other_ch;
		case MULE_JISR_RDNG:
			d = getch(inf);
			if(0xa1 <= d && d <= 0xfe){
				return makewch(d & 0x7f,
				  (roman_unite ? roman_force : JISROMAN) | G0);
			}
			ungetch(d);
			goto other_ch;
		default:
			d = getch(inf);
			if(0xa0 <= d && d <= 0xff){
				c != 0x85 ? (c -= 0x81 - 'A') : (c = 'T');
				return makewch(d,
					    (termchmask(c) | CHARSET96) | G1);
			}
			ungetch(d);
			goto other_ch;
		}
	} else
	if(0x90 <= c && c <= 0x96){
		us_int	jset;

		switch(c){
		case MULE_OKNJ_RDNG:
			jset = (jisk_unite ? jisk_force_no0213 : JIS78K);
			goto jis_common;
		case MULE_KNJ_RDNG:
			jset = (jisk_unite ? jisk_force_no0213 : JIS83K);
			goto jis_common;
		case MULE_SUPK_RDNG:
			jset = JISSUPK;
		jis_common:
			d = getch(inf);
			if(0xa1 <= d && d <= 0xfe){
				us_int	e;

				e = getch(inf);
				if(0xa1 <= e && e <= 0xfe){
					return makewch(((d << 8) | e) & 0x7f7f,
								    jset | G0);
				}
				ungetch(e);
			}
			ungetch(d);
			goto other_ch;
		default:
			d = getch(inf);
			if(0xa1 <= d && d <= 0xfe){
				us_int	e;

				e = getch(inf);
				if(0xa1 <= e && e <= 0xfe){
					c -= (0x95 <= c ? 0x95-'G' : 0x91-'A');
					next_ret = makewch(e & 0x7f,
					  (termchmask(c) | MULBYTECHAR) | G0);
					return makewch(d & 0x7f,
					  (termchmask(c) | MULBYTECHAR) | G0);
				}
				ungetch(e);
			}
			ungetch(d);
			goto other_ch;
		}
	} else switch(c){
	case uEOF:
		return wEOF;
	case '\r':
		if(i_eolcnv && (c = getch(inf))!= '\n') (ungetch(c), c = '\n');
		goto other_ch;
	case DOSEOF:
		if(i_igaftctlz) return wEOF;
		if(i_ignctlz) goto resume;
		 /* FALLTHROUGH */
					 /* 2muleintɂ͕svȂ */
	default:
	other_ch:
		return ctowc(c);
	}
}

static	wchar4b	special_wgetc(inf)
FILE	*inf;
{
	wchar4b	wc;
	us_int	c, d, chset;
	static	wchar4b	next_get = wEOF;

	if(next_get != wEOF){
		wc = next_get, next_get = wEOF;
	} else {
		wc = plain_wgetc(inf);
	}
	if(wc == wEOF) return wc;

	c = wctoc(wc) & ~0x8080;
	chset = rmvbufinfo(whatset(wc));

	if(chset & JKANJITREAT){
		if(!r_regularize || chset == JISSUPK || chset == J213K2)
			return wc;
		switch(c >> 8){
		case 0x21:
			switch(c = Conv21(c & 0x7f)){
			case '\0':
				break;
			case ' ':
				if(r_regul_kspc2) next_get = ctowc(' ');
				return ctowc(' ');
			default:
				return makewch(c, roman_force | G0);
			}
			break;
		case 0x23:
			c &= 0x7f;
			if('0' <= c && c <= '9' ||
			   'A' <= c && c <= 'Z' ||
			   'a' <= c && c <= 'z') /* or: isalnum(c) */
				return makewch(c, roman_force | G0);
			break;
		}
		return wc;
	} else
	if(chset == JISKANA){
		if(!k_regularize) return wc;
		c &= 0x7f; /* c0x20ȉ肤 */
		if(0x21 <= c && c <= 0x5f){
			d = Convjisk(c);
			wc = makewch(d ^ ((d & 0x80) ? 0x2180 : 0x2500),
							jisk_force | G0);
			if(k_regul_daku &&
			   (0x36 <= c && c <= 0x44 || 0x4a <= c && c <= 0x4e ||
			    0x33 == c)){
				next_get = plain_wgetc(inf);
				if(rmvbufinfo(whatset(next_get)) == JISKANA){
					switch(wctoc(next_get) & 0x7f){
					case 0x5f:
						if(c <= 0x44) break;
						wc++; /* FALLTHROUGH */
					case 0x5e:
						0x33 == c ? wc += 78 : wc++;
						next_get = wEOF;
					}
				}
			}
			return wc;
		} else {
			return (c == ' ') ? ctowc(' ') :
					    makewch(GETA, jisk_force | G0);
		}
	} else {
		return wc;
	}
}

 /* designate̕KvꍇĂсAۂɂ */
static	void	desigseq_out(otf, chset, buf_no)
FILE	*otf;
us_int	chset, buf_no;
{
	out_designate_const(chset, buf_no);
	if(chset & SPECIALSET){
		if(chset == JIS90K){
			fputs(SEQMOD, otf);
			goto normalset;
		} else { /* PCKANJI, PCROMAN */
			if(buf_no != G0) goto normalset;
			 /* G0ȊȌꍇJIS78K, JISROMAN */
			putc(ESC, otf), putc(chset == PCKANJI? 'K' : 'H', otf);
		}
	} else {
	normalset:
		putc(ESC, otf);
		if(chset & CHARSET96){
			if(chset & MULBYTECHAR) putc('$', otf);
			putc((int)buf_no - G1 + '-', otf);
		} else {
			if(chset & MULBYTECHAR){
				putc('$', otf);
				if(termch(chset) <= 'B' && buf_no == G0 &&
				   !desig4byte) goto nobufnmchar;
			}
			putc((int)buf_no - G0 + '(', otf);
		nobufnmchar:
			;
		}
		 /* o^ςݑ2ԕ2/1̐}`(94̂̂) */
		if(termch(chset) & 0x80) putc('!', otf);

		putc(termch(chset) & ~0x80, otf);
	}
}

 /* invoke̕KvꍇɂĂсAۂɂ */
static	void	invkseq_out(otf, buf_no, glr)
FILE	*otf;
us_int	buf_no, glr;
{
	if(glr == GL){
		out_invoke(buf_no, GL);
		 /* 2萔ɂR[hfc */
		switch(buf_no){
		case G0:
			putc(SI, otf); break;
		case G1:
			putc(SO, otf); break;
		default:
			putc(ESC, otf), putc((int)buf_no - G2 + 'n', otf);
			break;
		}
	} else {
		out_invoke(buf_no, GR);
		putc(ESC, otf), putc('~' + G1 - (int)buf_no, otf);
	}
}

 /* chset[}Zbgłꍇg ͕]
    designateinvoke̕Kv𒲂ׁA΂ */
#define	romanG0GLseq_out(otf, chset)				\
	do {							\
		if(Curdesig(WRSTAT, G0) != (chset)){		\
			out_designate_const(chset, G0);		\
			if(chset & SPECIALSET){ /* PCROMAN */	\
				fputs("\033H", otf);		\
			} else {				\
				fputs("\033(", otf);		\
				putc(termch(chset), otf);	\
			}					\
		}						\
		if(Curbufno(WRSTAT, GL) != G0){			\
			out_invoke(G0, GL);			\
			putc(SI, otf);				\
		}						\
	} while(0)

 /* chsetZbg(⏕܂)łꍇg ͕] */
#define	jiskG0GLseq_out(otf, chset)				\
	do {							\
		if(Curdesig(WRSTAT, G0) != (chset)){		\
			out_designate_const(chset, G0);		\
			if(chset & SPECIALSET){			\
				if(chset == JIS90K){		\
					fputs(SEQMOD, otf);	\
					goto normk;		\
				} else { /* PCKANJI */		\
					fputs("\033K", otf);	\
				}				\
			} else {				\
			normk:					\
				fputs("\033$", otf);		\
				if(termch(chset) > 'B' || desig4byte) \
					putc('(', otf);		\
				putc(termch(chset), otf);	\
			}					\
		}						\
		if(Curbufno(WRSTAT, GL) != G0){			\
			out_invoke(G0, GL);			\
			putc(SI, otf);				\
		}						\
	} while(0)

 /* ʓIȐ}`ZbgwpBdesignateinvoke̕Kv𒲂ׁA΂
    SS2SS3fƂ̂ŁA2Agpɂ͒ӁBAASS2
    f̂͑3SNGLSFTĂ鎞̂ */
static	void	desinvkseq_out(otf, chset, buf_no, glr)
FILE	*otf;
us_int	chset, buf_no, glr; /* SNGLSFT̃rbgbuf_noĂ */
{
	if(buf_no & SNGLSFT){
		us_int	true_bufno;

		switch(buf_no){
		case G2_SS8bit:
		case G2_SS7bit:
			true_bufno = G2; break;
		default:
			true_bufno = G3; break;
		}
		if(Curdesig(WRSTAT, true_bufno) != chset)
			desigseq_out(otf, chset, true_bufno);
		switch(buf_no){
		case G2_SS8bit:
			putc(SS2, otf); break;
		case G2_SS7bit:
			fputs("\033N", otf); break;
		case G3_SS8bit:
			putc(SS3, otf); break;
		default: /* case G3_SS7bit: */
			fputs("\033O", otf); break;
		}
	} else {
		if(Curdesig(WRSTAT, buf_no) != chset)
			desigseq_out(otf, chset, buf_no);
		if(Curbufno(WRSTAT, glr) != buf_no)
			invkseq_out(otf, buf_no, glr);
	}
}

static	void	undesig_G1_to_G3()
{
	int	buf_no;

	for(buf_no = G1; buf_no <= G3; ++buf_no)
		out_designate_const(UNK_SET, buf_no);
}

static	void	ctlsetchar_out(c, otf)
FILE	*otf;
us_int	c;
 /* c0x20, 0x7f, 0xa0, 0xffŁAsetCHARSET96̏ꍇ͗v */
{
	switch(c){
	case ' ':
		if(redsg_on_spc_out & UNDESIG_G123) undesig_G1_to_G3();
		if((redsg_on_spc_out & ROMAN_G0GL) ||
		   (Curset(WRSTAT, GL) & CHARSET96))
			goto romandesg;
		break;
	case '\t':
		if(redsg_on_spc_out & UNDESIG_G123) undesig_G1_to_G3();
		if(redsg_on_spc_out & ROMAN_G0GL) goto romandesg;
		break;
	case '\n':
		if(o_eolcr) c = '\r';
		 else if(o_eolcnv) ctlsetchar_out('\r', otf);
		/* FALLTHROUGH */
	case '\r': case '\f':
		if(redsg_on_cr_out & UNDESIG_G123) undesig_G1_to_G3();
		if(redsg_on_cr_out & ROMAN_G0GL) goto romandesg;
		break;
	case 0x7f:
		if(redsg_on_ctl_out & UNDESIG_G123) undesig_G1_to_G3();
		if((redsg_on_ctl_out & ROMAN_G0GL) ||
		   (Curset(WRSTAT, GL) & CHARSET96))
			goto romandesg;
		break;
	default:
		if(!(c & 0x80)){
			if(redsg_on_ctl_out & UNDESIG_G123) undesig_G1_to_G3();
			if(redsg_on_ctl_out & ROMAN_G0GL){
			romandesg:
				if(!(Curset(WRSTAT, GL) & ROMANSET))
					romanG0GLseq_out(otf, roman_force);
			}
		} else {
		  /* 0x80ȏɂĂ͉L̑[uȊOƂ肠lȂ */
			if((c == 0xa0 || c == 0xff) &&
			   (Curset(WRSTAT, GR) & CHARSET96)){
				desigseq_out(otf,
					roman_force, Curbufno(WRSTAT, GR));
				 /* 96ZbgłȂችł */
			}
		}
	}
	putc((int)c, otf);
}

static	void	wchar_out(otf, c, chset, buf_no)
 /* {ꕶ̏o͂ɗp */
FILE	*otf;
us_int	c, chset, buf_no;
{
	us_int	d;

	desinvkseq_out(otf, chset, buf_no, (c & 0x8080) ? GR : GL);
	d = c >> 8;
	if(d) (putc((int)d, otf), c &= 0xff);
	putc((int)c, otf);
}

 /* {ꕶo͗pB{ꕶSS2, SS3̎ȊOł͏1oCg
    ǂ܂Ă */
static	void	nonjset_out(otf, c, chset, buf_no)
FILE	*otf;
us_int	c, chset, buf_no;
{
	switch(nonjset){
	case NONJ_Preserve:
		if((chset & CHARSET96) && buf_no == G0) buf_no = G1;
		wchar_out(otf, c, chset, buf_no);
		 /* buf_noSNGLSFTĂꍇGL/GR̋ʂ͎gȂ */
		break;
	case NONJ_G0GL:
		if(chset & CHARSET96){
			wchar_out(otf, c & ~0x8080, chset, G1);
		} else {
			goto w_out_G0GL;
		}
		break;
	case NONJ_CTtype:
		if(chset & CHARSET96){
			goto w_out_G1GR;
		} else {
			goto w_out_G0GL;
		} /* NOTREACHED */
		break;
	case NONJ_JP2type:
		if(chset & CHARSET96){
			wchar_out(otf, c & ~0x8080, chset, G2_SS7bit);
		} else {
			goto w_out_G0GL;
		} /* NOTREACHED */
		break;
	default: /* NONJ_EUCtype */
		if(chset & (MULBYTECHAR | CHARSET96)){
		 /* SS2o͂MSkanjiȂǂ̏ꍇA{ꕶ2oCg
		    Ă邱Ƃ */
		w_out_G1GR:
			wchar_out(otf,
				  c | ((c >> 8) ? 0x8080 : 0x80), chset, G1);
		} else
	     /*	if(chset & CHARSET96){
			wchar_out(otf,
			    c | ((c >> 8) ? 0x8080 : 0x80), chset, G2_SS8bit);
		} else */ {
		w_out_G0GL:
			wchar_out(otf, c & ~0x8080, chset, G0);
		}
		break;
	}
}

static	void	iso_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
/* j		94P(JISJi)	JISJi  96͂G1
			94		  (EUĈƂ96PG2~)
	EUC	G0	JISG3	G2	G0=ASC G1=83K G2=KANA G3=SUPK GLG0 GRG1
			ȊOG1
	JIS1	G0	G0	G0	G0=ASC G1=KANA G2=G3=UK	GLG0 GRG1
	JIS2	G0	G0	G1(GL)	G0=ASC G1=KANA G2=G3=UK GLG0 GRG1
	JIS3	G0	G0	G1	G0=ASC G1=KANA G2=G3=UK GLG0 GRG1
	Comp1	G0	G0	G1	G0=ASC G1=LATN G2=G3=UK GLG0 GRG1
	(Comp2	G0	G1	G1
 IvV: E/J
	(E,J)	{ȊO=̒ʂ/ۑ/G0GL(96G1)
		TAB,SP=G0GL/ CR=G0GL/ OTHERCTL=G0GL/
			20 7f a0 ffɂĂCHARSET96ɒ
	(J)	(=G0/G1) KANA=G0/G1GL/G1GR G1=LATIN/KANA
 */
	us_int	c, chset, buf_no;

	c = wctoc(wc);
	chset = whatset(wc), buf_no = gbufno(chset), chset = rmvbufinfo(chset);

	if(chset & ROMANSET){
	 /* ɂ͂悭̂Ŋ֐Ăяo͎g킸}NɂĂ */
		if(Curset(WRSTAT, GL) != chset)	romanG0GLseq_out(otf, chset);
		putc((int)c & 0x7f, otf);
	} else
	if(jhojo_out != JHOJO_G0GL && (chset == JISSUPK || chset == J213K2)){
		/* ̏ꍇjhojo_out == JHOJO_SS3Ɍ */
#if 0 /* EUCJ̏ꍇƓ[u */
		if(eucjout_h_unite) chset = jishojo_G3;
#endif /* ̂Ƃ낱̑[u͂Ȃ */
		desinvkseq_out(otf, chset, G3_SS7bit, GL);
		c &= ~0x8080;
		put2c(c, otf);
	} else
	if(chset & JKANJITREAT){ /* ֐ĂяoɂȂ */
		if(Curset(WRSTAT, GL) != chset) jiskG0GLseq_out(otf, chset);
		c &= ~0x8080;
		put2c(c, otf);
	} else
	if(!chset){
		ctlsetchar_out(c, otf); /* o_eolcnv, o_eolcrl */
	} else
	if(chset == JISKANA){
		c &= 0x7f;
		if((c <= 0x20 || 0x60 <= c) && outtype_iso != IOtype_PC){
			iso_wputc(makewch(GETA, jisk_force | G0), otf);
			return;
		}
		switch(jkana_out){
		case JKANA_G1GR:
			if(outtype_iso == IOtype_PC &&
			 /* o͂PC^ȂJi͉pZbgG0GLɎw
			    óBJKANA_G1GL̏ꍇ */
			   !(Curset(WRSTAT, GL) & ROMANSET) &&
			   Curset(WRSTAT, GL) != chset)
				desinvkseq_out(stdout, roman_force, G0, GL);
			if(Curset(WRSTAT, GR) != chset)
				desinvkseq_out(otf, chset, G1, GR);
			putc((int)c | 0x80, otf);
			break;
		case JKANA_G1GL:
			if(Curset(WRSTAT, GL) != chset){
				if(outtype_iso == IOtype_PC &&
				   !(Curset(WRSTAT, GL) & ROMANSET))
					desigseq_out(stdout, roman_force, G0);
					 /* łǂGLG1Ăяo񂾂
					    invoke͖ */
				desinvkseq_out(otf, chset, G1, GL);
			}
			putc((int)c, otf);
			break;
		default: /* case JKANA_G0GL: */
			if(Curset(WRSTAT, GL) != chset)
				desinvkseq_out(otf, chset, G0, GL);
			putc((int)c, otf);
			break;
		}
	} else {
		nonjset_out(otf, c, chset, buf_no);
	}
}

static	void	eucj_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
	us_int	c, chset, buf_no;

	c = wctoc(wc);
	chset = whatset(wc), buf_no = gbufno(chset), chset = rmvbufinfo(chset);

	if(chset & ROMANSET){ /* [}̌Ăяo͏G0GL */
		if(Curset(WRSTAT, GL) != chset)
			desinvkseq_out(otf, chset, G0, GL);
		putc((int)c & 0x7f, otf);
	} else
	if(chset & JKANJITREAT){ /* E⏕ */
		switch(chset){
		case JISSUPK: case J213K2:
			if(eucjout_h_unite) chset = jishojo_G3;
			if(Curdesig(WRSTAT, G3) != chset)
				desigseq_out(otf, chset, G3);
			putc(SS3, otf);
			break;
		default:
			if(eucjout_k_unite) chset = jisk_G1;
			if(Curset(WRSTAT, GR) != chset)
				desinvkseq_out(otf, chset, G1, GR);
			break;
		}
		c |= 0x8080;
		put2c(c, otf);
	} else
	if(!chset){
		ctlsetchar_out(c, otf); /* o_eolcnv, o_eolcrl */
	} else
	if(chset == JISKANA){
		c |= 0x80;
		if(c <= 0xa0 || 0xe0 <= c){
			eucj_wputc(makewch(GETA, jisk_force | G0), otf);
			return;
		}
		if(Curdesig(WRSTAT, G2) != JISKANA)
			desigseq_out(otf, JISKANA, G2);
		putc(SS2, otf);
		putc((int)c, otf);
	} else {
		nonjset_out(otf, c, chset, buf_no);
	}
}

static	void	mscode_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
	register us_int	c, d;
	us_int	chset;

	c = wctoc(wc);
	chset = rmvbufinfo(whatset(wc));

	if(chset & ROMANSET){
		putc((int)c & 0x7f, otf);
	} else
	if(chset & JKANJITREAT){ /* E⏕ */
		int	msupaddparam;

		c &= ~0x8080;
		switch(chset){
		case JISSUPK:
			if((c = supk2msgaiji(c)) == 0) goto geta_out;
			msupaddparam = 0xf0 - (0x21 >> 1);
			break;
		case J213K2:
			if((c = x0213tomsgaiji(c)) == 0) goto geta_out;
			msupaddparam = 0xf0 - (0x21 >> 1);
			break;
		default:
			msupaddparam = (c < 0x5f00) ?
				0x81 - (0x21 >> 1) : 0xe0 - (0x5f >> 1);
			break;
		}
		d = c & 0x1ff;
		d += (d < 0x100 ? (--msupaddparam, 0x9f - 0x21) :
		      d <= 0x15f ? 0x40 - 0x121 : 0x80 - 0x160);
		putc((int)(c >> 9) + msupaddparam, otf), putc((int)d, otf);
	} else
	if(!chset){
		if(c == '\n'){
			if(o_eolcr) c = '\r';
			 else if(o_eolcnv) putc('\r', otf);
		}
		putc((int)c, otf);
	} else
	if(chset == JISKANA){
		c |= 0x80;
		if(c < 0xa1 || 0xdf < c) goto geta_out;
		putc((int)c, otf);
	} else { /* Non-Jset */
	geta_out:
		fputs(GETA_MS, otf);
	}
}

static	void	do_i_subopt(c)
int	c;
{
	cswitch(c){
	case 'e': case 'u':
		common_wgetc = iso_wgetc, intype_iso = IOtype_EUC; break;
	case 'j':
		common_wgetc = iso_wgetc, intype_iso = IOtype_JIS; break;
	case 'c':
		common_wgetc = iso_wgetc, intype_iso = IOtype_CT; break;
	case 'P':
		common_wgetc = iso_wgetc, intype_iso = IOtype_PC; break;
	case 'm': case 's':
		common_wgetc = mscode_wgetc; break;
	case 'i':
		common_wgetc = muleint_wgetc; break;
	case '3':
		eucjin_x0213 ^= 1; break;

	case 't':
		i_eolcnv ^= 1; break;
	case 'z':
		i_igaftctlz ^= 1; break;
	case 'Z':
		i_ignctlz ^= 1; break;
	case 'l':
		i_linemode ^= 1; break;
	case 'f':
		i_nobuf ^= 1; break;
	case 'k':
		i_kanajis ^= 1; break;
	case 'a':
		i_i88591prior ^= 1; break;
	default:
		usage();
	}
}

static	void	do_o_subopt(c)
int	c;
{
	cswitch(c){
	case 'e': case 'u':
		wputc = eucj_wputc; outtype_iso = IOtype_EUC; break;
	case 'j':
		wputc = iso_wputc;  outtype_iso = IOtype_JIS; break;
	case 'c':
		wputc = iso_wputc;  outtype_iso = IOtype_CT;  break;
	case 'P':
		wputc = iso_wputc;  outtype_iso = IOtype_PC;  break;
	case 'm': case 's':
		wputc = mscode_wputc; break;
	case '3':
		eucjout_x0213 ^= 1; break;

	case 't':
		o_eolcnv ^= 1; break;
	case 'T':
		o_eolcr ^= 1; break;
	case 'f':
		o_nobuf ^= 1; break;
	default:
		usage();
	}
}

static	void	do_j_subopt(c)
int	c;
{
	cswitch(c){
	case '@':
		jisk_force_no0213 = JIS78K; break;
	case 'B':
		jisk_force_no0213 = JIS83K; break;
	case '+':
		jisk_force_no0213 = JIS90K; break;
	case 'p':
		jisk_unite ^= 1; break;
	default:
		usage();
	}
}

static	void	do_r_subopt(c)
int	c;
{
	cswitch(c){
	case 'J':
		roman_force = JISROMAN; break;
	case 'B':
		roman_force = ASCIISET; break;
	case 'p':
		roman_unite ^= 1; break;
	case 'H':
		swnam_as_roman ^= 1; break;
	case '1':
		r_regularize ^= 1; break;
	case 'n':
		r_regul_nokbstl ^= 1; break;
	case 's':
		r_regul_kspc2 ^= 1; break;
	default:
		usage();
	}
}

static	void	do_k_subopt(c)
int	c;
{
	cswitch(c){
	case 'I':
		jkana_out = JKANA_G0GL; break;
	case '7':
		jkana_out = JKANA_G1GL; break;
	case '8':
		jkana_out = JKANA_G1GR; break;
	case '2':
		k_regularize ^= 1; break;
	case 'd':
		k_regul_daku ^= 1; break;
	default:
		usage();
	}
}

static	void	do_c_subopt(c)
int	c;
{
	cswitch(c){
	case 'e':
		redsg_on_eof_out ^= ROMAN_G0GL; break;
	case 'l':
		redsg_on_cr_out ^= ROMAN_G0GL; break;
	case 'L':
		redsg_on_cr_out ^= UNDESIG_G123; break;
	case 's':
		redsg_on_spc_out ^= ROMAN_G0GL; break;
	case 'S':
		redsg_on_spc_out ^= UNDESIG_G123; break;
	case 'o':
		redsg_on_ctl_out ^= ROMAN_G0GL; break;
	case 'O':
		redsg_on_ctl_out ^= UNDESIG_G123; break;
	default:
		usage();
	}
}

static	void	do_C_subopt(c)
int	c;
{
	cswitch(c){
	case 'l':
		redsg_on_cr_in ^= 1; break;
	case 's':
		redsg_on_spc_in ^= 1; break;
	case 'o':
		redsg_on_ctl_in ^= 1; break;
	default:
		usage();
	}
}

static	void	do_f_subopt(c)
int	c;
{
	cswitch(c){
	case 'E':
		nonjset = NONJ_EUCtype; break;
	case 'I':
		nonjset = NONJ_G0GL; break;
	case 'C':
		nonjset = NONJ_CTtype; break;
	case '2':
		nonjset = NONJ_JP2type; break;
	case 'p':
		nonjset = NONJ_Preserve; break;
	default:
		usage();
	}
}

static	void	do_u_subopt(c)
int	c;
{
	cswitch(c){
	case '4':
		desig4byte ^= 1; break;
	default:
		usage();
	}
}

static	void	do_x_subopt(c)
int	c;
{
	cswitch(c){
	case 'j':	/* JISX0213 standard */
		msgaiji_conv = MSGAIJI_0213; break;
	case 't':	/* TOG/JVC standard */
		msgaiji_conv = MSGAIJI_TOGJ; break;
	case 'y':	/* Original yakc, SONY NEWS */
		msgaiji_conv = MSGAIJI_ORIG; break;
	default:
		usage();
	}
}

static	void	do_3_subopt(c)
int	c;
{
	cswitch(c){
	case 'c':
		x0213_1_compat ^= 1; break;
	case 'f':
		x0213_1_force ^= 1; break;
	case 'n':
		x0213_1_nouse ^= 1; break;
	case 'C':
		x0213_2_compat ^= 1; break;
	case 'F':
		x0213_2_force ^= 1; break;
	case 'N':
		x0213_2_nouse ^= 1; break;
	case 'd':
		eucjout_k_unite ^= 1; break;
	case 'D':
		eucjout_h_unite ^= 1; break;
	default:
		usage();
	}
}

static	void	do_h_subopt(c)
int	c;
{
	cswitch(c){
	case '7':
		jhojo_out = JHOJO_SS3; break;
	default:
		usage();
	}
}

static	void	do_opt(c, optarg)
int	c;
char	*optarg;
{
	void	(*do_subopt_fn)(
#ifdef __WATCOMC__ /* sigh */
			int
#endif
		);

	for(;;){
		cswitch(c){
		case 's': initstring = optarg; return; /* ڒEo */

		case 'i': do_subopt_fn = do_i_subopt; break;
		case 'o': do_subopt_fn = do_o_subopt; break;
		case 'j': do_subopt_fn = do_j_subopt; break;
		case 'r': do_subopt_fn = do_r_subopt; break;
		case 'k': do_subopt_fn = do_k_subopt; break;
		case 'c': do_subopt_fn = do_c_subopt; break;
		case 'C': do_subopt_fn = do_C_subopt; break;
		case 'f': do_subopt_fn = do_f_subopt; break;
		case 'u': do_subopt_fn = do_u_subopt; break;
		case 'x': do_subopt_fn = do_x_subopt; break;
		case '3': do_subopt_fn = do_3_subopt; break;
		case 'h': do_subopt_fn = do_h_subopt; break;
		default:
			usage();
		}
		for(; *optarg && *optarg != ','; optarg++)
			(*do_subopt_fn)(*optarg);
		if(!*optarg) break;
		c = *++optarg;
		if(!*++optarg) usage();
	}
}

static	void	alloc_iobufs()
{ /* ibufobuf蓖ĂꂸNULL̂܂܂ɂȂĂG[Ƃ͂Ȃ */
	if(o_nobuf){
		if(!i_nobuf){ /* ibuf */
			ibuf = malloc(ibufsiz = BIGBUFSIZ);
			if(ibuf == NULL) ibuf = malloc(ibufsiz >>= 1);
		}
	} else { /* ȂƂobuf͂ */
		obuf = malloc(obufsiz = BIGBUFSIZ);
		if(obuf == NULL) obuf = malloc(obufsiz >>= 1);
		if(obuf == NULL || i_nobuf) return;

		 /* ibuf */
		ibuf = malloc(ibufsiz = obufsiz);
		if(ibuf == NULL){
			ibufsiz -= (obufsiz >>= 1);
			ibuf = obuf + obufsiz;
		 /* ƂreallocɂȂ */
		}
	}
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c, err_status = 0;

	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;
	while(EOF != (c = getopt(ac, av, "i:o:j:r:k:c:C:f:u:s:x:3:h:"))){
		do_opt(c, optarg);	 /* Cusage() */
	}
	av += optind, ac -= optind;
#ifdef MSDOS
	i_igaftctlz ^= i_eolcnv;
#else
	i_ignctlz ^= i_eolcnv;
#endif
	x0213_compat = (x0213_1_compat || x0213_2_compat);

	 /* o̓R[h̎ʂɂ */
	switch(outtype_iso){
	case IOtype_CT:
		desig4byte ^= 1;		/* -u4 */
		if(jkana_out == JKANA_UNDEF)
			jkana_out = JKANA_G1GR; /* -k8 */
		if(nonjset == NONJ_UNDEF)
			nonjset = NONJ_CTtype;	/* -fC */
		break;
	case IOtype_PC:
		if(jkana_out == JKANA_UNDEF)
			jkana_out = JKANA_G1GR; /* -k8 */
		 /* ȉ͊YPƃIvVȂ */
		jisk_force_no0213 = PCKANJI, roman_force = PCROMAN;
		break;
	}
	if(jkana_out == JKANA_UNDEF) jkana_out = JKANA_G0GL;
	if(nonjset == NONJ_UNDEF) nonjset = NONJ_Preserve;   /* default */

	if(x0213_1_nouse) x0213_1_force = 0;
	if(x0213_2_nouse) x0213_2_force = 0;
	eucjin_x0213_G1 = ((eucjin_x0213 || x0213_1_force) && !x0213_1_nouse);

	jisk_force = x0213_1_force ? J213K1 : jisk_force_no0213;
	jishojo_force = x0213_2_force ? J213K2 : JISSUPK;
	jisk_G1 = eucjout_x0213 ? J213K1 : jisk_force_no0213;
	jishojo_G3 = eucjout_x0213 ? J213K2 : JISSUPK;

	 /* o̓R[h̓IvVŊɌ܂ĂBZbg̏Ԃ
	    (STDSTAT, WRSTAT)B܂RDSTATɏԂ߂WRSTAT, STDSTAT
	    ɃRs[ARDSTAT͌ŉ߂ċ߂ */
	in_designate_to_thebuf(
		outtype_iso == IOtype_CT ? ASCIISET : roman_force, G0);
	in_designate_to_thebuf(
		outtype_iso == IOtype_EUC ? jisk_G1 :
		outtype_iso == IOtype_CT ? LATIN1SET : JISKANA, G1);
	in_designate_const(jishojo_G3, G3);
	if(wputc == mscode_wputc) kanjitreatflg = MULBYTECHAR; /* ł */
	setinit(initstring); /* RDSTATKɕς */
	 /* ܂łł܂RDSTATɏԂ܂̂ŃRs[ */
	memcpy(&iostat[STDSTAT], &iostat[RDSTAT], sizeof(struct iosetinfo));
	memcpy(&iostat[WRSTAT], &iostat[STDSTAT], sizeof(struct iosetinfo));
	 /* RDSTAT͌ŉ߂Č߂ */

	if(r_regularize){
		if(r_regul_nokbstl){
			Conv21(0x41) = Conv21(0x31) =
			Conv21(0x40) = Conv21(0x6f) = '\0';
		} else switch(roman_force){
		case JISROMAN:
			Conv21(0x41) = '\0', Conv21(0x31) = '~';
			 /* FALLTHROUGH */
		case PCROMAN:
			Conv21(0x40) = '\0', Conv21(0x6f) = '\\';
			break;
		}
	}

	fsetbin(stdout);
	alloc_iobufs(); /* ibuf, obuf蓖āA傫ibufsizobufsiz */
	if(o_nobuf){
		setbuf(stdout, NULL);
	} else {
		if(obuf != NULL && 0 != setfbuf(stdout, obuf, obufsiz))
			cantbuf();
	}

	if(!ac){
		yakc(stdin);
	} else {
		for(; ac; --ac, ++av){
			if(**av == '-' && !av[0][1]){
				yakc(stdin);
				clearerr(stdin);
			} else {
				FILE	*f;

				if(NULL == (f = fopen(*av, "r"))){
					cmd_errmsg(s_conv_to_unix_format(*av));
					fputs(": Can't open\n", stderr);
					err_status = 1;
					continue;
				}
				yakc(f);
				fclose(f);
			}
		}
	}

	/* if(redsg_on_eof_out & UNDESIG_G123){} */ /* Ӗ */
	if((redsg_on_eof_out & ROMAN_G0GL) && !(Curset(WRSTAT,GL) & ROMANSET)){
		desinvkseq_out(stdout, roman_force, G0, GL);
	} /* ŌROMANIĂ */
	if(fclose(stdout) != 0 && !isatty(fileno(stdout))){
		cmd_errmsg("Can't write to stdout\n"), exit(1);
	}
	return err_status;
}

static	void	setinit(s)
char	*s; /* s: "1b2442c" */
{
	us_int	c, d, l;

	if(s == NULL) return;

	l = strlen(s);
	if(l & 1){
	error:
		cmd_errmsg("Error in initial string\n"), exit(1);
	}
	if(l > (UBUFSIZ - 1) * 2){
		cmd_errmsg("Initial string too long\n"), exit(1);
	}
	ungetch(uEOF);
	while(l){
		c = s[--l];
		if(is_xdigit(c)) c = ctoi(c); else goto error;
		if(l & 1){
			d = c;
		} else {
			c <<= 4; c |= d; ungetch(c);
		}
	}
	while(wEOF != iso_wgetc((FILE *)NULL)); /* RDSTAT낢ς */
}

static	void	yakc_setbuf(inf)
register FILE	*inf;
{
#ifdef MSDOS
	fsetbin(inf);
#endif
	if(i_nobuf){
		setbuf(inf, NULL);
	} else {
		if(ibuf != NULL && 0 != setfbuf(inf, ibuf, ibufsiz)) cantbuf();
		 /* obt@t@CԂŎ荇ɂȂ邱Ƃ͂Ȃ */
	}
	unget_sp = 0; /* Ô */
}

static	void	yakc_intro(inf)
register FILE	*inf;
{ /* ̓R[hȂǓ͂̏ */
	register us_int	c;

	 /* ̓R[ȟ */
	if(common_wgetc != NULL){
		wgetc = common_wgetc;
	} else
	if(initstring != NULL){
		wgetc = iso_wgetc;
	} else {
		 /* ̎_wgetc͖ ܂܂wgetc͎gȂ */
		for(;;){
			c = getch(inf); /* us_intɂEOF0xff */
			if(0x21 <= c && c <= 0x7e){
				(*wputc)(makewch(c, roman_force | G0), stdout);
			} else switch(c){ /* 0x00`0x20, 0x7f`0xff, EOF */
			case ESC:
				if(peekch(inf) != '[') goto decide;
				goto other_ch;
			case '\n':
				if(i_linemode) goto decide;
				goto other_ch;
			case '\r':
				if(i_linemode) goto decide;
				if(i_eolcnv && (c = getch(inf)) != '\n')
					(ungetch(c), c = '\n');
				goto other_ch;
			case SI: case SO: case ASS2: case ASS3:
				goto decide;
			case DOSEOF:
				if(i_igaftctlz) goto decide;
				if(i_ignctlz) continue;
				goto other_ch;
			default: /* ܂EOF */
				if(0x80 <= c) goto decide;
				 /* FALLTHROUGH */
			other_ch:
				(*wputc)(ctowc(c), stdout);
				continue;
			}
		}
	decide:
		ungetch(c);
		decide_incode(inf); /* wgetcɉ */
	} /* Ɠ̓R[h܂ */

	memcpy(&iostat[RDSTAT], &iostat[STDSTAT], sizeof(struct iosetinfo));
	 /* setinit()ĂԂSTDSTATRs[ */
	if(wgetc == iso_wgetc && initstring == NULL){
#if 0 /* ͕sv? */
		in_designate_to_thebuf(
			intype_iso == IOtype_CT ? ASCIISET : roman_force, G0);
#endif
		in_designate_to_thebuf(
			intype_iso == IOtype_EUC ?
			    (eucjin_x0213_G1 ? J213K1 : jisk_force_no0213) :
			intype_iso == IOtype_CT ? LATIN1SET : JISKANA, G1);
		in_designate_to_thebuf(
			!x0213_2_nouse && (x0213_2_force || eucjin_x0213) ?
				J213K2 : JISSUPK, G3);
		 /* eucjin_x02131łAx0213_[12]_{nouse,force}1Ȃ
		    ɋ */
	}
	if(r_regularize || k_regularize){
		plain_wgetc = wgetc, wgetc = special_wgetc;
	}
}

#define NEXT_96CH 0x30
#define AFTER_ESC 0x20
#define AFTER_SS2 0x10

static	void	decide_incode(inf)
register FILE	*inf;
{
	register us_int	c;
#ifdef LSI_C
	signed char
#else
	int
#endif
		eucj_rest = 0, jis_rest = 0, mscode_rest = 0,
		i88591_rest = 0, muleint_rest = 0, possible_codes = 5;
	int	tmp_sp;
	bool	esc_found = 0; /* EUCJJIS̋ʂȂ̔p */
	bool	mintnonj_found = 0,
		mintk_found = 0; /* MULEINTMSCODEʂȂ̔ڈ */

	tmp_sp = UBUFSIZ;
	for(;;){
		if(possible_codes < 2 || !tmp_sp) break;
		if(uEOF == (unget_buf[--tmp_sp] = c = getch(inf)) ||
		   i_linemode && (c == '\r' || c == '\n') ||
		   i_igaftctlz && c == DOSEOF){
			if(eucj_rest) (eucj_rest = -1, --possible_codes);
			if(jis_rest) (jis_rest = -1, --possible_codes);
			if(mscode_rest) (mscode_rest = -1, --possible_codes);
			if(muleint_rest) (muleint_rest = -1, --possible_codes);
			if(i88591_rest) (i88591_rest = -1, --possible_codes);
			break;
		} /* tmp_sp < unget_sp ƂȂ邱Ƃ͂Ȃ */

		switch(mscode_rest){
		case AFTER_ESC:
			if(c == '['){
				goto mscode_yet_possible;
			} else {
				goto mscode_impossible;
			}
			break;
		case 1:
			if(0x40 <= c && c <= 0xfc && c != 0x7f){
			mscode_yet_possible:
				mscode_rest = 0;
			} else {
				goto mscode_impossible;
			}
			break;
		case 0:
			if(c == ESC){
				mscode_rest = AFTER_ESC;
			} else
			if(!(c & 0x80) && c != SI && c != SO ||
			   0xa0 <= c && c <= 0xdf){
				/* nothing */
			} else
			if(0x81 <= c && c <= 0xfc){
				++mscode_rest;
			} else {
			mscode_impossible:
				mscode_rest = -1, --possible_codes;
			}
			break;
		}
		switch(eucj_rest){
		case -1:
			break;
		case 0:
			if(c == ESC){
				eucj_rest = AFTER_ESC;
			} else
			if(!(c & 0x80) && c != SI && c != SO){
				/* nothing */
			} else
			if(0xa1 <= c && c <= 0xfe){
				++eucj_rest;
			} else
			if(c == SS2){
				eucj_rest = AFTER_SS2;
			} else
			if(c == SS3){
				eucj_rest = 2;
			} else {
			eucj_impossible:
				eucj_rest = -1, --possible_codes;
			}
			break;
		case AFTER_ESC:
			if(' ' <= c && c <= 0x7e){
				goto eucj_yet_possible;
			} else {
				goto eucj_impossible;
			}
			break;
		case AFTER_SS2:
			if(0xa1 <= c && c <= 0xdf){
			 /* ʒ2oCgڂ0xa0̉\͔l
			    default caselAmuleint̔łl */
			eucj_yet_possible:
				eucj_rest = 0;
			} else {
				goto eucj_impossible;
			}
			break;
		default: /* case 1, 2 */
			if(0xa1 <= c && c <= 0xfe){
				--eucj_rest;
			} else {
				goto eucj_impossible;
			}
			break;
		}
		switch(jis_rest){
		case 0:
			if(c == ESC){
				esc_found = 1;
			} else
			if(!(c & 0x80) || 0xa1 <= c && c <= 0xdf){
				/* nothing */
			} else {
				--jis_rest, --possible_codes;
			}
			break;
		}
		switch(i88591_rest){
		case AFTER_ESC:
			if(c == '['){
				i88591_rest = 0;
			} else {
				goto i88591_impossible;
			}
			break;
		case 0:
			if(c == ESC){
				i88591_rest = AFTER_ESC;
			} else
			if(!(c & 0x80) || 0xa0 <= c){
				/* nothing */
			} else {
			i88591_impossible:
				i88591_rest = -1, --possible_codes;
			}
			break;
		}
		switch(muleint_rest){
		case -1:
			break;
		case 0:
			if(!(c & 0x80)){
				/* nothing */
			} else
			if(0x81 <= c && c <= 0x8d){
				switch(c){
				case 0x8b:
					goto muleint_impossible;
				case MULE_KANA_RDNG:
					muleint_rest = AFTER_SS2; break;
				case MULE_JISR_RDNG:
					muleint_rest = 1; break;
				default:
					muleint_rest = NEXT_96CH;
					mintnonj_found = 1;
					break;
				}
			} else
			if(0x90 <= c && c <= 0x96){
				switch(c){
				case MULE_OKNJ_RDNG:
				case MULE_KNJ_RDNG:
				case MULE_SUPK_RDNG:
					muleint_rest = 2;
					mintk_found = 1;
					break;
				default:
					muleint_rest = 2;
					mintnonj_found = 1;
					break;
				}
			} else {
			muleint_impossible:
				muleint_rest = -1, --possible_codes;
			}
			break;
		case AFTER_SS2:
			if(0xa1 <= c && c <= 0xdf){
				muleint_rest = 0;
			} else {
				goto muleint_impossible;
			}
			break;
		case NEXT_96CH:
			if(0xa0 <= c && c <= 0xff){
				muleint_rest = 0;
			} else {
				goto muleint_impossible;
			}
			break;
		default: /* case 1, 2 */
			if(0xa1 <= c && c <= 0xfe){
				--muleint_rest;
			} else {
				goto muleint_impossible;
			}
			break;
		}
	}

	bcopy((char *)(unget_buf + tmp_sp), (char *)(unget_buf + unget_sp),
			sizeof(us_int) * (UBUFSIZ - tmp_sp));
	unget_sp += UBUFSIZ - tmp_sp;
	if(eucj_rest >= 0 && !(jis_rest >= 0 && esc_found && i_kanajis)){
		wgetc = iso_wgetc;
		intype_iso = IOtype_EUC;
		 /* ̏ꍇJISƔ肷BJISłȂ̕^N^O
		    oĂꍇɑΏ邽߁B̃P[XŁA
		    ISO8859-1DIvVw肳Ăꍇ́A
		    ISO8859-1̉\𒲂ׂ */
	} else
	if(i_i88591prior && i88591_rest >= 0){
		goto select_i88591;
	} else
	if(jis_rest >= 0){
		wgetc = iso_wgetc;
		intype_iso = IOtype_JIS;
	} else
	if(mscode_rest >= 0 &&
	!(muleint_rest >= 0 && mintk_found && !mintnonj_found && !i_linemode)){
		wgetc = mscode_wgetc;
	} else
	if(muleint_rest >= 0){
		wgetc = muleint_wgetc;
	} else
	if(i88591_rest >= 0){
	select_i88591:
		wgetc = iso_wgetc, intype_iso = IOtype_CT;
	} else {
		wgetc = iso_wgetc;
		intype_iso = (esc_found ? IOtype_JIS : IOtype_EUC);
	}
}

static	void	yakc(inf)
register FILE	*inf;
{
	wchar4b	c;

	yakc_setbuf(inf);
	if(!i_linemode){
		yakc_intro(inf); /* œ̓R[hm */

		 /* ̓R[h̊m܂ł͂ʂ炸
		    ̂܂܏oĂ̂Œ */
		while(wEOF != (c = (*wgetc)(inf))){
			(*wputc)(c, stdout);
		}
	} else {
		for(;;){
			yakc_intro(inf); /* œ̓R[hm */
			for(;;){
				if(wEOF == (c = (*wgetc)(inf))) return;
				(*wputc)(c, stdout);
				if(c == ctowc('\n') || c == ctowc('\r'))
					break;
			}
		}
	}
}
