
SETARG(3)		Reference Manual		SETARG(3)


NAME

	setarg - R}hsWJp̃Cu֐Q


SYNTAX

	#include <stdio.h>
	#include "tools.h"

	int	split_word(char *cmdpath, char *argstr, char **argv_area);
	int	split_word_alloc(char *cmdpath, char *argstr, char **argv_area);
	int	expand_envvar(char *argstr);
	int	expand_indirects(int argc, char **argv, char ***new_argv_ptr);
	int	expand_bquote(int argc, char **argv, char ***new_argv_ptr);
	int	expand_braces(int argc, char **argv, char ***new_argv_ptr);
	int	expand_home(int argc, char **argv, char ***new_argv_ptr);
	int	expand_wild(int argc, char **argv, char ***new_argv_ptr);
	int	expand_arg(char *cmdpath, char *argstr, char ***new_argv_ptr);
	void	unquote_arguments(int argc, char **argv);
	void	discard_argv(char **argv);
	char	*get_psp_arg(void);
	char	*get_long_arg(char *arg);
	void	expand_hook(void);
	void	expand_hook_default(void);
	void	expand_control(void);

	int	parse_wild(char *pat, WILD_INTERNAL *intrep);
	int	lname_match(char *ref. char *longref, WILD_INTERNAL *intrep);
	int	name_match(char *ref, WILD_INTERNAL *intrep);
	void	discard_internal(WILD_INTERNAL *intrep);

	char	**expand_wildcard(char *name);
	char	**expand_wildcards(char **names);
	void	discard_wildcard(char **wildcards);
	void	make_internal(char *s, char *buf);
	int	string_match(char *ref, char *pat_compiled);
	void	setup_arguments(int *argcp, char ***argvp);

	extern	int	_wildcard_match;
	extern	int	_wildcard_exist;
	extern	int	_wildcard_add_nomatch;
	extern	int	_wildcard_check_nomatch;
	extern	int	_wildcard_check_nomatch_all;
	extern	int	_expand_abendcode;
	extern	int	_dosfind_param;
	char	*cmdname;
	extern	int	_lfnsupp_level;
	extern	int	_norestore21_onexec;


DESCRIPTION

	{}jÁAtools̏R}h(awkEPerlob`Ŏꂽ
	̂)ʂɗpĂAR}hsWJp̏Cu
	֐̉łB̃[`N΁AtoolsƓ
	ÃR}hɊȒPɑgݍ߂(͂ł)BLSI C-86g
	ꍇ́Ã[`̓X^[gAbv[`ƂĎĂA
	tools̔zzA[JCumakeĂłtlexpand.libN邾
	ŃvOɑgݍ߂(߂main()̎sȑOɍs)B
	ǂ̂悤Ȉߋ@\邩ɂẮA}jAwild(5)Q
	̂ƁB


EXPANSION FUNCTIONS

	ȉ́AWJp̏֐łB

	split_word() ́AR}hcmdpathƁAR}hs1ɂ܂Ƃ
	argstr(vZXpspZOg0x81Ԓnȍ~A0x0d܂ł
	A邢͂̃Rs[BA0x0d͏NULLŏI
	Ă邱)󂯎A󔒂ŕāACmain()ar
	gv[]Ɠ`argv_areaɎ(I[ɂNULL|C^)Aargc
	鐮ԂB]āAargstr̒127oCg܂łł邱
	OƂB̏ꍇA󔒂ŕƍő64ɕ
	ŁAargv_areaɂ(char *)^̃f[^66ȏオ̈mۂĂ
	(̕ʂ64ƁAR}hяI[NULL|C^
	Ōv66)Bargv[0]UNIX́AŃpX؂Ɂu/vg`
	ɏB̊֐͐V̈͑SmۂAn
	argstr𒼐ڏĕ邱ƂɒӁBȂÅ֐̓NH
	[gu"vu'vyсu`vӎsANH[g
	͍sȂB

	split_word_alloc() split_word() ɎĂ邪Aargv_areaɎ߂
	|C^zɂA܂̔zɔ[߂e|C^w
	ɂAVKɊ蓖Ă̈g_قȂB̂߁A
	cmdpathargstrmallocꂽGAgĂꍇ́A{֐Ă
	oɂ͂freeĂ悢Bargstr̒̏킩Ȃ
	ꍇ(Ⴆ΃R}hsexpand_envvar() ŉHꍇ)́Asp
	lit_word()łȂg˂΂ȂȂB܂Aargv_areaɂ(ch
	ar *)̔zł͂ȂAPȂ(char **)^̃|C^nƁBȂA
	argstr͖{֐Ăяoɂď邱Ƃ͂ȂB

	expand_envvar() ́AR}hs1ɂ܂Ƃ߂argstr(sp
	lit_word()ɓn̂Ɠl̂)󂯎Au$vŕ\
	̓WJsʂ̕AVKɊ蓖Ă̈ɓ
	ĕԂBϐ̓WJsȂԂɂꍇ́A̒PȂR
	s[VK蓖ăɓĕԂB

	expand_indirects() ́ACmain()argvargcɑ镶
	zƐ󂯎(^argvNULL|C^ŏI[ĂKv
	Ȃ)AԐڈWJĐVȈXgBʂargvɑ
	̂new_argv_ptr̎wɓAargcɑ̂ԂB
	^镶ẑargv[0]͓WJȂBԂXgp
	̃͑SĐVɊ蓖ĂB̊֐̓NH[gu"vu
	'vyсu`vӎsANH[g͍̏sȂB

	expand_bquote() , expand_braces() , expand_home() , expand_wild()
	͂ꂼAu` `vAu{ }vAu~vAChJ[h̓WJs
	ƈȊÓAexpand_indirects()ƓłBAexpand_wild()́A
	ŏIIɃNH[g̏sBȂAexpand_wild()̃ChJ
	[hWJʂ͏ɂȂ(ChJ[h܂܂Ȃ̑啶
	̋ʂ͕ۑ)B܂AChJ[h̓WJʂɂ͕st@
	C(VXet@C܂)͌ƂĊ܂܂Ȃ(ϐ_dosf
	ind_param ̒lςꍇ͂̌ł͂ȂBEXTERNAL VARIABLES
	̍Q)B

	expand_arg() ́AR}hcmdpathƁAR}hs1ɂ܂Ƃ
	argstr^āAȏ6expand_~~()֐ɌĂ
	oĈWJsAʂargcɂ̂ԂAargvɂ
	̂new_argv_ptr̎wɓB܂AR}h\
	AOϐcmdnameɓBtools̈WJ́Å֐̌Ăяo
	ɂčsĂB

	unquote_arguments() ́AargcŎw肳ꂽargv̓e(argv[
	0]͏)ɑ΂ANH[gu"vu'v̏sBargv̓
	e̊e񂪒ڏAVȃ蓖Ă͍sȂB
	ChJ[hWJsȂR}hł́Aexpand_wild()̑
	̊֐ĂяoāAŏIIȃNH[g̏sB

	discard_argv() ́Aexpand_indirects() , expand_bquote() , expand
	_braces() , expand_home() , expand_wild() ̏֐蓖Ă
	B́Å֐Ăяo*new_argv_pt
	rɓꂽlłB̊֐́AƂė^ꂽ|C^
	argvƂƁAargv[0], argv[1], cNULL|C^܂ŉ
	AŌargvB

	get_psp_arg() ́AvZXPSPZOg0x81Ԓnȍ~ɂAR
	}ḧAÓIȃobt@ɓĕԂBԂꂽ
	́Asplit_word(), split_word_alloc()܂expand_arg()̑1
	ĎgƂłB̊֐͖{CȗRpCւ̈
	AlĐ݂ꂽ̂ŁAtools̃R}hł͎ۂɂ͎gĂ
	ȂB
	LSI C-86ȊÕRpC֖{CuڐAꍇAT^I
	ȃAvP[VvOłmain()͎̂悤ɏ邱Ƃ
	Ȃ낤(WJ֐X^[gAbv[`ŎIɌĂ΂̂
	Ȃ)B

		#include <stdio.h>
		#include "tools.h"
		 /* ARGSUSED */
		main(int argc, char **argv) /* Actually, argc is not used */
		{
			...local-variable-definitions...

			/* First call expand_arg, and
			   proceed as if it were not called. */
			argc = expand_arg(argv[0], get_psp_arg(), &argv);

			...regular process...
		}

	get_long_arg() ́ADOS7ȍ~ɂāA܂łDOS̐ł126oC
	g𒴂钷R}h󂯎邽߂̊֐łBɂ́A
	PSPݗ̕@Ŏ擾(Ⴆget_psp_arg()̕Ԃl)
	^(A̖0x0dtĂĂȂĂ悢)B{
	֐́AR}hɗ^ꂽAϐCMDLINE
	̃R}hɗ^ꂽłƔfłꍇɂ́ACMDLIN
	Ê̕AłȂarĝ̂ԂB{֐Ԃ
	̍Ōɂ0x0dtĂȂƂɒӁB{֐̕ԂĺAget_
	psp_arg()̂ƓlAsplit_word(), split_word_alloc()܂exp
	and_arg()̑1ƂĎgƂłB

	expand_hook() ́AWJ[`̐U镑ς邽߂̎d|
	łAT^Iɂ́AEXTERNAL VARIABLES̍ɂĐϐ̒lA
	R}hC̃ChJ[h̓WJOɕύX邽߂ɗp
	BEXTERNAL VARIABLES̍QƁB

	expand_hook_default() ́AftHgexparg_hook()֐Bs
	Ă֐łBWJɐ旧čsׂݒs
	߂ɌĂ΂B݂̂Ƃ낱̊֐̎ۂ̓́ALong filenam
	e(ȉLFN)̃T|[gɊւ̂łBOSLFNT|[gĂ
	ǂ𒲂ׁAT|[gĂtoolsLFNT|[gœ삷邽
	߂̐ݒsBڂlfn(5)QƁBexparg_hook()̒ȊOŌĂ
	͂ȂB

	expand_control() ̓}NŁA̎̂expand_hook() ƓłB
	ߋƂ̌݊̂߂ɎcĂB


MATCHING FUNCTIONS

	ȉ̊֐́AChJ[h̃RpCEƍs߂
	̂łBʂexpand_wild() ̓葱ƂČĂ΂邪A
	[UŃChJ[h̏ƍsɂ́A
	֐zɌĂԂƂłB܂AChJ[hparse_wi
	ld() gē\ɕϊAlname_match() gďƍs
	A\svɂȂdiscard_internal() ŉAƂ
	菇𓥂ނ̂WłB

	parse_wild() ̑1patɂ̓ChJ[h܂(mȂ)
	A2intrepɂWILD_INTERNAL^̃f[^w|C^
	^Bparse_wild()́A1̕\ɕϊAintre
	p̎w֓BKvȃobt@͎IɊmۂ(AAintr
	epWILD_INTERNAL^̃f[^wȃ|C^łȂ΂ȂȂ)B
	patɃChJ[h܂܂ĂΔ0AȂ0ԂBȂA
	patɃpX؂蕶(u:vu/vu\v)܂܂ĂĂ͂ȂȂ(
	lname_match()A܂name_match()Al
	fsȂ)B

	lname_match() ̓ChJ[h̏ƍsB1E2ɂ̓C
	hJ[hƔrt@C̖Oł镶^(pX؂
	u:vu/vu\v܂܂ĂĂ͂ȂȂ)B1̃t@
	CShort filename(ȉSFN)A2LFNłBAASFN
	Ȃt@C̏ꍇ́A1ɂ͋󕶎A2SFN^
	邱ƁB3ɂparse_wild()̌Ăяoɂē\i[
	WILD_INTERNAL^ւ̃|C^^BvΔ0AȂ
	0ԂBSFNLFN̗^˂΂ȂȂ킯́Atools̃Ch
	J[hWJ͕WłSFNLFN̗ĂAƗ
	ɌĂ킯ł͂Ȃ(Ⴆ΁ALFNu.vŎn܂Ă΁AƂ
	SFNu.vŎn܂Ă炸^ꂽp^[ɍvĂĂA
	}b`̑ΏۊOƂȂ)߂łB

	name_match() lname_match() ƈāAt@C1^
	ƂłȂȂ͓l̓łB̓}NłB
	݂ł́Alname_match() ̓ŌĂ΂̂ƁAtoolsLFNΉ
	RpCꍇɌĂ΂ȊÓAȗprɂgꂸA
	ɉߋ̔łƂ̌݊̂߂ɎcĂB

	discard_internal() ́Aparse_wild()ɂĊmۂꂽobt@j
	Bɂ́Aparse_wild()̌Ăяoɂē\i[
	WILD_INTERNAL^ւ̃|C^^Bdiscard_internal() ̓}N
	łB


BACKWARD COMPATIBILITIES

	ȉ́Atools̃o[W2.xx܂Œ񋟂ĂCu֐łA
	݂toolsł͎gpĂȂA݊̂߂Ɍ݂񋟂Ă
	B

	expand_wildcard() ̓ChJ[hƂĎ󂯎AW
	Jʂ𕶎̔zƂĕԂBԂz(char*)0ŏIB
	WJʂmallocgIɊmۂꂽɊi[B
	͓expand_wild()Ăяo悤ɂȂĂB

	expand_wildcards() expand_wildcard() ɎĂ邪A̔z
	((char*)0)ŏI)ƂĎ󂯎ÃChJ[hp^
	[xɓWJBAAnznames̍ŏ̗vfnames[0]
	WJȂ(R}hɓ邱Ƃz肵Ă邽)B
	͓expand_wild()Ăяo悤ɂȂĂB

	discard_wildcard() expand_wildcard() , expand_wildcards() ɂ
	ĊmۂꂽBdiscard_argv ւ̃}NłB

	make_internal() string_match() ̓ChJ[h̃RpC
	EƍsB܂AChJ[hmake_internal() g
	ē\ɕϊAstring_match() gďƍsAƂ
	菇𓥂ށB

	make_internal() ́AƂăChJ[hA
	Ƃē\i[邽߂̃obt@ւ̃|C^BāA
	ChJ[h\ɕϊAŎ
	obt@֊i[B\́ÃChJ[h̒
	邱Ƃ͂ȂBmake_internal() œ\́Aparse_wi
	ld() œ̂Ƃ͑SႤ̂ŁA҂̍p͂łȂB

	string_match() ́A镶()make_internal() ɂ
	ꂽ\()̏ƍsBv1AȂ0
	ԂB

	setup_arguments() ́AԐڈ̓WJsBargcp, argvp̎wl
	͐VlɏBAAnz*argvp̍ŏ̗vf*a
	rgvp[0]͓WJȂ(R}hɓ邱Ƃz肵Ă邽
	)BWJʂ͐V蓖ĂꂽɊi[B݂set
	up_arguments() ́A}NłB


EXTERNAL VARIABLES

	ChJ[h[`𗘗p鑤͎̂悤Ȃ̊O
	ϐlQ/ύX邱ƂłB

	_wildcard_exist ͓ǂݏopϐŁAl0łBexpand_wild
	() Anꂽ1WJĂߒɂāAChJ
	[h̊܂܂0ȊO̒lɃZbgBx
	0ȊO̒lɂȂƃvO}z0ɖ߂Ȃ0ɃZbg
	Ƃ͂ȂB

	_wildcard_match ́A͂ǂݏopϐŁAl0łBexp
	and_wild() Anꂽ1WJĂߒɂāA
	ChJ[h܂ވAt@Cւ̃}b`ɐɁA0
	O̒lɃZbgBAU0ɂȂƃvO}z0
	Ȃ0ɂ͖߂ȂBȂAexpand_wild() ̈ɃChJ[
	hĂȂꍇ͂̕ϐ̒l͕ωȂB̕ϐ́u
	܂łɃChJ[hɃ}b`t@CvƂ
	\̂ƍlĂB

	_wildcard_check_nomatch ͏ݗp̕ϐŁAl0łB
	̕ϐ̒l0ȊO̒l̎ɂ́Aexpand_wild() Anꂽ1
	WJĂߒɂāA_wildcard_exist 0ł_wild
	card_match 0ƂԂNƁAuNo match.vƂbZ[W
	o͂ăvOIB܂A}b`t@C
	ȂChJ[h_ŃG[I킯łB
	ȂAtools.h̒ɁA_wildcard_nomatchƂ}NA(_wildcard
	_exist && !_wildcard_match) ƂĒ`ĂB

	_wildcard_check_nomatch_all ݗp̕ϐŁAl1łB
	̕ϐ̒l0̎ɂ́Aexpand_wild() S̃ChJ[h
	WJŁA_wildcard_exist 0ł_wildcard_match 
	0ƂԂɂȂĂƁAuNo match.vƂbZ[Wo͂
	ăvOIBq̕ϐ_wildcard_check_nomatch 0
	ꍇƈႢArŃ}b`t@ĈȂChJ[h
	ĂA̓WJŌ܂őÃChJ[h
	ɂt@C}b`ĂȂꍇɂ̂݃G[I
	ƂɂȂB́AUNIXcsh̏ɍ킹U镑łB

	_wildcard_add_nomatch ́A͂菑ݗp̕ϐłB̕ϐ
	̒lƁAChJ[h̓WJɎsĂAWJÖ
	̂܂܎cāAWJ𐬌̂ƌȂ(UNIXshƓlɂȂ)B
	̏ꍇA_wildcard_match ̒l0ɂ̂ŁAƂ_wildcard
	_check_nomatch _wildcard_check_nomatch_all 0łĂuNo
	 match.ṽG[ɂ͂ȂȂBA̕ϐ̒l0ƁAWJ
	sꍇ͓WJʂ0łƂĈ(]Ă̌
	ł́Aϐ_wildcard_check_nomatch Ȃǂ̒lł́AuNo mat
	ch.vɂȂ邩ǂ̃`FbNs)BȂA̕ϐ̏l
	͕łȀꍇ́Aŏɂ̕ϐ̒l̃`FbNsӏ
	āAϐTL_BSHWILD ɉłlݒ肳Ă邩
	ׂBĂΐ̒lAȂ0̕ϐ̒lƂĐ
	肵A𑱍sBāÅϐ`Ă΁A
	ChJ[h̓WJɎsĂAG[ƂȂ炸ɂ̈̂
	܎cƂABVFCNȏƂȂB(ȀꍇAC
	hJ[h̓WĴ܂łBVFCNɕς킯ł͂Ȃ̂ŁA
	u{ }vȂǂLłB)

	_expand_abendcode ݗpϐŁAl1BX^[gAbv
	[`sƂ(ChJ[hWJ[`ԐڈWJ[
	`ȂǂŃsNƂANH[gނ荇ĂȂƂ)
	ɁAR}h̏IR[h̒lƂĎgB

	_dosfind_param ܂ݗpŁAl0x31łB̕ϐ
	lAChJ[hWJ[`Cn̎Cu֐_
	dos_findfirst() ĂԂƂ̑2ɎgBls R}hŊ
	ϐLSWILDALLݒ肵ꍇƁAchmod R}hł́A̕ϐ̒l
	ύX(lsł0x3fAchmodł0x37)邱ƂɂAChJ[h̓W
	Jʂɕst@CVXet@C܂߂悤ɂĂ
	B

	ȂAR}hC̃ChJ[h̓WJ̓X^[gAbv
	[`ɂčŝŁAݗp̕ϐAmain()Ăяoꂽ
	ɕύXĂAWJʂɉe^邱Ƃ͂łȂBe^
	΁Aexpand_hook() Ƃ֐Œ`(ĂяoKv͂
	BChJ[hWJ[`̒玩IɌĂ΂)A̒
	ύX˂΂ȂȂB
	i͂̊֐́Aexpand_hook_default() Ƃ֐Ăяo
	̊֐ƂāACuɒ`ĂBexpand_hook_default()
	ɂẮAEXPANSION FUNCTIONS̍QƁBexpand_hook() Œ
	`Ȃꍇ́Aexpand_hook_default() 𖾎IɌĂяoKv͂
	B܂Aexpand_hook() ̒expand_hook_default() Ă΂Ȃ
	ƂÃvOLFNT|[g̏ԂœƂɂȂ邾ŁA
	Ɏx͂ȂB
	ۂexpand_hook() Œ`ꍇ́AႦΈȉ̂悤ɂ
	B

		void expand_hook()
		{
			_dosfind_param = 0x37;
			expand_hook_default();
		}

	cmdname ́Aǂݏop̕ϐłBĺu"cmdname"vƂ
	ł邪Aexpand_arg()Ă΂ƁAR}ĥ̃pX
	gqď(Ⴆ΁Aa:/usr/local/bin/ls.e
	xesꍇɂ͕"ls")A̕ϐɓ(
	̑́ALSI C̏ꍇAmain()sOɋN邱Ƃɒ)BADO
	S2ł͍͂̑sꂸAcmdname̒l"cmdname"̂܂܂ƂȂB
	ȂÃO[oϐvOł錾Ă΁A
	炪gB̍ہAcmdnamȅlݒ肵Ă΁ADOS2ł͂
	ꂪcmdname̒lƂĕێ邱ƂɂȂB

	_lfnsupp_level ͓ǂݏopŁALFÑT|[g󋵂ϐłB
	̕ϐ̒l̓[UύXĂ͂ȂȂB̒lLFN_NOSUPP
	Ã݂vOsOŚALFNT|[gĂȂ(DO
	S6ȑOAWindows95DOSłȂDOS7)BlLFN_NONEȂAOŜ
	LFNT|[gĂ邪Atools̃R}hƂĂLFN𗘗płȂ
	Ԃœ삷BlLFN_NOWILDȂAR}hƂĂLFNT|[g
	(R}hƂăt@Cw肷ۂLFNgȂ)A
	ChJ[h̓WJɂĂLFNȂBlLFN_WILDȂAR}
	hƂLFNT|[ĝɉAChJ[h̓WJɂ
	SFNALFNBlLFN_FULLȂAChJ[h̓WJ
	ɂSFNLFN̗B
	LFNΉ̏ڍׂɂĂlfn(5)QƂ̂ƁB

	_norestore21_onexec ͏ݗpŁAl0łB̒ĺA
	R}hLFNT|[g󋵂œ삵Ă鎞ɎqvZXs
	(tools̃R}h̒łfindf, foreach, xeqY)ɉeB
	LFNT|[g󋵂̏ꍇADOSt@NVR[int 21hLFNT|[
	gp̃[`ɒuĂ邪AqvZXsꍇ
	ʏAguh~̂߂ɁAint 21hɖ߂ĂqvZX
	点AqvZXI΍ēxint 21huƂ菇
	ނ悤ɂȂĂB_norestore21_onexec ̒l0ƁAint
	 21hɖ߂ɎqvZXsBڍׂɂĂ͂͂lfn(
	5)QƂ̂ƁB


COMPILATION OPTIONS

	tools.h̐擪Œ`Ă邢̃}N`/`
	邱ƂŁAWJ[`̋𐧌䂷邱ƂłBftH
	gł͂̃}N̂EXPAND_ENVVAR͒`Ă炸A
	SĒ`ĂB

	#define SORT_ENTRY
	    ChJ[h̓WJʂ\[gBexpand_wild() Ă
	    ꍇA^ꂽp^[̓WJʖɃ\[gāAp
	    ^[̏ԂɕׂĕԂBƂexpand_wild() ɗ^
	    Xgargv[1]u*x*vAargv[2]u?adsfvƂ񂾂
	    ƂBđO҂̓WJʂ́ucerxevƁutakoxvAu?ads
	    fv̓WJʂ́uaasdfvƁueasdfvƂB̏ꍇAe
	    xpand_wild() ԂXgɂ́ucerxevutakoxvuaasdfv
	    ueasdfv̏ɕ(uaasdfvucerxevueasdfvutakoxv̏
	    ɂ͂ȂȂ)B
	    ȂÃ}N`ăRpCĂAϐTL_NOSOR
	    T ɉłlZbgĂ΁A\[g͍sȂBA
	    AChJ[h̓WJʂɃ{[xƂȊO
	    Ɋ܂߂悤ɂĂꍇ(Ⴆ_dosfind_param̒l0x3f
	    Ă鎞Btools̒ł́AϐLSWILDALLݒ肵Ă
	    lsR}hY)́AWindows95Ń{[x̂
	    lbg[NhCũ[gfBNgɂẮAp^
	    [̓WJʂ̒̃{[ẍʒúATL_NOSORTw
	    ĂꍇAfBXNł̈ʒuɊ֌WȂɍŏƂȂB
	    ́Albg[NhCuɑ΂Windows95̃VXeR[
	    ɃoO邽߂̐łB
	#define EXPAND_TILDE
	    u~vz[fBNgɓWJBϐHOME `
	    ĂȂꍇ͉NȂB
	#define IGNORE_UNDERSCORE_FILES
	    t@C擪́u_vChJ[h̃}b`Ώۂ珜OB
	    ChJ[hp^[̍ŏ̕Ƃāu_vI
	    w肳ĂꍇAႦ΁u_*vp^[ƂĎw肳ꂽ
	    ɂ́At@C擪́u_v̓ChJ[hɃ}b`
	    킯ł͂Ȃ̂ŁA̋K̓Kp󂯂ȂBUNIXcsh
	    ChJ[hɂu.vŎn܂t@C̈Ɠł
	    BȂÃ}N`ăRpCĂAϐTL_N
	    OIGN_US ɉłlZbgĂ΁At@C擪
	    ́u_v}b`Ώۂ珜OȂB܂ALFNChJ[h
	    T|[g󋵉ł́At@C擪́u_v͏Ƀ}b`Ώۂ
	    OȂB
	#define KANJI
	    MSR[h(VtgJIS)2oCgT|[gBu?v
	    ꕶɃ}b`Au[c]v̊ӎB܂A
	    2oCgڂɃChJ[h^u\vȂǂĂʈ
	    ȂB
	#define WILD_NOHIDDEN
	    ChJ[h̓WJʂɉBt@CEVXet@C
	    ܂߂ȂB
	#define EXPAND_BQUOTE
	    u` `v̓WJsB
	#define SUPP_LFN
	    LFNT|[gBۂ̐U镑͊ϐTL_USELFN̒lɂ
	    قȂ(lfn(5)Q)B
	#define EXPAND_ENVVAR
	    u$vɂϐ̓WJsBϐTL_EXPENVɐݒ肳
	    ĂlɂẮAϐWJ̐U镑኱ς(wild(
	    5)Q)B
	#define LOOK_CMDLINE
	    DOS7ȍ~ɂāAϐCMDLINEgĒR}h
	    B

	܂AmakefileCPPFLAGSɈȉ̃RpCXCb`w肷
	(tools.h̖`ɒڎw肵Ă̂)AftHgł͑gݍ
	邢̋@\OƂłB

	-DNOLFN
	    }NSUPP_LFNLOOK_CMDLINE̒`BȂ킿ALFNT
	    |[g@\(R}h󂯎@\܂)OB
	-DNOTILDE
	    }NEXPAND_TILDE̒`BȂ킿Au~vz[f
	    BNgɓWJ@\OB
	-DNOBQUOTE
	    }NEXPAND_BQUOTE̒`BȂ킿Au` `v̓WJ
	    @\OB
	-DNOENVVAR
	    }NEXPAND_ENVVAR(A̓ftHgł͒`ĂȂ)
	    ̒`BȂ킿Au$vɂϐ̓WJ@\(
	    ftHgł͑gݍ܂ȂAƂtools.h̖`EXPAND_
	    ENVVAR`ƂĂ)OB

	ÃRpCXCb``ƁAꍇɂĂmake
		lcc: can't exec: c:/c/cpp: Arg list too long
	̂悤ȃG[Ŏ~܂\B́AlccŋNR
	pCpR}hɓnȂ߂邽߂łAȂ
	ꍇ̑΍@ƂĂ͎cOȂALSI C̐ݒt@C_lcc
	ȂǂăR}hC}w͂邩A邢̓RpC
	XCb`ƂĎw肷̂߂tools.hŒڎw肷邭炢
	B

	Ȃ̑Atools̃RpC(CuAeR}hƂ)
	TOOLSƂ}N`悤ɂȂĂ(makefileQ)B
	̗ŔAtools̃R}ḧꕔ́ÃpbP[WƋpȂǂ
	RŁAtoolsÕR}hƂĂRpC邱ƂA
	ꍇ̓NWJ[`₻̑̃CuقȂ邽߁A
	tools̈ƂăRpCꍇTOOLS`邱Ƃɂ
	؂蕪Ă邩łB]āACnւ̈ڐAȂǂ̏ꍇ
	Atools̃CuȂR}hƂăRpĈ
	΁ATOOLS`ăRpC`ԂOƂĂ̈ڐA
	vB


BUGS

	WJ֐parse_wild() ́AmۂłȂꍇAG
	[bZ[W\exit(expand_abendcode) Ă܂B

	{CuAget_psp_arg()֐̐̂ƂɗᎦ悤Ȍ`
	(main()֐̒`̒ōŏɖIɖ{CuĂňW
	Js) ɂāALSI CȊOCRpCŎgpꍇA{Cu
	ȊÖWJ[`ɃNĂ܂ƁAĊ
	ҒʂɓȂȂ\̂Œӂ̂ƁB
	Ⴆ΁A{CuŎWJł́Au'v͒1
	̃NH[g̈Ӗ߁A
		R}h '?
	́AR}hɁu?vƂ^ċNӖBƂ낪A
	ɖ{CuȊOɁAu' 'vuɋ܂ꂽNH[g
	v̈ӖɎg悤ȈWJ[`ƂAꂪ̃R
	}hɓɃNĂ܂Aꂪmain()̎sOɔ
	IɌĂ΂悤ɂȂĂƁAɂꂪu'?vWJ悤
	āAuw'xނ荇ȂvƂG[NĂ܂m
	Ȃ̂łB


SEE ALSO
	wild(5), lfn(5), intro(1), X̃R}h̃}jA(1)
