#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include "tools.h" /* ESCAPEdefineĂ镶2oCgڂɂȂ肤
  ̂łꍇ̂Ƃ͍lĂȂB'\''͂ł͂Ȃ */
#ifdef MSDOS
#  define ECHO_ESC ESCAPE
#else
#  define ECHO_ESC '\\'
#endif

#ifdef OLD_C
stricmp(s, p)
register char	*s, *p;
{
	for(; to_lower(*s) == to_lower(*p); s++, p++) if(!*s) return(0);
	return(to_lower(*s) < to_lower(*p) ? -1 : 1);
}
#endif

main(ac, av)
int	ac;
char	**av;
{
	union {
		char	*string;
#define SYSV_STYLE 2
#define BSD_STYLE 1
		int	flg;
	} style;
	bool	endcr = 1;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif

	style . string = getenv("ECHO_STYLE");
	if(style . string == NULL || !stricmp(style . string, "sysv")){
		style . flg = SYSV_STYLE; /* for backward compatibility */
		 /* tcshł͖ݒ̏ꍇBSD */
	} else
	if(!stricmp(style . string, "both")){
		style . flg = SYSV_STYLE | BSD_STYLE;
	} else
	if(!stricmp(style . string, "none")){
		style . flg = 0;
	} else {
		style . flg = BSD_STYLE;
	}

	--ac, ++av;
	if((style . flg & BSD_STYLE) && ac && !strcmp(*av, "-n")){
		--ac, ++av;
		endcr = 0;
	}

	if(!ac) return 0; /* exit 0 */
	fsetbin(stdout);
	for(; ac--; ++av){
		if(style . flg & SYSV_STYLE){
			char	*p, c;
			int	i;

			for(p = *av; (c = *p) != '\0'; ++p){
				if(c == ECHO_ESC){
					switch(c = *++p){
					case 'c': goto nextarg;
					case 'n': c = '\n'; break;
					case 't': c = '\t'; break;
					case 'b': c = '\b'; break;
					case 'r': c = '\r'; break;
					case 'f': c = '\f'; break;
					case 'a': c = 0x7; break;
					case 'v': c = 0xb; break;
					case 'e': c = '\033'; break;
					case '\0': --p, c = ECHO_ESC; break;
					case '0':
						c = 0, i = 3;
						while(++p, i-- && is_octal(*p))
							c <<= 3, c |= *p - '0';
						--p; break;
					case 'x':
						c = 0, i = 2;
						while(++p, i--&& is_xdigit(*p))
							c <<= 4, c |=
							  to_lower(*p) -
							  (isdigit(*p) ? '0' :
							   'a' - 10);
						--p; break;
					case '^':
						if(!p[1]) break;
						c = *++p & 0x1f; break;
					/* case ECHO_ESC: break; */
					/* default: break; */
					}
				}
				putchar(c);
			}
		} else {
			fputs(*av, stdout);
		}

		if(ac){
			putchar(' ');
		} else if(!(style . flg & BSD_STYLE) || endcr){
#ifdef MSDOS
			putchar('\r');
#endif
			putchar('\n');
		}
	nextarg:
		;
	}

	return 0; /* exit 0 */
}
