#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "tools.h"
#ifdef ORIG
#  define LINMAX (1024*4)
#endif
/* -a123 -estr -j[12]m -o x.y x.y... -tc f1 f2	*/

/*
#define NOEXNOOUT
*/ /* Ƃœ쎎Č߂ */

#ifndef MSDOS
#  define iskanji(c) ((c) & 0x80)
#endif

char	*cmdname = "joinf";

static	char	*emptyfill = NULSTR, addwidow = 0; /* 0, 1, 2, 3 */
static	int	joinfield[2] = {0, 0}, outlistlen = 0;
static	char	fieldsep[2] = {'\0', '\0'};
typedef struct {
	char	fno; /* 0 or 1 */
	int	field;
} outfieldstr;
static	outfieldstr *outlist = NULL;

static	FILE	*inf[2];
static	char	*infnm[2];
#ifdef ORIG
static	char	linbuf[2][LINMAX];
#else
static	char	*linbuf[2] = {NULL, NULL};
#endif

static	void	usage()
{
	fputss(stderr, "Usage: ", cmdname, "\
 [-a n] [-e string] [-j[1|2] m]\n\
\t     [-o fieldlist] [-t c] file1 file2\n\
", NULL);
	exit(1);
}

static	void	put_maxn_c(n, s)
int	n;
char	*s;
{
	for(; n && *s; ++s, --n) putchar(*s);
}

static	void	outfreg(p)
char	*p;
{
	outlist = (outfieldstr *)chk_realloc(
		(char *)outlist, (outlistlen + 1) * sizeof(outfieldstr));

	outlist[outlistlen] . fno = *p - '1';
	if(*p != '1' && *p != '2' || *++p != '.' || !*++p) usage();
	if(0 > (outlist[outlistlen] . field = atoi(p) - 1)) usage();
	while(is_digit(*p)) p++;
	if(*p) usage();

	++outlistlen;
}

static	char	*readnthfile(nth)
int	nth;
{
	int	len;
	char	*buf;

#ifdef ORIG
	if(NULL != (buf = fgets(linbuf[nth], LINMAX, inf[nth]))){
#else
	if(NULL != (buf = linbuf[nth] = getline(linbuf[nth], inf[nth]))){
#endif
		if(!*buf){ /* nothing */
		} else
		if(len = strlen(buf), buf[--len] != '\n'){
#ifdef ORIG
			if(len == LINMAX - 2){
				fputss(stderr, cmdname, ": ", infnm[nth],
					": line too long\n", NULL);
				exit(1);
			}
#endif
			fputss(stderr, cmdname, ": ", infnm[nth], 
				": missing line-feed character added at the \
end of file\n", NULL);
		} else {
			buf[len] = '\0';
		}
	}
	return buf;
}

static	char	*fieldend(p)
char	*p;
 /* ptB[hȂ炻̖̒AȂƂ̂܂܂Ԃ */
{
	if(*fieldsep){
		for(; *p; iskanjipos(p) ? (p += 2) : p++){
			if(*fieldsep == *p &&
			   (!fieldsep[1] || fieldsep[1] == p[1])) break;
		}
	} else {
		while(*p && !is_space(*p)) p++;
	}
	return p;
}

static	char	*fieldtop(p)
char	*p;
 /* p^uȂ玟̃tB[h̐擪AȂƂ̂܂܂Ԃ */
{
	if(*fieldsep){
		if(*fieldsep == *p){
			if(fieldsep[1]){
				if(fieldsep[1] == p[1]) p += 2;
			} else p++;
		}
	} else {
		while(is_space(*p)) p++;
	}
	return p;
}

#define	fieldnext(p) fieldtop(fieldend(p))

static	char	*fieldnth(p, n)
char	*p;
int	n;
{
	if(!*fieldsep) p = fieldtop(p);
	while(n--) p = fieldnext(p);
	return p;
}

static	void	fieldeach(p)
char	*p;
{
	char	*q;

	p < (q = fieldend(p)) ? put_maxn_c(q - p, p) :
				(void)fputs(emptyfill, stdout);
}

static	void	fieldout(s1, s2, flag)
char	*s1, *s2;
int	flag; /* 1, 2, 3 */
{
	int	curf[2], i, outfirst, f_no, f_field;
	char	*ftop[2], *ltop[2], *p;

	curf[0] = curf[1] = 0;
	ltop[0] = ftop[0] = s1, ltop[1] = ftop[1] = s2;

	if(!outlistlen){ /* outlistlen0ȂSo */
		f_no = (flag & 01) ? 0 : 1;
		f_field = joinfield[f_no];
		fieldeach(fieldnth(ltop[f_no], f_field));
		for(f_no = 0; f_no < 2; f_no++){
			f_field = joinfield[f_no];
			for(i = 0, p = fieldnth(ltop[f_no], 0); *p;
			    ++i, p = fieldnext(p)){
				if(i != f_field){
					put_maxn_c(2,
						*fieldsep ? fieldsep : " ");
					fieldeach(p);
				}
			}
		}
	} else {
		for(outfirst = 1, i = 0; i < outlistlen; i++){
			f_no = outlist[i] . fno;
			f_field = outlist[i] . field;
#ifdef NOEXNOOUT
			if(!(flag & f_no)) continue;
#endif
			if(curf[f_no] > f_field){
				p = fieldnth(ltop[f_no], f_field);
			} else {
				p = fieldnth(ftop[f_no], f_field - curf[f_no]);
			}
			outfirst ? (void)(outfirst = 0) :
				   put_maxn_c(2, *fieldsep ? fieldsep : " ");
			fieldeach(ftop[f_no] = p),
			curf[f_no] = f_field;
		}
	}
	putchar('\n');
}

static	strpartcmp(p, m, q, n)
char	*p;
int	m;
char	*q;
int	n;
{
	int	result;

	if(0 != (result = strncmp(p, q, m < n ? m : n))) return result;
	return m - n;
}

static	strfieldcmp(fb, fe, p, n)
char	*fb, *fe, *p;
int	n;
{
	char	*pe;

	p = fieldnth(p, n), pe = fieldend(p);
	return strpartcmp(fb, fe - fb, p, pe - p);
}

static	void	do_join(av)
char	*av[];
{
	char	*f2b, *f2e, *f2line, *f1line;
	char	**f2bufs; /* f2bufs, f2bufcntstaticłȂĂ? */
	int	f2bufcnt = 0, f2bufused = 0;
	char	f2eof = 0, f2pushed = 0, f1eof = 0, f1pushed = 0, f1match;
	int	i;

	for(i = 0; i < 2; i++){
		conv_to_unix_format(av[i]);
		if(av[i][0] == '-' && !av[i][1]){
			inf[i] = stdin; infnm[i] = "(stdin)";
		} else if(NULL == (inf[i] = fopen(infnm[i] = av[i], "r"))){
			fputss(stderr, cmdname, ": ", infnm[i],
				": Can't open\n", NULL);
			exit(1);
		}
	}

	f2bufs = (char **)chk_malloc(sizeof(char *) * (f2bufcnt = 50));
		/* malloc size͓KɌ߂BƂł̑PʂK */
	for(;;){
		 /* Oɓǂ񂾍s̑|BOɓǂ񂾍sf2lineɂ */
		if(f2bufcnt > 200 &&
		   f2bufused < 100 && f2bufused * 3 < f2bufcnt){
			f2bufs = (char **)chk_realloc((char *)f2bufs,
					    sizeof(char *) * (f2bufcnt = 200));
			 /* f2bufusedȏ͊mۂ邱 */
		}
		while(f2bufused) free(f2bufs[--f2bufused]);
		 /* f2bufused0ɂȂ */

		while(!f2eof){
			if(f2pushed){
				f2pushed = 0;
			} else {
				f2line = readnthfile(1);
				if(NULL == f2line){f2eof++; break;}
			}

			if(!f2bufused){ /* vA̍ŝŏ */
				f2line = chk_strdup(f2line);
				 /* strdupȂf2b, f2e */
				f2bufs[f2bufused++] = f2line;
				f2b = fieldnth(f2line, joinfield[1]);
				f2e = fieldend(f2b);
			} else {
				if(strfieldcmp(f2b,f2e, f2line, joinfield[1])){
					f2pushed = 1;
					 /* ̍sf2line܂linbuf[1]
					    cĂ */
					break;
				} else { /* v */
					if(f2bufused >= f2bufcnt){
						f2bufs = (char **)chk_realloc(
						  (char *)f2bufs,
						  sizeof(char *) *
							(f2bufcnt += 20));
					}
					f2bufs[f2bufused++]=chk_strdup(f2line);
				}
			}
		}

		for(f1match = 0; ;){
		 /* ŏf1pushedf1eof0 */
			if(f1pushed){
				f1pushed = 0;
			} else if(!f1eof){
				f1line = readnthfile(0);
				if(f1line == NULL) f1eof++;
			}
			if(f1eof && !f2bufused) exit(0);
			i = !f2bufused ? /* ǂݐs */ 1 :
			    f1eof ? -1 :
			    strfieldcmp(f2b, f2e, f1line, joinfield[0]);

			if(i > 0){ /* f2Bf1o */
				if(addwidow & 01)
					fieldout(f1line, NULSTR, 1);
			} else
			if(i == 0){ /* BSf2bufsɑ΂gݍ킹o */
				f1match = 1;
				for(i = 0; i < f2bufused; i++)
					fieldout(f1line, f2bufs[i], 3);
			} else
			if(i < 0){ /* f1Bf2o */
				if(!f1match && (addwidow & 02)){
					for(i = 0; i < f2bufused; i++)
						fieldout(NULSTR, f2bufs[i], 2);
				}
				f1pushed = 1;
				 /* ݍsf1line܂linbuf[0]Ɏc */
				break;
			}
		}
	}
}

main(ac, av)
int	ac;
char	*av[];
{
	char	*p;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	while(++av, --ac){
		if('-' != *(p = *av) || !p[1]) break;
		if(*++p == '-') {++av, --ac; break;}
		switch(*p){
		case 'a':
			if(!*++p){
				if(++av, !--ac) usage(); else p = *av;
			}
			if(*p < '1' || '3' < *p || p[1]) usage();
			addwidow = *p - '0';
			break;
		case 'e':
			if(!*++p){
				if(++av, !--ac) usage(); else p = *av;
			}
			emptyfill = p;
			break;
		case 'j':
			if(*++p && (*p < '1' || '2' < *p || p[1])) usage();
			if(++av, !--ac) usage();
			{
				int	fi;

				if(0 > (fi = atoi(*av) - 1)) usage();
				switch(*p){
				case '1': joinfield[0] = fi; break;
				case '2': joinfield[1] = fi; break;
				default:
					joinfield[0]= joinfield[1]= fi; break;
				}
			}
			break;
		case 'o':
			if(*++p || ac == 1 || (++av, --ac, !is_digit(**av)))
				usage(); /* Œ1ȂƂ */
			for(; ac; ++av, --ac){
				if(p = *av, !is_digit(*p)) break;
				outfreg(p);
			}
			++ac, --av; /* 1߂ */
			break;
		case 't':
			if(!*++p){
				if(++av, !--ac) usage();
				p = *av;
				if(!*p) usage();
			}
			fieldsep[0] = *p;
			if(iskanji(*p)) fieldsep[1] = *++p;
			 else fieldsep[1] = '\0';
			if(p[1]) usage();
			break;
		default:
			usage();
		}
	}
	if(ac != 2) usage();
	do_join(av);
	return 0;
}
