#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#endif
#ifdef LSI_C
#  include <farstr.h>
#endif
#include <signal.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "setenv";

#define LONG_SIGNBIT (~0L ^ ((unsigned long)~0L >> 1))

#ifdef UX_COMPILE_TEST
#  define MK_FP(x, y) ((void *)(y))
#  define _osmajor 3
#  define _osminor 30
unsigned short	_psp = 0x1234;
union	REGS {
	union {
		char	ah, al;
	} h;
	union {
		short	ax, bx;
	} x;
};
struct	SREGS {
	short	es;
};
#endif

/* ԐڈLFNT|[gv̉\̂
   exparg_hook()̒`͂Ȃ */

static	envptnchk(eseg)
unsigned int	eseg; /* ̃ZOg̓eϐۂΔ0Ԃ */
{
	char	far	*p = MK_FP(eseg, 0);

	if(0x1000 <= *(unsigned int far *)MK_FP(eseg - 1, 3) || !*p) return 0;
	 /* 傫邩Aϐ1܂܂Ȃ */
	for(;;){
		if(!*p) return 1; /* ϐs */
		if(*p == '=') return 0; /* ŏɁu=v */
		while(*p && *p != '='){
			if(is_cntrl(*p)) return 0; /* ςȕ */
			++p;
		}
		if(!*p++) return 0; /* u=vȂ΃yP */
		while(*p++);
	}
}

unsigned int	getprocenvseg(psp)
unsigned int	psp;
 /* ̃vZX̊ϐGÃZOgTBȂُȂ0 */
{
	unsigned int	mcbseg, mblkseg, envseg;
	char	mblkcont;
	union	REGS	in, out;
	struct	SREGS	segreg;

	envseg = *(unsigned int far *)MK_FP(psp, 0x2c);
#ifdef DEBUG
	fprintf(stderr, "envseg %04x\n", envseg);
#endif
	if(envseg && (_osmajor != 3 || _osminor < 20) || psp < envseg)
		return envseg;

	 /* envseg0Av3.2 3.3̏ꍇAvZXcommand.comȂ
	    ۂ̊ϐ͕ʂȂƂɂ邩mȂBT */
#ifdef DEBUG
	fprintf(stderr, "searching real envseg\n");
#endif
	in . h . ah = 0x52;
	intdosx(&in, &out, &segreg);
	for(mcbseg = *(unsigned int far *)MK_FP(segreg.es, out.x.bx - 2),
	      mblkcont = 1;
	    mblkcont;
	    mcbseg += *(unsigned int far *)MK_FP(mcbseg, 3) + 1){
#ifdef DEBUG
		fprintf(stderr, "?%04x\n", mcbseg);
#endif
		switch(*(char far *)MK_FP(mcbseg, 0)){
		case 'Z':
			mblkcont = 0; /* through */
		case 'M':
			break;
		default:
			return 0; /* ُ */
		}
		if(psp != *(unsigned int far *)MK_FP(mcbseg, 1))
			continue; /* vZXL */
		mblkseg = mcbseg + 1;
		if(psp == mblkseg){ /* vO{ */
#ifdef DEBUG
			fprintf(stderr, "program body...\n");
#endif
			if(!envseg) return mcbseg +
				*(unsigned int far *)MK_FP(mcbseg, 3) + 2;
			 /* ̃ubNԂ */
			continue;
		}
		if(envseg == mblkseg) continue; /* ʑO̊GA */
		if(envptnchk(mblkseg)) return mblkseg; /* OK */
	}
	 /* ȏŌȂΑcommand.comł͂ȂAenvseg{ */
#ifdef DEBUG
	fprintf(stderr, "maybe not command.com\n");
#endif
	return envseg;
}

static	unsigned int	getpenvseg(level) /* evZX̊̃ZOg */
int	level;
{
	unsigned int	psp = _psp;

	for(; level; --level) psp = *(unsigned int far *)MK_FP(psp, 0x16);
	return getprocenvseg(psp);
}

static	unsigned int	getshenvseg()
  /* eHčsčŏɐeZOgƈvĂvZX
     ̃ZOg */
{
	unsigned int	psp = _psp, opsp;

	do {
		opsp = psp;
		psp = *(unsigned int far *)MK_FP(psp, 0x16);
	} while(psp != opsp);
	return getprocenvseg(psp);
}

static	unsigned int	getrenvseg() /* [g̊̃ZOg */
{
	return getprocenvseg(*(unsigned int far *)MK_FP(
		*(unsigned int far *)MK_FP(0, 0x2e*4+2), 0x16));
}

static	void	noenv_exit(env)
char	*env;
{
	fputss(stderr,
		cmdname, ": ", env, ": No such environment variable.\n", NULL);
	exit(1);
}

static	void	usage_exit()
{
	fputss(stderr, "Usage:  ",
		cmdname, " [-rsabl] [-e[num]] [-P num] env value\n",
		"\t", cmdname, " -u [-rsl] [-P num] env\n",
		"\t", cmdname, " -p [-rsl] [-P num] [env]\n", NULL);
	exit(1);
}

static	void	search_env(seg, envnm, envp, tailp, endp)
unsigned int	seg;
char	*envnm;
char	far	**envp;
char	far	**tailp;
char	far	**endp;
 /* ̃ZOgŎw肳ꂽO̊ϐ̃AhX(ȂNULL)*envp
    00h̎*tailp GAIAhX(2A00h̎)*endpɓ */
{
	char	far	*envptr = MK_FP(seg, 0);
	int	envnmlen = strlen(envnm);
	bool	flg;

	*envp = *tailp = NULL;
	while(*envptr){
		flg = 0;
		if(0 == far_strncmp(envptr, (char far *)envnm, envnmlen) &&
		   '=' == envptr[envnmlen])
			*envp = envptr, ++flg;
		while(*envptr++);
		if(flg) *tailp = envptr;
	}
	*endp = ++envptr;
}

static	void	unset_env(seg, envnm)
unsigned int	seg;
char	*envnm;
{
	char	far	*envptr;
	char	far	*envtail;
	char	far	*envend;

	search_env(seg, envnm, &envptr, &envtail, &envend);
	if(envptr == NULL) noenv_exit(envnm);
	signal(SIGINT, SIG_IGN);
	far_memmove(envptr, envtail, envend - envtail);
}

static	void	far_puts(s)
char	far	*s;
{
	for(; *s; ++s) putchar(*s);
	putchar('\n');
}

static	int	envnamecmp(p1, p2)
char	far *	*p1;
char	far *	*p2;
{
	char	far *e1, far *e2;
	unsigned char	c1, c2;

	for(e1 = *p1, e2 = *p2; *e1 == *e2 && *e1 && *e1 != '='; ++e1, ++e2);
	return (int)((c1 = *e1) == '=' ? '\0' : c1) -
	       (int)((c2 = *e2) == '=' ? '\0' : c2);
}

static	void	prn_env(seg, envnm)
unsigned int	seg;
char	*envnm;
 /* getenv()ł͎vZX̂̂Ȃ̂Łc */
{
	char	far	*envptr;
	char	far	*dummy;

	if(envnm == NULL){
		char	far *	*envs;
		int	count = 0, alloced, i;

		envs = chk_malloc(sizeof(char far *) * (alloced = 40));
		for(envptr = MK_FP(seg, 0); *envptr; ++envptr, ++count){
			if(count >= alloced) envs = chk_realloc(envs,
					sizeof(char far *) * (alloced += 20));
			envs[count] = envptr;
			for(; *envptr; ++envptr);
		}
		qsort(envs, count, sizeof(char far *), envnamecmp);
		for(i = 0; i < count; ++i) far_puts(envs[i]);
		free(envs);
	} else {
		search_env(seg, envnm, &envptr, &dummy, &dummy);
		if(envptr == NULL) noenv_exit(envnm);

		envptr += strlen(envnm);
		far_puts(++envptr);
	}
}

typedef enum {
	NOADD, ADDAFTER, ADDBEFORE,
} addtype;

static	void	set_env(seg, envnm, val, addmode)
unsigned int	seg;
char	*envnm, *val;
addtype	addmode;
{
	char	far	*envptr;
	char	far	*envtail;
	char	far	*envend;
	int	envnmlen = strlen(envnm), vallen = strlen(val);
	unsigned int	envsegsiz = *(unsigned int far *)MK_FP(seg - 1, 3);
	size_t	needed;

	search_env(seg, envnm, &envptr, &envtail, &envend);
	if(envptr == NULL) addmode = NOADD; /* ʏꍇaddmode͖Ӗ */

	 /* KvGAvZA蓖Ă͂ݏoȂ`FbN */
	needed = FP_OFF(envend);
	if(addmode != NOADD){ /* envptr͔NULL */
		needed += vallen;
	} else {
		if(envptr != NULL) needed -= envtail - envptr;
		needed += envnmlen + vallen + 2;
	}
	if(((needed + 15) >> 4) > envsegsiz){
		fputss(stderr,
			cmdname, ": Environment area exhausted.\n", NULL);
		exit(1);
	}

	signal(SIGINT, SIG_IGN);
	switch(addmode){
	case NOADD:
		if(envptr != NULL){
			far_memmove(envptr, envtail, envend - envtail);
			envend -= envtail - envptr;
		}
		far_strcpy(--envend, (char far *)envnm);
		far_strcpy(envend += envnmlen, (char far *)"=");
		far_strcpy(++envend, (char far *)val);
		(++envend)[vallen] = '\0';
		break;
	/* NOADDȊȌꍇenvptr͔NULL */
	case ADDAFTER:
		far_memmove(envtail + vallen, envtail, envend - envtail);
		far_strcpy(--envtail, (char far *)val);
		break;
	default: /* case ADDBEFORE: */
		envtail = envptr + envnmlen + 1;
		far_memmove(envtail + vallen, envtail, envend - envtail);
		far_strncpy(envtail, (char far *)val, vallen);
		break;
	}
}

 /* eval֘A */
static	void	synerr()
{
	fputss(stderr, cmdname, ": Expression syntax error.\n", NULL), exit(1);
}

static	int	isnumstring(s)
char	*s;
{
	if(*s == '+' || *s == '-') ++s;
	if(!*s) return 0;
	for(; is_digit(*s); ++s);
	return !*s || *s == '.';
}

static	long	lexp(x, y)
long	x, y;
{
	long	ans = 1;

	if(y < 0) return 0;
	while(y){
		if(y % 2) ans *= x;
		y /= 2, x *= x;
	}
	return ans;
}

static	long	evalexp3(avp) /*  | ( 0 ) */
char	***avp;
{
	static	long	evalexp0();
	long	ans;
	char	**av = *avp, *p;

	if((p = *av) == NULL) synerr();
	if(!strcmp(p, "(")){
		++av, ans = evalexp0(&av);
		if(strcmp(*av, ")")) synerr(); else ++av;
	} else
	if(isnumstring(p)){
		ans = atol(p), ++av;
	} else {
		synerr();
	}

	*avp = av;
	return ans;
}

static	long	evalexp2(avp) /* 3 | 3 ^ 2 */
char	***avp;
{
	long	ans, ans1;
	char	**av = *avp, *p;

	if(*av == NULL) synerr();
	ans = evalexp3(&av);
	if((p = *av) != NULL && !strcmp(p, "^")){
		++av, ans1 = evalexp2(&av);
		ans = lexp(ans, ans1);
	}

	*avp = av;
	return ans;
}

static	long	evalexp1(avp) /* 2 [*%/ 2 c] */
char	***avp;
{
	long	ans, ans1;
	char	**av = *avp, *p;

	if(*av == NULL) synerr();
	ans = evalexp2(&av);
	while((p = *av) != NULL && NULL != strchr("*/%", *p) && !p[1]){
		++av, ans1 = evalexp2(&av);
		if(*p == '*'){
			ans *= ans1;
		} else {
			if(!ans1){
				fputss(stderr,
					cmdname, ": Division by 0.\n", NULL);
				exit(1);
			}
			(*p == '/') ? (ans /= ans1) : (ans %= ans1);
		}
	}

	*avp = av;
	return ans;
}

static	long	evalexp0(avp) /* 1 [+- 1 c] */
char	***avp;
{
	long	ans, ans1;
	char	**av = *avp, *p;

	if(*av == NULL) synerr();
	ans = evalexp1(&av);
	while((p = *av) != NULL && NULL != strchr("+-", *p) && !p[1]){
		++av, ans1 = evalexp1(&av);
		switch(*p){
		case '+':
			ans += ans1; break;
		default:
			ans -= ans1; break;
		}
	}

	*avp = av;
	return ans;
}

static	char	*evalarg(av, digits)
char	**av;
int	digits;
{
	unsigned long	uans;
	int	alc_amount, anssgn = 0;
	char	*retbuf, *p;

	uans = (unsigned long)evalexp0(&av);
	if(*av != NULL) synerr();
	if(uans & LONG_SIGNBIT) /* (signed long)uans<0 ͏nˑ炵 */
		++anssgn, --digits, uans = -uans;

	alc_amount = (digits > 11 ? digits : 11) + 1; /* 32bit longO */
	retbuf = chk_malloc(alc_amount), p = retbuf + alc_amount, *--p = '\0';
	do {
		*--p = (char)((uans % 10) + '0'), uans /= 10, --digits;
	} while(uans);
	for(; digits > 0; --digits) *--p = '0';
	if(anssgn) *--p = '-';

	return p;
}

main(ac, av)
int	ac;
char	**av;
{
	int	c, parent_level = 1, plus_level = 0;
	char	unset = 0, lower = 0, prnenv = 0;
	addtype	addmode = NOADD;
	unsigned int	envseg;
	int	evaldigits = -1;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
	 /* ChJ[h̓T|[gAԐڈT|[g */
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(!strcmp("unsetenv", cmdname)) unset = 1;

	opterr = 0;
	while(EOF != (c = egetopt(ac, av, "uabrslpe;d:P:"))){
		cswitch(c){
		case 'u':
			unset = 1; break;
		case 'p':
			prnenv = 1; break;
		case 'l':
			lower ^= 1; break;
		case 'a':
			addmode = ADDAFTER; break;
		case 'b':
			addmode = ADDBEFORE; break;
		case 'r':
			parent_level = -2; break;
		case 's':
			parent_level = -1; break;
		case 'P':
			if(*optarg == '+'){
				plus_level += atoi(++optarg);
			} else {
				parent_level = atoi(optarg);
			}
			break;
		case 'd': /* for backward compatibility */
		case 'e':
			evaldigits = (optarg == NULL? 0 : atoi(optarg)); break;
		default:
			usage_exit();
		}
	}
	av += optind, ac -= optind;
	if(prnenv){
		if(ac > 1) usage_exit();
	} else
	if(unset){
		if(ac != 1) usage_exit();
	} else {
		if(evaldigits >= 0){
			if(ac < 2) usage_exit();
			 /* tools̈WJ[`Ă΂ĂǍ
			    av[ac]NULLɂȂĂ邱ƂOƂ */
			av[1] = evalarg(av + 1, evaldigits); /* xȂ͂ */
			av[ac = 2] = NULL; /* ܂Ô */
		} else {
			if(ac != 2) usage_exit();
		}
	}

	switch(parent_level){
	case -2:
		envseg = getrenvseg(); break;
	case -1:
		envseg = getshenvseg(); break;
	default:
		parent_level += plus_level;
		if(prnenv && parent_level == 1) --parent_level;
		envseg = (!parent_level ?
			*(unsigned int far *)MK_FP(_psp, 0x2c) :
			getpenvseg(parent_level));
		break;
	}
	if(!envseg){
		fputss(stderr,
			cmdname, ": Can't find environment area.\n", NULL);
		exit(1);
	}

	if(ac){
		char	*p;

		for(p = av[0]; *p; ++p){ /* vȂ */
			if(*p == '=' || iskanjipos(p) && *++p == '='){
				fputss(stderr, cmdname, ": ", av[0],
					": Illegal environment name.\n", NULL);
				exit(1);
			} else
			if(!lower && is_lower(*p)) *p = toupper(*p);
		}
	}
	if(prnenv){
		prn_env(envseg, ac ? av[0] : NULL);
	} else
	if(unset){
		unset_env(envseg, av[0]);
		 /* SIGINT[us */
	} else {
		set_env(envseg, av[0], av[1], addmode);
		 /* SIGINT[us */
	}
	return 0;
}
