#include <stdio.h>
#include <fcntl.h>
#include <process.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "tman";

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = -1;
	expand_hook_default();
}
#endif

static	open_man_to_stdin(name, nametail, secno)
char	*name, *nametail;
int	secno;
 /* name "doc" Ȃǂtɏ\ȃGAƂ
    mant@C(stdin)open̂ɐ1Ԃ */
{
	int	secno_max = 9;

	if(secno < 0){
		strcpy(nametail, "doc");
		if(0 <= open(name, O_RDONLY)) return 1;
		strcpy(nametail, "man");
		if(0 <= open(name, O_RDONLY)) return 1;
#define LEN_PLUS (1 + 1 + 3 + 1)
  /* "/", ".", ̊֐ŕtꂤ钷̍ő, '\0' */

		secno = 1;
	} else {
		secno_max = secno;
	}

	nametail[1] = '\0';
	for(; secno <= secno_max; secno++){
		*nametail = secno + '0';
		if(0 <= open(name, O_RDONLY)) return 1;
	}

	return 0;
}

static	void	man(cmdnm, secno)
char	*cmdnm;
int	secno;
{
	char	*p, *buf = NULL, *buftail, *manpath, *pager;
	int	buflen = 0, onepathlen, cmdnmlen;

	if(NULL == (pager = getenv("PAGER"))) pager = "more";
	if(NULL == (manpath = getenv("MANPATH")) &&
	   NULL == (manpath = getenv("MAN"))){
		_cmdputerrmes_cr("MANPATH not set");
		exit(-1);
	}

	fclose(stdin);
	cmdnmlen = strlen(cmdnm);
	for(;;){
		onepathlen = (NULL != (p = strchr(manpath, ENVPATH_SEP)) ?
					p++ - manpath : strlen(manpath));
		if(buflen < onepathlen + cmdnmlen + LEN_PLUS){
			buflen = onepathlen + cmdnmlen + LEN_PLUS + /*]T*/32;
			buf = chk_realloc(buf, buflen);
		}

		((char *)memcpy(buf, manpath, onepathlen))[onepathlen] = '\0';
		*(buftail = last_pathsep(buf, NULL)) = PATH_SEP1;
		strcpy(++buftail, cmdnm), *(buftail += cmdnmlen) = '.';
		if(open_man_to_stdin(buf, ++buftail, secno)) break;

		if(NULL == (manpath = p)){
			if(secno < 0){
				_puterrmes("No manual entry for ");
				_puterrmes_cr(cmdnm);
			} else {
				static char msg[] =
					" in section 0 of the manual";
				msg[12] += secno;

				_puterrmes("No entry for ");
				_puterrmes(cmdnm), _puterrmes_cr(msg);
			}
			exit(-1);
		}
	}
	free(buf);
	
	if(isatty(1)){
		execlp(pager, pager, NULL); /* execAĂȂ */
		 /* ÂDOSmorestdinǂ܂Ȃc */
		_cmdputerrmes("Can't exec "), _puterrmes_cr(pager), exit(-1);
	} else {
	 /* stdoutttyłȂꍇ͂̂܂܏o */
		char	iobuf[BUFSIZ];
		int	rdsize;

		while((rdsize = read(0, iobuf, BUFSIZ)) > 0){
			if(write(1, iobuf, rdsize) < 0){
				_cmdputerrmes_cr("Write failed"), exit(-1);
			}
		}
	}
}

main(ac, av)
int	ac;
char	**av;
{
	int	secno = -1;
	char	*cmdnm;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	switch(++av, --ac){
	case 2:
		secno = **av - '0';
		if(secno < 1 || 9 < secno || av[0][1]) goto usage;
		++av; /* FALLTHROUGH */
	case 1:
		cmdnm = av[0];
		break;
	default:
	usage:
		_puterrmes("Usage: "), _puterrmes(cmdname);
		_puterrmes_cr(" [secno] COMMANDNAME"), exit(-1);
	}
	man(cmdnm, secno);

	 /* stdoutttyłȂꍇ͂֋AĂ邱Ƃ */
	return 0;
}
